/*-------------------------------------------------------------------------------*/
  /*
    AdfChipBase.h
    Class AdfChipBase
    16-April-98
  */
#ifndef __AdfChipBase__
#define __AdfChipBase__
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/AdfRegBase.h"

class CAdfCardBase ;   // forward declaration 

class CResultFile  ;   // forward declaration 

/*-------------------------------------------------------------------------------*/

class CAdfChipBase
{
/////////////////////////////
// Constructor/Destructor
public:

	         CAdfChipBase();

             CAdfChipBase( CAdfCardBase*      _poMotherCard,
                           unsigned char   _ubChipAddress );

            ~CAdfChipBase();

            void RemoveFromChain() ; // Fix up linked chain to skip this register (to do before deleting it)

/////////////////////////////
// Attributes
public:

protected:

    CAdfCardBase*      m_poMotherCard ;
    CAdfChipBase*      m_poNextFpga ;
    CAdfChipBase*      m_poPrevFpga ;

    CAdfRegBase*       m_poFirstReg ; // starting point down chain of links through all Registers
    CAdfRegBase*       m_poLastReg ; 

    TulVmeAddress   m_ulVmeAddress ;

    unsigned char   m_ubChipAddress ;

    unsigned short  m_uwTotRegister ;

/////////////////////////////
// Operations
public:

    TCString        f_osBaseAddress     ( ) ; // e.g. return "Master#0/Slave#1/Slot# 2/Chip# 0"
    TCString        f_osVmeAddress      ( ) ; // e.g. return "VmeAddr 0x01020000"

    CAdfChipBase*      f_poNextFpga        ( ) { return m_poNextFpga  ; } ;
    CAdfChipBase*      f_poPrevFpga        ( ) { return m_poPrevFpga  ; } ;

    unsigned char   f_ubChipAddress     ( ) { return m_ubChipAddress ; } ;
    TulVmeAddress   f_ulVmeAddress      ( ) { return m_ulVmeAddress; } ;

    CAdfRegBase*       f_poFindRegister    ( unsigned short     _uwRegAddress ) ; 

    void            Dump                ( bool               _lIncludeReadOnly = true,
                                          CResultFile*       _poResultFile = NULL ) ;

protected:


///////////////////////////////////////////
// Access Privileges outside of this class

// special access privilege so that the base register constructor 
// can read the fpga address, etc 
// and write the LastReg variable, etc
friend class CAdfRegBase ;

// special access privilege so that the Dac Control Object
// can access the mother Card pointer
friend class CAdfDacCtrl ;
};

/////////////////////////////////////////
// Macro to cleanly remove an FPGA
/////////////////////////////////////////
#define DELETE_FPGA( FPGA_POINTER )     \
    FPGA_POINTER->RemoveFromChain () ;  \
    delete FPGA_POINTER ;               \
    FPGA_POINTER = NULL ;               \
/////////////////////////////////////////


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
#endif // __AdfChipBase__
