/*-------------------------------------------------------------------------------*/
  /*
    AdfVmeAddress.h
    11-Nov-04  
  */
/*-------------------------------------------------------------------------------*/

// This data type is used with indirect addressing off of a pointer of type short integer.  
// The address offset that will be generated is the index value times x2 (the size in bytes of the short int type).
// There are thus only 9 bits of Register Address in the index.  
// The VME Address offset that will be generated will be multiplied by 2 (shifted one bit to the left), 
// or, in other words, will create the desired 10 bit register address field of the byte address.
union VME_Reg_Address
{
	unsigned long ulAddress ;
	struct VME_Address_fields
	{   unsigned int uiMustBe0 : 1 ; // Force Even Address for D16 word aligned access
        unsigned int uiReg     :16 ; // register address within FPGA
		unsigned int uiChip    : 1 ; // chip address 0 for PAL, 0 for FPGA#0, 1 for FPGA#1
		unsigned int uiCard    : 5 ; // card address (= slot number 1-21)
		unsigned int uiSkip    : 1 ; // spare, must be zero (1 bit for MSB of A24 and 3 bits LSB of upper byte)
		unsigned int uiSlave   : 2 ; // Vertical Slave Number
		unsigned int uiMaster  : 2 ; // Vertical Master Number
		unsigned int uiMustBe1 : 1 ; // Fixed Address Bit Set on all Vertical Interconnects /*** will change? ***/
		unsigned int uiZero    : 3 ; // spare, must be zero (1 bit for MSB of A24 and 3 bits LSB of upper byte)
	} Field ;
} ;

/*-------------------------------------------------------------------------------*/

