/*-------------------------------------------------------------------------------*/
  /*
    CommandFileVmeIO.h
    3-Sep-99 split off from dialog box
  */
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/HandleBit3Adaptor61x.h"


struct Custom_Structure_VmeIO
{
    unsigned int        uiTotReg ;
    unsigned int        uiAdaptor_Num ;
    CBit3Adaptor61x*    poBit3Adaptor ;
	unsigned int        uiNumBytes ;
    CString             osAddressSpace ;
    CString             osTransferSize ;
    CString             osAccessMethod  ;
    EYesNo              eSwapping ;
    EVmeAmodAddrSpace   eAddrSpace ;
} ;

ESuccess CommandFileVmeIO         ( CString	                        _osCommand_File_Name,
                                    Custom_Structure_VmeIO*         _pxCustom,
                                    void*                           _pDlgThis = NULL ) ;

// declare the action routines
fKeyword_Action     VmeIO_Action_File_Opened ;
fKeyword_Action     VmeIO_Action_Bit3_Adaptor ;
fKeyword_Action     VmeIO_Action_Address_Space ;
fKeyword_Action     VmeIO_Action_Data_Size ;
fKeyword_Action     VmeIO_Action_Parse_Read_VME ;
fKeyword_Action     VmeIO_Action_Parse_Write_Value ;
fKeyword_Action     VmeIO_Action_Parse_Write_Verify ;
fKeyword_Action     VmeIO_Action_Done_With_File ;

//This function is not automatically called after the occurence of a Keyword, 
// but is explicitely invoked in all the VME Access actions above.
fKeyword_Action     VmeIO_Check_Ready_For_Access ;


// Cosmetic constants to decode Keyword Values for Access_Space
#define     KiCodeA32   32
#define     KiCodeA24   24
#define     KiCodeA16   16
#define     KiCodeDpm    0

// Cosmetic constants to decode Keyword Values for Data_Size
#define     KiCodeD32   32
#define     KiCodeD16   16
#define     KiCodeD8     8


// Cosmetic constants to encode Custom_Structure_VmeIO.osAccessMethod above
#define     KsAPI       "API"
#define     KsMMAP      "MMAP"
