
/**** why not merge this file into UtilsBits.h ****/

/*-------------------------------------------------------------------------------*/
  /*
    DataManip.h
  */
#ifndef __DataManip__
#define __DataManip__
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

// This is a general purpose structure for dual access 
// of char (8-bit byte) by byte or bit
union MultiAccessByte
{
	unsigned char ubByte ;

	struct ShortByBit
	{
		unsigned int bBit_0  : 1 ;
		unsigned int bBit_1  : 1 ;
		unsigned int bBit_2  : 1 ;
		unsigned int bBit_3  : 1 ;
		unsigned int bBit_4  : 1 ; 
		unsigned int bBit_5  : 1 ;
		unsigned int bBit_6  : 1 ;
		unsigned int bBit_7  : 1 ;
	} ByBit ;
} ;

// This is a general purpose structure for dual access 
// of short (16-bit word) by byte or whole word
union MultiAccessShort
{
	unsigned short uwWord ;

    struct ShortByByte
	{
		unsigned char ubByte_0 ;
		unsigned char ubByte_1 ;
	} ByByte ;

	struct ShortByBit
	{
		unsigned int bBit_0  : 1 ;
		unsigned int bBit_1  : 1 ;
		unsigned int bBit_2  : 1 ;
		unsigned int bBit_3  : 1 ;
		unsigned int bBit_4  : 1 ; 
		unsigned int bBit_5  : 1 ;
		unsigned int bBit_6  : 1 ;
		unsigned int bBit_7  : 1 ;
		unsigned int bBit_8  : 1 ;
		unsigned int bBit_9  : 1 ;
		unsigned int bBit_10 : 1 ;
		unsigned int bBit_11 : 1 ;
		unsigned int bBit_12 : 1 ;
		unsigned int bBit_13 : 1 ;
		unsigned int bBit_14 : 1 ;
		unsigned int bBit_15 : 1 ;
	} ByBit ;
} ;

// This is a general purpose structure for alternate access 
// of int (32-bit word) by bit, byte, word or whole longword
union MultiAccessLong
{
	unsigned long   ulLong ;
	unsigned short  uwWord[2] ;
	unsigned char   ubByte[4] ;

	struct LongByWord
	{
		unsigned short uwWord_0 ;
		unsigned short uwWord_1 ;
	} ByWord ;

	struct LongByByte
	{
		unsigned char ubByte_0 ;
		unsigned char ubByte_1 ;
		unsigned char ubByte_2 ;
		unsigned char ubByte_3 ;
	} ByByte ;

	struct LongByBit
	{
		unsigned int bBit_0  : 1 ;
		unsigned int bBit_1  : 1 ;
		unsigned int bBit_2  : 1 ;
		unsigned int bBit_3  : 1 ;
		unsigned int bBit_4  : 1 ;
		unsigned int bBit_5  : 1 ;
		unsigned int bBit_6  : 1 ;
		unsigned int bBit_7  : 1 ;
		unsigned int bBit_8  : 1 ;
		unsigned int bBit_9  : 1 ;
		unsigned int bBit_10 : 1 ;
		unsigned int bBit_11 : 1 ;
		unsigned int bBit_12 : 1 ;
		unsigned int bBit_13 : 1 ;
		unsigned int bBit_14 : 1 ;
		unsigned int bBit_15 : 1 ;
		unsigned int bBit_16 : 1 ;
		unsigned int bBit_17 : 1 ;
		unsigned int bBit_18 : 1 ;
		unsigned int bBit_19 : 1 ;
		unsigned int bBit_20 : 1 ;
		unsigned int bBit_21 : 1 ;
		unsigned int bBit_22 : 1 ;
		unsigned int bBit_23 : 1 ;
		unsigned int bBit_24 : 1 ;
		unsigned int bBit_25 : 1 ;
		unsigned int bBit_26 : 1 ;
		unsigned int bBit_27 : 1 ;
		unsigned int bBit_28 : 1 ;
		unsigned int bBit_29 : 1 ;
		unsigned int bBit_30 : 1 ;
		unsigned int bBit_31 : 1 ;
	} ByBit ;
} ;

// This is a general purpose structure for alternate access 
// of int64 (64-bit word) by bit, byte, word or whole longword

union MultiAccessQuad
{
	uint64           uqQuad ;
	unsigned long    ulLong[2] ;
	unsigned short   uwWord[4] ;
	unsigned char    ubByte[8] ;
	
    struct DoubleByLong
    {
		unsigned long ulLong_0 ;
		unsigned long ulLong_1 ;
    } ByLong ;

    struct DoubleByWord
	{
		unsigned short uwWord_0 ;
		unsigned short uwWord_1 ;
		unsigned short uwWord_2 ;
		unsigned short uwWord_3 ;
	} ByWord ;
	
    struct DoubleByByte
	{
		unsigned char ubByte_0 ;
		unsigned char ubByte_1 ;
		unsigned char ubByte_2 ;
		unsigned char ubByte_3 ;
		unsigned char ubByte_4 ;
		unsigned char ubByte_5 ;
		unsigned char ubByte_6 ;
		unsigned char ubByte_7 ;
	} ByByte ;
	
    struct DoubleByBit
	{
		unsigned int bBit_0  : 1 ;
		unsigned int bBit_1  : 1 ;
		unsigned int bBit_2  : 1 ;
		unsigned int bBit_3  : 1 ;
		unsigned int bBit_4  : 1 ;
		unsigned int bBit_5  : 1 ;
		unsigned int bBit_6  : 1 ;
		unsigned int bBit_7  : 1 ;
		unsigned int bBit_8  : 1 ;
		unsigned int bBit_9  : 1 ;
		unsigned int bBit_10 : 1 ;
		unsigned int bBit_11 : 1 ;
		unsigned int bBit_12 : 1 ;
		unsigned int bBit_13 : 1 ;
		unsigned int bBit_14 : 1 ;
		unsigned int bBit_15 : 1 ;
		unsigned int bBit_16 : 1 ;
		unsigned int bBit_17 : 1 ;
		unsigned int bBit_18 : 1 ;
		unsigned int bBit_19 : 1 ;
		unsigned int bBit_20 : 1 ;
		unsigned int bBit_21 : 1 ;
		unsigned int bBit_22 : 1 ;
		unsigned int bBit_23 : 1 ;
		unsigned int bBit_24 : 1 ;
		unsigned int bBit_25 : 1 ;
		unsigned int bBit_26 : 1 ;
		unsigned int bBit_27 : 1 ;
		unsigned int bBit_28 : 1 ;
		unsigned int bBit_29 : 1 ;
		unsigned int bBit_30 : 1 ;
		unsigned int bBit_31 : 1 ;
		unsigned int bBit_32 : 1 ;
		unsigned int bBit_33 : 1 ;
		unsigned int bBit_34 : 1 ;
		unsigned int bBit_35 : 1 ;
		unsigned int bBit_36 : 1 ;
		unsigned int bBit_37 : 1 ;
		unsigned int bBit_38 : 1 ;
		unsigned int bBit_39 : 1 ;
		unsigned int bBit_40 : 1 ;
		unsigned int bBit_41 : 1 ;
		unsigned int bBit_42 : 1 ;
		unsigned int bBit_43 : 1 ;
		unsigned int bBit_44 : 1 ;
		unsigned int bBit_45 : 1 ;
		unsigned int bBit_46 : 1 ;
		unsigned int bBit_47 : 1 ;
		unsigned int bBit_48 : 1 ;
		unsigned int bBit_49 : 1 ;
		unsigned int bBit_50 : 1 ;
		unsigned int bBit_51 : 1 ;
		unsigned int bBit_52 : 1 ;
		unsigned int bBit_53 : 1 ;
		unsigned int bBit_54 : 1 ;
		unsigned int bBit_55 : 1 ;
		unsigned int bBit_56 : 1 ;
		unsigned int bBit_57 : 1 ;
		unsigned int bBit_58 : 1 ;
		unsigned int bBit_59 : 1 ;
		unsigned int bBit_60 : 1 ;
		unsigned int bBit_61 : 1 ;
		unsigned int bBit_62 : 1 ;
		unsigned int bBit_63 : 1 ;
	} ByBit ;
} ;

// This is a special purpose structure for access to the 6-bit subfields 
// of CAT2 and CAT3 operand and comparator registers 
// and also FMLN address generator
union MultiAccessBy6Bit
{
	unsigned long ulLong ;

	struct LongBy6Bit
	{
		unsigned bBit_0_5   : 6 ;
		unsigned bBit_6_11  : 6 ;
		unsigned bBit_12_17 : 6 ;
		unsigned bBit_18_23 : 6 ;
		unsigned bBit_24_29 : 6 ;
		unsigned bBit_30_31 : 2 ;
	} By6Bit ;

} ;

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
#endif // __DataManip__
