/*-------------------------------------------------------------------------------*/
  /*
    GlobalConstants.h
    19-Nov-98  pre-processor compiled constants
  */
/*-------------------------------------------------------------------------------*/
#if defined (__GLOBAL_CONSTANTS__) // prevent double definition 
#else
    #define  __GLOBAL_CONSTANTS__
/*-------------------------------------------------------------------------------*/

    // The size of one trigger ADF-2 Card (maximum) address space is 256 kByte 
    // (and the Bit3 Model 617 allocation segment size is 4k)
    #define     KiAdf2CardAddressSize        0x00040000


    //Generic Adf-2 Card-related constants
    #define     KiTotEtaPerAdf                      4
    #define     KiTotPhiPerAdf                      4

    #define     KiTotFpgaPerAdf                     2
    #define     KiTotEtaPerAdfFpga                  2
    #define     KiTotPhiPerAdfFpga                  4

    #define     KiTotTrigTowerPerAdfFpga            8
    #define     KiTotTrigTowerPerAdfCard           16

    //Generic Tab Card-related constants
    #define     KiTotEtaPerTab                     40
    #define     KiTotPhiPerTab                      4

    #define     KiTotMaFpgaPerTab                  10
    #define     KiTotEtaPerTabMaFpga                4
    #define     KiTotPhiPerTabMaFpga                4

    #define     KiTotTrigTowerPerTabMaFpga          8
    #define     KiTotTrigTowerPerTabCard          160

    //Generic Gab Card-related constants
    #define     KiTotFpgaPerGab                     1

    //card address space 
    #define     KiL1CalTotVertMaster                1
    #define     KiL1CalTotVertSlave                 4
    #define     KiL1CalTotSlot                     22 
/*
    //Maestro ADF Slot and Crate Number
    #define     KiMaestroRequestMonit_Crate         1
    #define     KiMaestroRequestMonit_Slot         11
    #define     KiMaestroRequestMonit_Signal        0

    #define     KiMaestroImmediateMonit_Crate       0
    #define     KiMaestroImmediateMonit_Slot       11
    #define     KiMaestroImmediateMonit_Signal      0
*/
    //Maestro ADF Slot and Crate Number
    #define     KiMaestroRequestMonit_Crate         0
    #define     KiMaestroRequestMonit_Slot         11
    #define     KiMaestroRequestMonit_Signal        0

    #define     KiMaestroImmediateMonit_Crate       0
    #define     KiMaestroImmediateMonit_Slot       11
    #define     KiMaestroImmediateMonit_Signal      1

    // Number of Ticks in a Turn 
    #define     KiTotTicksInTurn                  159

    #define     KiShiftOneNibble                    4  // used to shift a quantity by one nibble (1/2 byte)
    #define     KiShiftOneByte                      8  // used to shift a quantity by one byte
    #define     KiShiftTwoByte                     16  // used to shift a quantity by two bytes
    #define     KiShiftThreeByte                   24  // used to shift a quantity by three bytes

    #define     Ki10BitRange                     1024 

    // cosmetic null string for code readibility
    #define     KsNullString                       ""

    #define     KiSleepOneSecond                 1000 // 1000 milliseconds for sleep function
    #define     KiSleepOneTenthSecond             100 // 100 milliseconds for sleep function
    #define     KiSleepOneHundredthSecond          10 // 10 milliseconds for sleep function

/*-------------------------------------------------------------------------------*/
// L1 Calorimeter Trigger Constants

    // Vertical Interconnect Master
    #define     KiL1CalVerticalMaster               0

    // Trigger Tower Coverage
#if defined VME_IO_NO_VERTICAL  // test stand run without the vertical interconnect, has to stay within Slave #0
    #define     KiL1CalTotSignEta                   1   //if set to 1, means only Pos Eta.
    #define     KiL1CalTotMagnEta                   4   //must be a multiple of 4
    #define     KiL1CalTotPhi                       4
#else
    #define     KiL1CalTotSignEta                   2   //if set to 1, means only Pos Eta.
    #define     KiL1CalTotMagnEta                  20   //must be a multiple of 4
    #define     KiL1CalTotPhi                      32
#endif

    #define     KfL1CalEtScale                   0.25
//    #define     KfL1CalMPtScale                  0.50

    #define     KiRawAdcZer                        50   //Zero Energy Response for EM and HD Raw ADC E

    #define     KiOutputEtZer                       8   //Zero Energy Response for EM and HD  Output Et

    //used to tighten parsing checks
    #define     KiMaxLookupZeroEngAdcE           1023    //max E->Et Lookup Zero Energy Response Input (typ= 50)
    #define     KiMaxLookupZeroEngOutEt           255    //max E->Et Lookup Zero Energy Response Output (typ= 8)
    #define     KfMaxLookupSlope                    1.0  //max E->Et Lookup Slope 

    #define     KiTotSamplesPerTick                 4

    #define     KiCrateIdL1Cal2b                 0x10   // Crate ID for L1Cal IIb
    #define     KiBaseL2Type                     0xc0   // L2 Data Type Base (need to add module number)

    #define     KiTotTabGabModule                   8    
    #define     KiModuleNumGab                      8    
    #define     KiMaxDeSkewTries                    5   // Maximum attempts at deskewing the Channel Links
    #define     KiChLinkPerTabFpga                  3   // How many Channel Link inputs are monitored by each TAB Fpga

    const double    kfPi = 3.1415926535 ;
      
/*-------------------------------------------------------------------------------*/
#endif //__GLOBAL_CONSTANTS__

