/*-------------------------------------------------------------------------------*/
  /*
     GuiCommand.h
     02-Nov-2004
  */
#ifndef __GuiCommand__
#define __GuiCommand__
/*-------------------------------------------------------------------------------*/

//Global Constants used various places
#include "L1Cal_IIb_TCC/GlobalConstants.h"

//Custom Data Type Definitions
#include "L1Cal_IIb_TCC/CustomDataTypes.h"

//Hardcoded XML tags found in Gui commands
#include "L1Cal_IIb_TCC/GuiCommandKeywords.h"

#include <xercesc/parsers/XercesDOMParser.hpp>
#include <xercesc/sax/HandlerBase.hpp>

XERCES_CPP_NAMESPACE_USE

/*-------------------------------------------------------------------------------*/

//maximum length of Msg payloads back to Coor
#define     KiMaxLengthReplyTextToGui          400 // does not include Id & status; just optional reply text
                                                   // still not big enough to hold 256 andor terms * 4-5 char and rest of text
                                                   // must be small enough so that KiMaxLengthFullGuiReply is less than KiMaxLengthStringOut used in Itc server 


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*
class CGuiCommand
{
/////////////////////////////
// Constructor/Destructor

public:

    CGuiCommand () ;
   ~CGuiCommand () ;

/////////////////////////////
// Member Variables

public:

    unsigned int        m_uiGuiCmdCode ;

private:
    
/////////////////////////////
// Member Functions

public: 

private:
    
    void    ResetCommand ( ) ;

} ;

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
class CGuiCommandLine
{
/////////////////////////////
// Constructor/Destructor

public:

    CGuiCommandLine () ;
   ~CGuiCommandLine () ;

/////////////////////////////
// Member Variables

public:

//    CGuiCommand*        m_poGuiCommand ;

    XercesDOMParser*    m_pDOMparser ;
    ErrorHandler*       m_pDOMerrHandler ;
    DOMDocument*        m_pXMLdocument ;
    DOMElement*         m_pXMLcommand_node_element ;
    XMLCh*              m_pXMLcommand_name ;

private:

    const char*         m_psRawCommand ;
    const char*         m_pcCurrentCommandCharNum ;
    const char*         m_pcCurrentTokenCharNum   ;

    char*               m_psReplyText ;
    unsigned int        m_uiCurrentReplyLength ;
    unsigned int        m_uiMaxReplyLength ;

/////////////////////////////
// Member Functions

public: 

    void    NewRawCommand   ( const char*     _psGuiCommand,
                              char*           _psReplyText,
                              unsigned int    _uiMaxReplyLength ) ;

    char*   GetNextToken    ( char*           _psToken ) ;    

    void    CopyReplyText   ( const char*     _psPreplyText ) ;

    void    AppendReplyText ( const char*     _psPreplyText ) ;

    const char*  GetAtChar  ( unsigned int     _uiCharNum ) { 
                                    return &m_psRawCommand[_uiCharNum] ; };    

private:
    
    void    ResetCommandLine ( ) ;

    void    ClearReplyText ( ) ;


friend class    CGuiCommandParser ;

} ;

/*-------------------------------------------------------------------------------*/
#endif // __GuiCommand__
