/*-------------------------------------------------------------------------------*/
  /*
     GuiCommandPrinter.h
     02-Nov-2004
  */
#ifndef __GuiCommandPrinter__
#define __GuiCommandPrinter__
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/GuiCommand.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
class CGuiCommandPrinter 
{

/////////////////////////////
// Constructor/Destructor

public:

    CGuiCommandPrinter () { } ;
   ~CGuiCommandPrinter () { } ;

/////////////////////////////
// Member Variables

public:

private: 

/////////////////////////////
// Member Functions

public: 

    EGuiCommandStatus  Vio_ReadReg               ( unsigned int        _uiVmeAddress,
                                                   unsigned long       _ulRepeatCnt,
                                                   char*               _psAddressSpace,
                                                   char*               _psDataSize,
                                                   char*               _psAccessPriv,
                                                   char*               _psAccessType,
                                                   char*               _psBit3Access,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Vio_WriteReg              ( unsigned int        _uiVmeAddress,
                                                   unsigned int        _uiDataOut,
                                                   unsigned long       _ulRepeatCnt,
                                                   char*               _psAddressSpace,
                                                   char*               _psDataSize,
                                                   char*               _psAccessPriv,
                                                   char*               _psAccessType,
                                                   char*               _psBit3Access,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Rio_ReadReg               ( unsigned int        _uiMasterNum,
                                                   unsigned int        _uiSlaveNum,
                                                   unsigned int        _uiSlotNum,
                                                   unsigned int        _uiChipNum,
                                                   unsigned int        _uiRegAddr,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Rio_WriteReg              ( unsigned int        _uiMasterNum,
                                                   unsigned int        _uiSlaveNum,
                                                   unsigned int        _uiSlotNum,
                                                   unsigned int        _uiChipNum,
                                                   unsigned int        _uiRegAddr,
                                                   unsigned int        _uiDataOut,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Mio_MultiRead             ( unsigned int        _uiMasterNum,
                                                   unsigned int        _uiSlaveNum,
                                                   unsigned int        _uiSlotNum,
                                                   unsigned int        _uiChipNum,
                                                   unsigned int        _uiRegAddr,
                                                   unsigned int        _uiRegSamples, 
                                                   unsigned int        _uiCondMask,
                                                   unsigned int        _uiCondValue,
                                                   unsigned int        _uiMax_Try,
                                                   unsigned int        _uiRegDumpToFile,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Hst_10BitHisto            ( unsigned int        _uiMasterNum,
                                                   unsigned int        _uiSlaveNum,
                                                   unsigned int        _uiSlotNum,
                                                   unsigned int        _uiChipNum,
                                                   unsigned int        _uiRegAddr,
                                                   unsigned int        _uiRegSamples, 
                                                   unsigned int        _uiRegAddrIncr,
                                                   unsigned int        _uiRegDumpToFile,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Sio_ReadReg               ( unsigned int        _uiTabGab_Module,
                                                   unsigned int        _uiChip_Address,
                                                   unsigned int        _uiGroup_Address,
                                                   unsigned int        _uiSerial_Address,
                                                   unsigned int        _uiSerial_Data,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Sio_WriteReg              ( unsigned int        _uiTabGab_Module,
                                                   unsigned int        _uiChip_Address,
                                                   unsigned int        _uiGroup_Address,
                                                   unsigned int        _uiSerial_Address,
                                                   unsigned int        _uiSerial_Data,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Sio_VmeSclStatus          ( CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Cfg_ConfigFPGA            ( unsigned int        _uiMasterNum,
                                                   unsigned int        _uiSlaveNum,
                                                   unsigned int        _uiSlotNum,
                                                   unsigned int        _uiFpgaMask,
                                                   char*               _psFileName,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Tcf_ConfigTabGab          ( unsigned int        _uiModuleNum,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Rrt_ClearAll              ( CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Rrt_AddRange              ( unsigned int        _uiMasterNum,
                                                   unsigned int        _uiSlaveNum,
                                                   unsigned int        _uiSlotNum,
                                                   unsigned int        _uiChipNum,
                                                   unsigned int        _uiRegAddrStart,
                                                   unsigned int        _uiRegAddrCount,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Rrt_StartTest             ( unsigned int        _uiTestLoop,
                                                   unsigned int        _uiExponent,
                                                   bool                _lOnErrorStop,
                                                   bool                _lOnErrorVerifyAll,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Adc_Capture               ( unsigned int        _uiMasterNum,
                                                   unsigned int        _uiSlaveNum,
                                                   unsigned int        _uiSlotNum,
                                                   unsigned int        _uiTtRelEta,
                                                   unsigned int        _uiTtRelPhi,
                                                   unsigned int        _uiTtEtaSign,
                                                   unsigned int        _uiTtEtaMagn,
                                                   unsigned int        _uiTtPhi,
                                                   ETT_Chan_Type       _eTtType,
                                                   unsigned int        _uiThreshold,
                                                   unsigned int        _uiMaxTry,
                                                   unsigned int        _uiAdcDumpToFile,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Dac_ProgOneDac            ( unsigned int        _uiMasterNum,
                                                   unsigned int        _uiSlaveNum,
                                                   unsigned int        _uiSlotNum,
                                                   unsigned int        _uiTtRelEta,
                                                   unsigned int        _uiTtRelPhi,
                                                   unsigned int        _uiTtEtaSign,
                                                   unsigned int        _uiTtEtaMagn,
                                                   unsigned int        _uiTtPhi,
                                                   ETT_Chan_Type       _eTtType,
                                                   unsigned int        _uiDacValue,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Dac_Find_DAC              ( unsigned int        _uiMasterNum,
                                                   unsigned int        _uiSlaveNum,
                                                   unsigned int        _uiSlotNum,
                                                   unsigned int        _uiTtRelEta,
                                                   unsigned int        _uiTtRelPhi,
                                                   unsigned int        _uiTtEtaSign,
                                                   unsigned int        _uiTtEtaMagn,
                                                   unsigned int        _uiTtPhi,
                                                   ETT_Chan_Type       _eTtType,
                                                   unsigned int        _uiAdcValue,
                                                   unsigned int        _uiAdcDumpToFile,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Adf_InitCard              ( unsigned int        _uiMasterNum,
                                                   unsigned int        _uiSlaveNum,
                                                   unsigned int        _uiSlotNum,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Adf_SendPrn               ( unsigned int        _uiMasterNum,
                                                   unsigned int        _uiSlaveNum,
                                                   unsigned int        _uiSlotNum,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Adf_SendBls               ( unsigned int        _uiMasterNum,
                                                   unsigned int        _uiSlaveNum,
                                                   unsigned int        _uiSlotNum,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Roc_AnalyzeEvt            ( CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Roc_DumpEvt               ( unsigned int        _ulTotLongDump,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Cmd_Vio_File              ( char*               _psFileName,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Cmd_Rio_File              ( char*               _psFileName,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Cmd_Sio_File              ( char*               _psFileName,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Cmd_Cfg_File              ( char*               _psFileName,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Cmd_Tti_File              ( char*               _psFileName,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Cmd_Msg_File              ( char*               _psFileName,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Cmd_Mcf_File              ( char*               _psFileName,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Daq_Start_Run             ( unsigned int        _uiRunNumber,
                                                   unsigned int        _uiEventMax,
                                                   unsigned int        _uiCoolDown,
                                                   unsigned int        _uiModeBinary,
                                                   char*               _psDirectory,
                                                   CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Daq_Pause_Run             ( CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Daq_Resume_Run            ( CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Daq_Stop_Run              ( CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

    EGuiCommandStatus  Daq_Status                ( CGuiCommandLine*    _poGuiCommandLine = NULL ) ;

private:

} ;
/*-------------------------------------------------------------------------------*/
#endif // __GuiCommandPrinter__
