/*-------------------------------------------------------------------------------*/
  /*
     GuiDlgIoVme.h
     06-Oct-2005
  */
/*-------------------------------------------------------------------------------*/



// constants for manipulating radio buttons 
// for Bit3 resource type (i.e. VME cycle type)
#define     KFlag_A32   0
#define     KFlag_A24   1
#define     KFlag_A16   2
#define     KFlag_DPM   3

// constants for manipulating radio buttons 
// for data transfer size
#define     KFlag_D32   0
#define     KFlag_D16   1
#define     KFlag_D8    2

// constants for manipulating radio buttons 
// for Address Modifier
#define     KFlag_Amod_Progr        0
#define     KFlag_Amod_Data         1
#define     KFlag_Amod_Block        2

#define     KFlag_Amod_Super        0
#define     KFlag_Amod_NonPriv      1


// constants for manipulating radio buttons 
// for Bit3 interface method: API call vs Memory Map
#define     KFlag_API   0
#define     KFlag_MAP   1



// Read VME Register
ESuccess DlgIoVme_ReadReg               ( unsigned long       _ulVmeAddress,
                                          unsigned long*      _pulDataIn,
                                          unsigned long       _ulRepeatCnt      = 1,
                                          char*               _psAddressSpace   = NULL,     // default to A32
                                          char*               _psDataSize       = NULL,     // default to D16
                                          char*               _psAccessPriv     = NULL,     // default to Super
                                          char*               _psAccessType     = NULL,     // default to Data
                                          char*               _psBit3Access     = NULL ) ;  // default to API

// Write VME Register
ESuccess DlgIoVme_WriteReg              ( unsigned long       _ulVmeAddress,
                                          unsigned long       _ulDataOut,
                                          unsigned long*      _pulDataIn,
                                          unsigned long       _ulRepeatCnt      = 1,
                                          char*               _psAddressSpace   = NULL,     // default to A32
                                          char*               _psDataSize       = NULL,     // default to D16
                                          char*               _psAccessPriv     = NULL,     // default to Super
                                          char*               _psAccessType     = NULL,     // default to Data
                                          char*               _psBit3Access     = NULL ) ;  // default to API
