#if !defined ( NO_MS_CSTRING )
#else
#endif

/*-------------------------------------------------------------------------------*/
  /*
    DefineCString.h
    Class CString defined as interface to std::string
    12-Oct-2004
  */
/*-------------------------------------------------------------------------------*/

// String Class: use standard string to replace MFC CString

#include    <string>
typedef std::string std_string ;



class CString ; //forward declaration so that we can get the typedef below over with
typedef CString TCString ;


/*
    #define CONST               const
    typedef char CHAR;
    typedef CONST CHAR *LPCSTR, *PCSTR;
    typedef LPCSTR LPCTSTR;
*/

typedef const char* LPCSTR ;
typedef const char* LPCTSTR;

void makelower( char* c ) ;


class CString : public std_string
{

  public : 

    CString ( )                   : std_string(  ) { } ;
    CString ( std_string    s )   : std_string( s) { } ;
    CString ( const char    c )   : std_string(&c) { } ;
    CString ( const char*   c )   : std_string( c) { } ;

  public : 

      operator LPCTSTR() const ;

  public : 

    const char*   GetBuffer ( int i )           const { return c_str () ; } ;
    const int     FindOneOf ( const char* s )   const { return find_first_of (s) ; } ;
    const CString      Left ( int n )           const { return CString ( substr( 0, n ) ) ; } ;
    const CString       Mid ( int b )           const { return CString ( substr( b    ) ) ; } ;
    const CString       Mid ( int b, int n )    const { return CString ( substr( b, n ) ) ; } ;
    const int     GetLength ( )                 const { return length() ; } ;
    const char        GetAt ( int i )           { return at( i ) ; } ;
    void          MakeLower ( )                 ;
    int       CompareNoCase ( const char * s )  ;
} ;


inline          CString::operator LPCTSTR() const 
{ 
    return c_str() ; 
} ;

inline CString operator+ ( const CString _L, const CString _R )  { return CString((std_string)_L + (std_string)_R) ; } ;
inline CString operator+ ( const char*   _L, const CString _R )  { return CString(            _L + (std_string)_R) ; } ;
inline CString operator+ ( const CString _L, const char*   _R )  { return CString((std_string)_L +             _R) ; } ;
inline CString operator+ ( const char    _L, const CString _R )  { return CString(            _L + (std_string)_R) ; } ;
inline CString operator+ ( const CString _L, const char    _R )  { return CString((std_string)_L +             _R) ; } ;

