/*-------------------------------------------------------------------------------*/
  /*
    HandleConfigAdfFpga.h
    2-Sep-99 split off from dialog box
  */
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/AdfCardBase.h"

/*-------------------------------------------------------------------------------*/

// used to pass a request to set the Board CSR after an FPGA Configuration
// Its value must be a logical OR of the following constants
typedef     unsigned long   TMaskBoardCsr ;

#define     KmCsr_Set_bMsaFpgaOutEnab          0x00000001
#define     KmCsr_Set_bBsfFpgaOutEnab          0x00000002

#define     KmCsr_Set_bMsaEclOutEnab           0x00000010

#define     KmCsr_Set_bJtagSpcEnab             0x00000100
#define     KmCsr_Set_bJtagSpcActive           0x00000200

#define     KmCsr_Set_bGlobalIntEnab           0x00001000

#define     KmCsr_Clear_bVmeFpgaReconf         0x00010000
#define     KmCsr_Clear_bVmeBusErr             0x00020000

// this is the default settings when using configuration command files
#define     KmCsr_Set_Default                ( KmCsr_Set_bMsaFpgaOutEnab | KmCsr_Set_bBsfFpgaOutEnab | KmCsr_Set_bJtagSpcEnab | KmCsr_Set_bJtagSpcActive | KmCsr_Clear_bVmeFpgaReconf | KmCsr_Clear_bVmeBusErr )

// used to provide details about the type of error 
// that occured during the attempted Configuration 
// Its value must be ONE of the following constants
typedef     unsigned long   TErrorCode ;

#define     KeERR_DldFpga_NoError             0x00010000

#define     KeERR_DldFpga_SRecFile            0x00010001
//#define     KeERR_DldFpga_FileAccess          0x00010001
//#define     KeERR_DldFpga_FileContent         0x00010002
#define     KeERR_DldFpga_BadDldMask          0x00010011
#define     KeERR_DldFpga_DldInit             0x00010021
#define     KeERR_DldFpga_DldByteStream       0x00010031
#define     KeERR_DldFpga_DldTerminate        0x00010041
#define     KeERR_DldFpga_ConfiguredMask      0x00010051
#define     KeERR_DldFpga_SetCsr              0x00010061


ESuccess ConfigureAdfFpga ( CAdfCardBase*   _poTargetCard,
                            unsigned short  _uwConfigEnabMask,
            	            CString	        _osConfiguration_File_Name,
                            TMaskBoardCsr   _mCsrFlags = KmCsr_Set_Default, // obsolete
                            unsigned short* _puwConfigured = NULL,
                            TErrorCode*     _ptErrorCode = NULL,
                            EYesNo          _eVerbose = No ) ;


ESuccess CheckConfigurationMask ( unsigned short _uwConfigEnabMask ) ;
