/*-------------------------------------------------------------------------------*/
  /*
    HandleConsole.h
    Class CConsoleAccess
     1-May-98
     8-May-98 Add Set color member functions
    25-Jun-98 Add GetConsoleHwnd
    26-Oct-98 rename from ConsoleAccess to HandleConsole
  */
#ifndef __HandleConsole__
#define __HandleConsole__
/*-------------------------------------------------------------------------------*/

// Message Payload default Max Length = 156 = 2x80 char line not counting 2x prefix
#define     KiConsoleMsgLengthDefault        156

// Long Line Message Payload Max Length 
#define     KiConsoleMsgLengthLongest       1024

class CConsoleAccess
{
/////////////////////////////
// Constructor/Destructor
public:

	 CConsoleAccess();


     ~CConsoleAccess();

/////////////////////////////
// Attributes
public:


private:

#if !defined ( NO_MS_CONSOLE )
    static  HANDLE mg_hConsole ;    //Handle to Standard Output from Console
    static  HWND   mg_hWindow ;     //Handle to Console Window
#else
#endif

	static  unsigned long mg_ulErrorGauge ;

/////////////////////////////
// Operations
public:

    static  ESuccess  NewConsole ( ) ;

    static  ESuccess  CloseConsole ( ) ;

    static  ESuccess  WriteLine         ( const char*       const _sString,
                                          const char*       const _sPrefix = NULL,
                                          const int               _iMsgLengthMax = KiConsoleMsgLengthDefault ) ; 
    // CString can be converted to char*
    // but CString* cannot, so here is an overloaded version of Writeline
//    static  ESuccess  WriteLine         ( CString*          const _oString ) ;

    // WriteLongLine  allows for a longer input string
    static  ESuccess  WriteLongLine     ( const char*       const _sString,
                                          const char*       const _sPrefix = NULL ) ;

    static  ESuccess  ErrorLine         ( const char*       const _sString ) ;

    static  ESuccess  WarningLine       ( const char*       const _sString ) ;

    static  ESuccess  SystemLine        ( const char*       const _sString ) ;

    static  ESuccess  MessageLine       ( const char*       const _sString ) ;

    static  ESuccess  InternalErrorLine ( const char*       const _sString ) ;

private:

#if !defined ( NO_MS_CONSOLE )
    static  HANDLE    GetHandle ( ) ;
    static  HWND      GetConsoleHwnd(void) ;
#else
#endif

    static  ESuccess  SetRed ( ) ;
    static  ESuccess  SetBlue ( ) ;
    static  ESuccess  SetAqua ( ) ;
    static  ESuccess  SetPurple ( ) ;
    static  ESuccess  SetYellow ( ) ;
    static  ESuccess  SetWhite ( ) ;
    static  ESuccess  SetBrightWhite ( ) ;
};

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
// define some console message constants

// Prefix Flag Length = 2 leading char e.g. "E$"
#define     KiConsoleMsgPrefixLength            2 

// Define All Line Prefix
#define     KiConsolePrefixSeparator         '$'
#define     KiConsolePrefixInfo             "I$"
#define     KiConsolePrefixError            "E$" 
#define     KiConsolePrefixWarning          "W$" 
#define     KiConsolePrefixSystem           "S$" 
#define     KiConsolePrefixMessage          "M$" 
#define     KiConsolePrefixBug              "B$" 

#define     KiConsolePrefixNevisInfo        "I#"
#define     KiConsolePrefixNevisError       "E#" 
//#define     KiConsolePrefixContinuation     "-$" now use lowercase of above

// Define character flag to show overflow 
#define     KcConsoleSuffixOverflow          '?'

// Cosmetic constants
#define     KiConsoleMessageSpaceForCR          1
#define     KiConsoleMessageSpaceForNULL        1

/*-------------------------------------------------------------------------------*/
#endif // __HandleConsole__
