

#define KiL1CalTotTabModule     20         // Includes tab (0..7) gab (8) and vmescl (10) and 15??
#define KiTabCardAddressSize 32768         // Address space reserved for each Tab/Gab Module
#define KiVmeSclSlot            18         // Slot of the VME/SCL card


/*-------------------------------------------------------------------------------*/
  /*
    HandleHardwareAccess.h
    Class CHardwareAccess
    19-Nov-2004
  */
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/HandleBit3Adaptor61x.h"

class CHardwareAccess 
{

/////////////////////////////
// Constructor/Destructor
public:

	 CHardwareAccess();

     ~CHardwareAccess();

/////////////////////////////
// Attributes
public:

#if defined VME_IO_DUAL_BIT3
    static CBit3Adaptor61x*    mg_poBit3BusAdaptorArray[2]  ; // for Dual Crate 0
#endif

    static CBit3Adaptor61x*    mg_poBit3BusAdaptor_Adf ; // for ADF via Vertial Interconnect
    static CBit3Adaptor61x*    mg_poBit3BusAdaptor ;     // for backwards compatibility, same as the xxxx_Adf above
    static CBit3Adaptor61x*    mg_poBit3BusAdaptor_Tab ; // for TAB/GAB/VMESCL

private:

    // This is an array of pointers in the process' virtual address space
    // mapped to the base address of each trigger card. 
    // This array is initialized to null pointers. 
    // The MemoryMapThisCard member function (called by the constructor for the base 
    // register class) will test the corresponding pointer, and if null, will 
    // cause the mapping of another section of VME space starting at the base 
    // of the corresponding card address and of length the standard size 
    // of a card's address space. 
    // The AdfRegBase constructor will then use this base pointer to prepare a direct 
    // pointer to the corresponding register.
    static TuwRegWord*     mg_apuwAdfCardBase[KiL1CalTotVertMaster][KiL1CalTotVertSlave][KiL1CalTotSlot] ;


    // This is an array of pointers in the process' virtual address space
    // mapped to the base address of each TAB/GAB card. 
    static unsigned long*  mg_apuwTabCardBase[KiL1CalTotTabModule] ;

/////////////////////////////
// Operations
public:

    // Map a segment of VME Address Space corresponding to a particular ADF-2 Card
    static TuwRegWord* MemoryMapThisCard ( unsigned char   _ubVertMaster,
                                           unsigned char   _ubVertSlave,
                                           unsigned char   _ubCardSlot ) ;

    // Map a segment of VME Address Space corresponding to a particular TAB/GAB Card
    static unsigned long* MemoryMapThisModule ( unsigned char   _ubCardSlot ) ;

    // Call to Bit3 API to read a 16-bit word at the specified A32 address
    static ESuccess    ReadVmeReg     ( TulVmeAddress       _ulVmeAddress, 
                                        TuwRegWord* const   _kpuwReadData ) ;

    // Call to Bit3 API to write a 16-bit word at the specified A32 address
    static ESuccess    WriteVmeReg    ( TulVmeAddress       _ulVmeAddress, 
                                        TuwRegWord* const   _kpuwWriteData ) ;

    // Read a Tab/Gab/VmeScl Target 
    // Call to Bit3 API or memory map access to Read a 32-bit word at the specified A24 address
    static ESuccess    ReadTabGab     ( unsigned long      _ulModuleNum, 
                                        unsigned long      _ulChipNum, 
                                        unsigned long      _ulGroupNum,
                                        unsigned long*     _pulValue ) ;

    // Write a Tab/Gab/VmeScl Target 
    // Call to Bit3 API or memory map access to Write a 32-bit word at the specified A24 address
    static ESuccess    WriteTabGab    ( unsigned long      _ulModuleNum, 
                                        unsigned long      _ulChipNum, 
                                        unsigned long      _ulGroupNum,
                                        unsigned long*     _pulValue ) ;

private:

};


