/*-------------------------------------------------------------------------------*/
  /*
    HandleItcServer.h
     16-Jul-99
  */
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/StringMessageConsumerInterface.h"

#include "itc/String_Message.hpp"
#include "itc/itc.hpp"

// Nested message interface definition
typedef     ESuccess    Nested_Message_Consumer_Interface ( const itc::IPC_Message &_ItcMsgIn ) ;

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
class ItcServer
{

/////////////////////////////
// Constructor/Destructor
public:

    ItcServer        ( unsigned short                       _uwIP_Port_Num,
                       String_Message_Consumer_Interface*   _pfString_Message_Consumer = NULL ) ;
    
    ItcServer        ( unsigned short                       _uwIP_Port_Num,
                       Nested_Message_Consumer_Interface*   _pfNested_Message_Consumer ) ;

   ~ItcServer        ( ) ;

private:
    void  InitServer ( ) ; // common construction actions

/////////////////////////////
// Attributes
public:

    itc::SOCK_Acceptor*                 m_pServer ;

private:

    unsigned short                      m_uwIP_Port_Num ;

    EYesNo                              m_ynConnected ;

    String_Message_Consumer_Interface*  m_pfString_Message_Consumer ;
    Nested_Message_Consumer_Interface*  m_pfNested_Message_Consumer ;

    itc::Connection_Handle*             m_pLast_Connection ;

/////////////////////////////
// Operations
public:
    
    void        start ();

    ESuccess    SendMessage       ( const char*       const _sString ) ;
    ESuccess    SendOpaque        ( const void*       const _pxBlock, 
                                    unsigned long     const _ulSize ) ;

    void        Message_Consumer  ( const itc::IPC_Message &_ItcMsgIn ) ; 

    unsigned short  f_uwIP_Port_Num   ( )       { return m_uwIP_Port_Num ; } ; 
    EYesNo          f_ynConnected     ( )       { return m_ynConnected ; } ; 
    itc::Connection_Handle*  f_pLast_Connection ( ) 
                                                { return m_pLast_Connection ; } ; 

} ;

