/*-------------------------------------------------------------------------------*/
  /*
    HandleSymbols.h
    Class CSymbolSet, and CSymbolElement
     28-Oct-98
  */
/*-------------------------------------------------------------------------------*/


class CSymbolElement
{
/////////////////////////////
// Constructor/Destructor
public:

	 CSymbolElement   ();

	 CSymbolElement   ( const char*         _psSymbolName, 
                        unsigned long       _ulSymbolValue,
                        CSymbolElement*     _poPrevSymbol  );

     ~CSymbolElement  ();

/////////////////////////////
// Attributes
public:


private:

    CString             m_osSymbolName ;
    unsigned long       m_ulSymbolValue ;
    CSymbolElement*     m_poPrevSymbol ;

/////////////////////////////
// Operations
public:

    const char*         GetName       ( )        { return m_osSymbolName.GetBuffer(0) ; } ;

    unsigned long       GetValue      ( )        { return m_ulSymbolValue ; } ;

    CSymbolElement*     GetPrev       ( )        { return m_poPrevSymbol  ; } ;

private:

    EYesNo              MatchName     ( const char*           _psSymbolName ) ;

/////////////////////////////
// Special Access Permissions

friend  class CSymbolSet ;

} ;

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

class CSymbolSet
{
/////////////////////////////
// Constructor/Destructor
public:

	 CSymbolSet();


     ~CSymbolSet();

/////////////////////////////
// Attributes
public:


private:

    CSymbolElement*     m_poLastSymbol ;

    unsigned short      m_uwTotSymbol ;

    CSymbolElement*     m_poCachedLastAccessed ;

/////////////////////////////
// Operations
public:

    CSymbolElement*     LocateSymbol  ( const char*     _psSymbolName ) ;

    ESuccess            AddSymbol     ( const char*     _psSymbolName, 
                                        unsigned long   _ulSymbolValue ) ;

    ESuccess            ModifySymbol  ( const char*     _psSymbolName, 
                                        unsigned long   _ulSymbolValue ) ;

    ESuccess            DeleteAllSymbols ( ) ;


/////////////////////////////
// Overloaded assignement operator
public:
    const CSymbolSet&   operator=     ( const CSymbolSet&   _SymbolSetSrc ) ;

} ;

