/*-------------------------------------------------------------------------------*/
  /*
    HsroCrate.h
    Class CHsroCrate
    5-Sep-00  L1FW VRB Crate
    2-Jul-01  Made into generic readout crate that HsroL1fw will derive from
  */
#ifndef __HsroCrate__
#define __HsroCrate__
/*-------------------------------------------------------------------------------*/

#include "HsroVrbCard.h"
#include "HsroVrbContrCard.h"
#include "HsroVbdCard.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

class CHsroCrate 
{
/////////////////////////////
// Constructor/Destructor
public:

             CHsroCrate         ( ) ; 

            ~CHsroCrate         ( );

/////////////////////////////
// Attributes

public:

    //Array of VRB Cards in the crate
    CHsroVrbCard*       m_paoVrb[Ki_Max_Vrb_in_Readout_Crate] ; 

    //VRB Controller Card
    CHsroVrbContrCard*  m_poVrbContr ; 

    //VBD Card
    CHsroVbdCard*       m_poVbd ; 

protected:

    //Pointer to Last VRB Card In Crate
    CHsroVrbCard*       m_poLastVrbCard ; 

/////////////////////////////
// Operations

public:

    ESuccess Initialize           ( ) ;

    ESuccess InitializeAllVrb     ( ) ;
    ESuccess InitializeVrbc       ( ) ;
    ESuccess InitializeVbd        ( ) ;

    ESuccess VmeSysReset          ( TulVmeAddress _ulVerticalSysResetAddress ) ;

    ESuccess ExtractOneCard       ( unsigned long       _ulVrb_Slot,
                                    unsigned long       _ulVtm_Channel,
                                    OneCardHsroDataMax* _pxActualData,
                                    unsigned long       _ulTotLong ) ;

protected:

};

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
#endif // __HsroCrate__

