/*-------------------------------------------------------------------------------*/
  /*
    HsroL1CalVrbAddresses.h
    25-May-2005 VRB Card Addresses
  */
#ifndef __HsroL1CalVrbAddresses__
#define __HsroL1CalVrbAddresses__
/*-------------------------------------------------------------------------------*/

////////////////////////////////////////////////////////////////////
// VRB's
/* VRB info Not yet valid */
////////////////////////////////////////////////////////////////////

#define Ki_Id_Vrb_L1Cal_0                             1101           // arbitrary card ID. 
#define Ki_Ordinal_Vrb_L1Cal_0                        0              // was the first one, now the last
#define Ki_Slot_Vrb_L1Cal_0                           9            
#define Ki_BaseAddr_Vrb_L1Cal_0                       0x14090000     // this includes the Base address for master #1 slave #0 

#define Ki_Id_Vrb_L1Cal_1                             1102           
#define Ki_Ordinal_Vrb_L1Cal_1                        1
#define Ki_Slot_Vrb_L1Cal_1                           10            
#define Ki_BaseAddr_Vrb_L1Cal_1                       0x140A0000

#define Ki_Id_Vrb_L1Cal_2                             1103           
#define Ki_Ordinal_Vrb_L1Cal_2                        2             
#define Ki_Slot_Vrb_L1Cal_2                           11            
#define Ki_BaseAddr_Vrb_L1Cal_2                       0x140B0000


#define Ki_Tot_Vrb_L1Cal_Readout                      3
// There is also VRB mapping information in the ListOfL1CalCardAddresses.h file

////////////////////////////////////////////////////////////////////
// VRB Controller
////////////////////////////////////////////////////////////////////

#define Ki_Id_Vrb_L1Cal_Controller                    1201
#define Ki_Slot_Vrb_L1Cal_Controller                  14
#define Ki_A24BaseAddr_Vrb_L1Cal_Controller           0x14480000
#define Ki_A16BaseAddr_Vrb_L1Cal_Controller           0x14FFC000 // The upper 64k addresses of the 24 bit space 
                                                                 // generates A16 cycles in the VI slave crate

////////////////////////////////////////////////////////////////////
// VBD / SBC
////////////////////////////////////////////////////////////////////

#define Ki_Id_Vbd_L1Cal                               1301
#define Ki_Slot_Vbd_L1Cal                             4
#define Ki_A24BaseAddr_Vbd_L1Cal                      0x14380000
#define Ki_A16BaseAddr_Vbd_L1Cal                      0x14FF6000


////////////////////////////////////////////////////////////////////
// Access to "Master's IO space" to reset remote crate
////////////////////////////////////////////////////////////////////
//
//        -------+-------|-------+-------|-------+-------|-------+-------
//        A A A A A A A A A A A A A A A A A A A A A A A A A A A A A A A A
//        3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0
//        1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//        -------+-------|-------+-------|-------+-------|-------+-------
//                                               |Rck|             |Crt|
//       |1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1|0 0 0 1|Num|0 0 0 0 0 1 X|Num|0
//        \-----------------------------/         \-/             | \-/
//         Upper Half of address is FFFF           |              |  |
//                                                 |              |  |
//                       V.I. Master Address <-----/              |  |
//                                                                |  |
//                                            0 = Interrupt <-----/  |
//                                            1 = Reset              |
//                                                                   |
//                                          V.I. Slave Address <-----/
//
//   e.g. Reset L1Cal Readout Crate (Master 1, Slave 0) = VME write to 0xFFFF1418

#define Ki_VME_Reset_Addr_Vbd_L1Cal                   0xFFFF1418

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
#endif // __HsroL1CalVrbAddresses__

