/*-------------------------------------------------------------------------------*/
  /*
    L1CalCardAddresses.h
    13-Sep-2005
  */
/*-------------------------------------------------------------------------------*/
#ifndef __L1CalCardAddresses__
#define __L1CalCardAddresses__
/*-------------------------------------------------------------------------------*/

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
// Vertical Master used for Adf Crates
#define Ki_Adf_Crate_Master            0

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
// Instead of having lots of constants for ADF Card address coordinates
// we have utility routines to rebuild them

unsigned char L1CalAdfCardAddress_Master( unsigned long     _ulSign_Eta,
                                          unsigned long     _ulMagn_Eta_By4,
                                          unsigned long     _ulPhi_By4 ) ;

unsigned char L1CalAdfCardAddress_Slave ( unsigned long     _ulSign_Eta,
                                          unsigned long     _ulMagn_Eta_By4,
                                          unsigned long     _ulPhi_By4 ) ;

unsigned char L1CalAdfCardAddress_Slot  ( unsigned long     _ulSign_Eta,
                                          unsigned long     _ulMagn_Eta_By4,
                                          unsigned long     _ulPhi_By4 ) ;

CString L1CalAdfCardAddress_Desc        ( unsigned long     _ulSign_Eta,
                                          unsigned long     _ulMagn_Eta_By4,
                                          unsigned long     _ulPhi_By4 ) ;

///////////////////////////////////////////////////////////////////////////
// Same for TAB 

unsigned char L1CalTabCardAddress_Module( unsigned long     _ulPhi_By4 ) ;

CString L1CalTabCardAddress_Desc        ( unsigned long     _ulPhi_By4 ) ;

///////////////////////////////////////////////////////////////////////////
// Same for GAB 

unsigned char L1CalGabCardAddress_Module( ) ;

CString L1CalGabCardAddress_Desc        ( ) ;

/*-------------------------------------------------------------------------------*/
// Common to TAB and GAB
//
//    VRB         Link
//    SLOT        1      2      3     4
//    9           TAB0   TAB1   TAB2  SPARE
//    10          TAB3   GAB    TAB4  SPARE
//    11          TAB5   TAB6   TAB7  SPARE

unsigned char L1CalTabVrbSlot         ( unsigned char       _ulModule_Num ) ;

unsigned char L1CalTabVrbChannelPair  ( unsigned char       _ulModule_Num ) ;

/*-------------------------------------------------------------------------------*/
#endif // __L1CalCardAddresses__
