/*-------------------------------------------------------------------------------*/
  /*
     ListOfMasterCommandFiles.h
     Collection of all master Command files used by L1Cal_IIb_TCC
     Note: ListOfResultFiles.h lists additional files (e.g. LBN_At_Last_Init.lbn)
     5-Jan-00
     29-Nov-01 add the "helper" files
      1-Apr-02 cleanup 
                match helper files to command name
                match button files to Request_<command_name>
      2-May-01 add Boot_Auxi 
  */
/*-------------------------------------------------------------------------------*/
//use static tag so that this same file can be included in multiple source files
//without causing multiple definitions link errors

//Boot Auxi Command File (e.g. define Et lookup, Latency, Dac Values, etc.)
//This file is executed when L1Cal_IIb_TCC starts up
static const CString     osBoot_Auxi                 = "%CONFIG%/Boot_Auxi.mcf" ;

//Config FPGA (Configures all L1FW, L2FW and L1Cal fpgas)
//This file is executed when L1Cal_IIb_TCC receives a "Configure_FPGAs" command
static const CString     osConfigure_FPGAs_MCF       = "%CONFIG%/Configure_FPGAs.mcf" ;

//PRE-INIT AUXI command file 
//This file is executed when L1Cal_IIb_TCC receives an "init" (aka "L1Cal_Initialize") command
static const CString     osInit_Pre_Auxi_MCF         = "%CONFIG%/Init_Pre_Auxi.mcf" ;

//POST-INIT AUXI command file (
//This file is executed when L1Cal_IIb_TCC receives an "init" (aka "L1Cal_Initialize") command
static const CString     osInit_Post_Auxi_MCF        = "%CONFIG%/Init_Post_Auxi.mcf" ;

/*-------------------------------------------------------------------------------*/
// The files above are "critical" files which implement basic system operation
// and contain detailed and complex actions.
/*-------------------------------------------------------------------------------*/
// The files below are "helper" files used by L1Cal_IIb_TCC as a simple mean 
// to send itself a COOR command.
/*-------------------------------------------------------------------------------*/

//Send a "Configure_FPGAs" command
//This file is used by the button "Configure All FPGAs" in "Master Command Files" 
//static const CString     osHelper_Configure_MCF      = "%CONFIG%\\Request_Configure_FPGAs.mcf" ;

