/*-------------------------------------------------------------------------------*/
  /*
     MessageCoorPrinter.h
     7-Oct-99
     28-Oct-99 Coor Command Parsing split onto separate files
  */
#ifndef __MessageCoorPrinter__
#define __MessageCoorPrinter__
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
class CMessageCoorPrinter 
{

/////////////////////////////
// Constructor/Destructor

public:

    CMessageCoorPrinter () { } ;
   ~CMessageCoorPrinter () { } ;

/////////////////////////////
// Member Variables

public:

private: 

/////////////////////////////
// Member Functions

public: // These are the functions to override in the L1FW Simulator

    ECoorMessageStatus  Configure_FPGAs           ( CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  L1Cal_Initialize          ( CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  Iterative_DeSkew          ( CMessageCommandLine*    _poCoorCommandLine = NULL ) ;


    ECoorMessageStatus  StartRun                  ( const unsigned long     _ulRunNumber,
                                                    EItemPolarity*          _pubListItemPolarity,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  StopRun                   ( const unsigned long     _ulRunNumber,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  PauseRun                  ( const unsigned long     _ulRunNumber,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  ResumeRun                 ( const unsigned long     _ulRunNumber,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  BeginStore                ( const unsigned long     _ulStoreNumber,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  EndStore                  ( const unsigned long     _ulStoreNumber,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;



    ECoorMessageStatus  Exclude_Tower             ( ETT_Chan_Type           _eTTType,
                                                    TAllTriggerTowers*      _pxTT,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;




    ECoorMessageStatus  RefSetEMEtProg            ( const unsigned int      _uiRefSetNum, 
                                                    TAllTriggerTowers*      _pxTT,
                                                    const double            _fdThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  RefSetJetEtProg           ( const unsigned int      _uiRefSetNum, 
                                                    TAllTriggerTowers*      _pxTT,
                                                    const double            _fdThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  RefSetTTEtProg            ( const unsigned int      _uiRefSetNum, 
                                                    TAllTriggerTowers*      _pxTT,
                                                    const double            _fdThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  RefSetEMEtDeall           ( const unsigned int      _uiRefSetNum, 
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  RefSetJetEtDeall          ( const unsigned int      _uiRefSetNum, 
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  RefSetTTEtDeall           ( const unsigned int      _uiRefSetNum, 
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;



    ECoorMessageStatus  L2MaskEM                  ( TAllTriggerTowers*      _pxTT,
                                                    const unsigned int      _uiRefSetNum, 
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  L2MaskJet                 ( TAllTriggerTowers*      _pxTT,
                                                    const unsigned int      _uiRefSetNum, 
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  L2MaskTau                 ( TAllTriggerTowers*      _pxTT,
                                                    const unsigned int      _uiRefSetNum, 
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;



    ECoorMessageStatus  AlgoUseEmFraction         ( TAllTriggerTowers*      _pxTT,
                                                    bool                    _lUseEmFraction,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  AlgoUseEmIsolation        ( TAllTriggerTowers*      _pxTT,
                                                    bool                    _lUseEmIsolation,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  AlgoEmIsolationEtCut      ( TAllTriggerTowers*      _pxTT,
                                                    const double            _fdThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  AlgoTauEtCoreCut          ( TAllTriggerTowers*      _pxTT,
                                                    const double            _fdThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  AlgoGlobalSumEtCut        ( TAllTriggerTowers*      _pxTT,
                                                    const double            _fdThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  AlgoUseIcrJetObjects      ( TAllTriggerTowers*      _pxTT,
                                                    bool                    _lUseIcr,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  AlgoUseIcrGlobalSums      ( TAllTriggerTowers*      _pxTT,
                                                    bool                    _lUseIcr,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;



    ECoorMessageStatus  TermEmAll                 ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum, 
                                                    const unsigned int      _uiThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermEmCentral             ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum, 
                                                    const unsigned int      _uiThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermJetAll                ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum, 
                                                    const unsigned int      _uiThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermJetCentral            ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum, 
                                                    const unsigned int      _uiThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermTauAll                ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum, 
                                                    const unsigned int      _uiTauRatioNum, 
                                                    const unsigned int      _uiThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermTauCentral            ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum, 
                                                    const unsigned int      _uiTauRatioNum, 
                                                    const unsigned int      _uiThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermIsolEmAll             ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum, 
                                                    const unsigned int      _uiThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermIsolEmCentral         ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum, 
                                                    const unsigned int      _uiThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermMissEt                ( const unsigned int      _uiComparatorNum, 
                                                    const double            _fdThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermTotEt                 ( const unsigned int      _uiComparatorNum, 
                                                    const double            _fdThreshold,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermAcoplanarJet          ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum1, 
                                                    const unsigned int      _uiRefSetNum2,
                                                    const unsigned int      _uiDelta_Phi,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermNonCollinearLowEtJet  ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum1, 
                                                    const unsigned int      _uiRefSetNum2,
                                                    const unsigned int      _uiDelta_Phi,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermNonCollinearMonoJet   ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum1, 
                                                    const unsigned int      _uiRefSetNum2,
                                                    const unsigned int      _uiDelta_Phi,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermJetFree               ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum1, 
                                                    const unsigned int      _uiRefSetNum2,
                                                    const unsigned int      _uiDelta_Phi,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;

    ECoorMessageStatus  TermBackToBackEm          ( const unsigned int      _uiComparatorNum, 
                                                    const unsigned int      _uiRefSetNum, 
                                                    const unsigned int      _uiDelta_Phi,
                                                    CMessageCommandLine*    _poCoorCommandLine = NULL ) ;


    static void         BuildItemList             ( char*                   _psReplyText,
                                                    EItemPolarity*          _pubListItemPolarity ) ;

    static void         Add_Formatted_Item_List   ( char*                   _psReplyText,
                                                    EItemPolarity*          _pubListItemPolarity ) ;

    static void         Add_Formatted_TT_Range    ( char*                   _psReplyText,
                                                    TAllTriggerTowers*      _pxTT ) ;

    static void         Add_Formatted_TT_Eta      ( char*                   _psReplyText,
                                                    TAllTriggerTowers*      _pxTT ) ;

    static void         Add_Formatted_TT_Phi      ( char*                   _psReplyText,
                                                    TAllTriggerTowers*      _pxTT ) ;

    static void         Add_Formatted_Range       ( char*                   _psReplyText,
                                                    int                     _iRangeLower, 
                                                    int                     _iRangeUpper,
                                                    EItemPolarity           _ePolarity = ItemAsserted ) ;

private:

} ;
/*-------------------------------------------------------------------------------*/
#endif // __MessageCoorPrinter__
