/*-------------------------------------------------------------------------------*/
  /*
     MessageKeywordsCoorL1Cal.h
     15-Sep-2005
  */
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
// Encoded COOR Command Types 

//All command IDs in this file must fall within these values
#define     Ki_CoorCmd_MinID_L1Cal                       1000
#define     Ki_CoorCmd_MaxID_L1Cal                       1999


//[L1Cal_Ref_Set EM_Et_Ref_Set  0 TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 10.0]
//[L1Cal_Ref_Set Jet_Et_Ref_Set 0 TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 10.0]
//[L1Cal_Ref_Set TT_Et_Ref_Set  0 TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 10.0]
//[L1Cal_Ref_Set EM_Et_Ref_Set  0 Deallocate]
//[L1Cal_Ref_Set Jet_Et_Ref_Set 0 Deallocate]
//[L1Cal_Ref_Set TT_Et_Ref_Set  0 Deallocate]
#define     Ks_CoorCmd_L1Cal_Ref_Set                   "L1Cal_Ref_Set"
#define     Ki_CoorCmd_L1Cal_Ref_Set                    1000

//[L1Cal_Ref_Set EM_Et_Ref_Set  0 TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 10.0]
#define     Ks_CoorSubCmd_EM_Et_Ref_Set                "EM_Et_Ref_Set"
#define     Ki_CoorSubCmd_EM_Et_Ref_Set                 1010
//[L1Cal_Ref_Set EM_Et_Ref_Set  0 Deallocate]
#define     Ki_CoorSubCmd_EM_Et_Ref_Set_Deallocate      1015

//[L1Cal_Ref_Set Jet_Et_Ref_Set 0 TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 10.0]
#define     Ks_CoorSubCmd_Jet_Et_Ref_Set               "Jet_Et_Ref_Set"
#define     Ki_CoorSubCmd_Jet_Et_Ref_Set                1020
//[L1Cal_Ref_Set Jet_Et_Ref_Set 0 Deallocate]
#define     Ki_CoorSubCmd_Jet_Et_Ref_Set_Deallocate     1025

//[L1Cal_Ref_Set TT_Et_Ref_Set  0 TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 10.0]
#define     Ks_CoorSubCmd_TT_Et_Ref_Set                "TT_Et_Ref_Set"
#define     Ki_CoorSubCmd_TT_Et_Ref_Set                 1030
//[L1Cal_Ref_Set TT_Et_Ref_Set  0 Deallocate]
#define     Ki_CoorSubCmd_TT_Et_Ref_Set_Deallocate      1035


//[L1CAL_L2Mask  EM_L2Mask  TT_Eta(-16:16) TT_Phi(1:32) Use_Ref_Set   0]
//[L1CAL_L2Mask  Jet_L2Mask TT_Eta(-16:16) TT_Phi(1:32) Use_Ref_Set   0]
//[L1CAL_L2Mask  Tau_L2Mask TT_Eta(-16:16) TT_Phi(1:32) Use_Ref_Set   0]

#define     Ks_CoorCmd_L1CAL_L2Mask                    "L1CAL_L2Mask"
#define     Ki_CoorCmd_L1CAL_L2Mask                     1050

//[L1CAL_L2Mask  EM_L2Mask TT_Eta(-16:16) TT_Phi(1:32) Use_Ref_Set   0]
#define     Ks_CoorSubCmd_EM_L2Mask                    "EM_L2Mask"
#define     Ki_CoorSubCmd_EM_L2Mask                     1060

//[L1CAL_L2Mask  Jet_L2Mask TT_Eta(-16:16) TT_Phi(1:32) Use_Ref_Set   0]
#define     Ks_CoorSubCmd_Jet_L2Mask                   "Jet_L2Mask"
#define     Ki_CoorSubCmd_Jet_L2Mask                    1070

//[L1CAL_L2Mask  Tau_L2Mask TT_Eta(-16:16) TT_Phi(1:32) Use_Ref_Set   0]
#define     Ks_CoorSubCmd_Tau_L2Mask                   "Tau_L2Mask"
#define     Ki_CoorSubCmd_Tau_L2Mask                    1080



//[L1CAL_Algo_Param  EM_Isolation    Use_EMFraction]
//[L1CAL_Algo_Param  EM_Isolation    Ignore_EMFraction]
//[L1CAL_Algo_Param  EM_Isolation    Use_EMIsolation]
//[L1CAL_Algo_Param  EM_Isolation    Ignore_EMIsolation]
//[L1CAL_Algo_Param  EM_Isolation_Et_Cut     TT_Eta(-16:16) TT_Phi(1:32) Energy_Threshold 1.0]
//[L1CAL_Algo_Param  TT_Tau_EtCore_Cut       TT_Eta(-16:16) TT_Phi(1:32) Energy_Threshold 8.0]
//[L1CAL_Algo_Param  TT_Global_Sum_Et_Cut    TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 1.0]
//[L1CAL_Algo_Param  Jet_Objects     Use_ICR]
//[L1CAL_Algo_Param  Jet_Objects     Ignore_ICR]
//[L1CAL_Algo_Param  Global_Sums     Use_ICR]
//[L1CAL_Algo_Param  Global_Sums     Ignore_ICR]

#define     Ks_CoorCmd_L1CAL_Algo_Param                "L1CAL_Algo_Param"
#define     Ki_CoorCmd_L1CAL_Algo_Param                 1100

//[L1CAL_Algo_Param EM_Isolation Use_EMFraction]
//[L1CAL_Algo_Param EM_Isolation Ignore_EMFraction]
//[L1CAL_Algo_Param EM_Isolation Use_EMIsolation]
//[L1CAL_Algo_Param EM_Isolation Ignore_EMIsolation]
#define     Ks_CoorSubCmd_EM_Isolation                 "EM_Isolation"
#define     Ki_CoorSubCmd_EM_Isolation                  1110

//[L1CAL_Algo_Param EM_Isolation Use_EMFraction]
#define     Ks_CoorKeyword_Use_EMFraction              "Use_EMFraction"
#define     Ki_CoorKeyword_Use_EMFraction               1120
#define     Ki_CoorSubCmd_EM_Isolation_Use_EMFraction       1121

//[L1CAL_Algo_Param EM_Isolation Ignore_EMFraction]
#define     Ks_CoorKeyword_Ignore_EMFraction           "Ignore_EMFraction"
#define     Ki_CoorKeyword_Ignore_EMFraction            1122
#define     Ki_CoorSubCmd_EM_Isolation_Ignore_EMFraction    1123

//[L1CAL_Algo_Param EM_Isolation Use_EMIsolation]
#define     Ks_CoorKeyword_Use_EMIsolation             "Use_EMIsolation"
#define     Ki_CoorKeyword_Use_EMIsolation              1126
#define     Ki_CoorSubCmd_EM_Isolation_Use_EMIsolation      1127

//[L1CAL_Algo_Param EM_Isolation Ignore_EMIsolation]
#define     Ks_CoorKeyword_Ignore_EMIsolation          "Ignore_EMIsolation"
#define     Ki_CoorKeyword_Ignore_EMIsolation           1128
#define     Ki_CoorSubCmd_EM_Isolation_Ignore_EMIsolation   1129

//[L1CAL_Algo_Param EM_Isolation_Et_Cut TT_Eta(-16:16) TT_Phi(1:32) Energy_Threshold 1.0]
#define     Ks_CoorSubCmd_EM_Isolation_Et_Cut          "EM_Isolation_Et_Cut"
#define     Ki_CoorSubCmd_EM_Isolation_Et_Cut           1130

//[L1CAL_Algo_Param TT_Tau_EtCore_Cut TT_Eta(-16:16) TT_Phi(1:32) Energy_Threshold 8.0]
#define     Ks_CoorSubCmd_TT_Tau_EtCore_Cut            "TT_Tau_EtCore_Cut"
#define     Ki_CoorSubCmd_TT_Tau_EtCore_Cut             1140

//[L1CAL_Algo_Param TT_Global_Sum_Et_Cut TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 1.0]
#define     Ks_CoorSubCmd_TT_Global_Sum_Et_Cut         "TT_Global_Sum_Et_Cut"
#define     Ki_CoorSubCmd_TT_Global_Sum_Et_Cut          1150

//[L1CAL_Algo_Param Jet_Objects Use_ICR]
//[L1CAL_Algo_Param Jet_Objects Ignore_ICR]
#define     Ks_CoorSubCmd_Jet_Objects                  "Jet_Objects"
#define     Ki_CoorSubCmd_Jet_Objects                   1160

//[L1CAL_Algo_Param Global_Sums Use_ICR]
//[L1CAL_Algo_Param Global_Sums Ignore_ICR]
#define     Ks_CoorSubCmd_Global_Sums                  "Global_Sums"
#define     Ki_CoorSubCmd_Global_Sums                   1170

//[L1CAL_Algo_Param Jet_Objects Use_ICR]
#define     Ks_CoorKeyword_Use_ICR                     "Use_ICR"
#define     Ki_CoorKeyword_Use_ICR                      1180
#define     Ki_CoorSubCmd_Jet_Objects_Use_ICR               1181
#define     Ki_CoorSubCmd_Global_Sums_Use_ICR               1182

//[L1CAL_Algo_Param Jet_Objects Ignore_ICR]
#define     Ks_CoorKeyword_Ignore_ICR                  "Ignore_ICR"
#define     Ki_CoorKeyword_Ignore_ICR                   1185
#define     Ki_CoorSubCmd_Jet_Objects_Ignore_ICR            1186
#define     Ki_CoorSubCmd_Global_Sums_Ignore_ICR            1187


//[L1CAL_to_L1FW  EM_All_Term                 1  Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW  EM_Central_Term             1  Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW  Jet_All_Term                1  Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW  Jet_Central_Term            1  Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW  Tau_All_Term                1  Use_Ref_Set   0 Use_Tau_Ratio_Set 1 Count_Threshold 2]
//[L1CAL_to_L1FW  Tau_Central_Term            1  Use_Ref_Set   0 Use_Tau_Ratio_Set 1 Count_Threshold 2]
//[L1CAL_to_L1FW  Isolated_EM_All_Term        1  Use_Ref_Set   0 Count_Threshold 2]
//[L1CAL_to_L1FW  Isolated_EM_Central_Term    1  Use_Ref_Set   0 Count_Threshold 2]
//[L1CAL_to_L1FW  Missing_Et_Term             1  Energy_Threshold 10.0]
//[L1CAL_to_L1FW  Total_Et_Term               1  Energy_Threshold 10.0]
//[L1CAL_to_L1FW  Acoplanar_Jet_Term          0  Use_Ref_Set1  1  Use_Ref_Set2      2  Min_Delta_Phi_Slices  2]
//[L1CAL_to_L1FW  NonCollinear_LowEt_Jet_Term 0  Use_Ref_Set1  1  Use_Ref_Set2      2  Min_Delta_Phi_Slices  2]
//[L1CAL_to_L1FW  NonCollinear_Mono_Jet_Term  0  Use_Ref_Set1  1  Use_Ref_Set2      2  Min_Delta_Phi_Slices  3]
//[L1CAL_to_L1FW  Back_To_Back_EM_Term        1  Use_Ref_Set   0  Min_Delta_Phi_Slices  3]
//[L1CAL_to_L1FW  Jet_Free_Term               0  Use_Ref_Set   1  Use_Ref_Set_Veto  2  Min_Delta_Phi_Slices  3]
#define     Ks_CoorCmd_L1CAL_to_L1FW                   "L1CAL_to_L1FW"
#define     Ki_CoorCmd_L1CAL_to_L1FW                    1200


//[L1CAL_to_L1FW EM_All_Term                1 Use_Ref_Set   0 Count_Threshold 4]
#define     Ks_CoorSubCmd_EM_All_Term                  "EM_All_Term"
#define     Ki_CoorSubCmd_EM_All_Term                   1210

//[L1CAL_to_L1FW EM_Central_Term            1 Use_Ref_Set   0 Count_Threshold 4]
#define     Ks_CoorSubCmd_EM_Central_Term              "EM_Central_Term"
#define     Ki_CoorSubCmd_EM_Central_Term               1215


//[L1CAL_to_L1FW Jet_All_Term               1 Use_Ref_Set   0 Count_Threshold 4]
#define     Ks_CoorSubCmd_Jet_All_Term                 "Jet_All_Term"
#define     Ki_CoorSubCmd_Jet_All_Term                  1220

//[L1CAL_to_L1FW Jet_Central_Term           1 Use_Ref_Set   0 Count_Threshold 4]
#define     Ks_CoorSubCmd_Jet_Central_Term             "Jet_Central_Term"
#define     Ki_CoorSubCmd_Jet_Central_Term              1225


//[L1CAL_to_L1FW Tau_All_Term  1 Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW Tau_All_Term  0 Use_Ref_Set  1 Use_Tau_Ratio_Set 1 Count_Threshold 1]
#define     Ks_CoorSubCmd_Tau_All_Term                 "Tau_All_Term"
#define     Ki_CoorSubCmd_Tau_All_Term                  1230

//[L1CAL_to_L1FW Tau_Central_Term  1 Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW Tau_Central_Term  0 Use_Ref_Set   1 Use_Tau_Ratio_Set 1 Count_Threshold 1]
#define     Ks_CoorSubCmd_Tau_Central_Term             "Tau_Central_Term"
#define     Ki_CoorSubCmd_Tau_Central_Term              1235


//[L1CAL_to_L1FW Isolated_EM_All_Term       1 Use_Ref_Set   0 Count_Threshold 4]
#define     Ks_CoorSubCmd_Isolated_EM_All_Term         "Isolated_EM_All_Term"
#define     Ki_CoorSubCmd_Isolated_EM_All_Term          1240

//[L1CAL_to_L1FW Isolated_EM_Central_Term   1 Use_Ref_Set   0 Count_Threshold 4]
#define     Ks_CoorSubCmd_Isolated_EM_Central_Term     "Isolated_EM_Central_Term"
#define     Ki_CoorSubCmd_Isolated_EM_Central_Term      1245


//[L1CAL_to_L1FW Missing_Et_Term            1 Energy_Threshold 10.0]
#define     Ks_CoorSubCmd_Missing_Et_Term              "Missing_Et_Term"
#define     Ki_CoorSubCmd_Missing_Et_Term               1250



//[L1CAL_to_L1FW Total_Et_Term              1 Energy_Threshold 10.0]
#define     Ks_CoorSubCmd_Total_Et_Term                "Total_Et_Term"
#define     Ki_CoorSubCmd_Total_Et_Term                 1260



//[L1CAL_to_L1FW Acoplanar_Jet_Term         0 Use_Ref_Set1 1  Use_Ref_Set2 2 Min_Delta_Phi_Slices 2]
#define     Ks_CoorSubCmd_Acoplanar_Jet_Term           "Acoplanar_Jet_Term"
#define     Ki_CoorSubCmd_Acoplanar_Jet_Term            1270


//[L1CAL_to_L1FW NonCollinear_LowEt_Jet_Term 0  Use_Ref_Set1 1 Use_Ref_Set2 2 Min_Delta_Phi_Slices 2]
#define     Ks_CoorSubCmd_NonCollinear_LowEt_Jet_Term  "NonCollinear_LowEt_Jet_Term"
#define     Ki_CoorSubCmd_NonCollinear_LowEt_Jet_Term   1275


//[L1CAL_to_L1FW NonCollinear_Mono_Jet_Term 0 Use_Ref_Set1 1 Use_Ref_Set2 2 Min_Delta_Phi_Slices 3]
#define     Ks_CoorSubCmd_NonCollinear_Mono_Jet_Term   "NonCollinear_Mono_Jet_Term"
#define     Ki_CoorSubCmd_NonCollinear_Mono_Jet_Term    1280



//[L1CAL_to_L1FW Back_To_Back_EM_Term       1 Use_Ref_Set   0 Min_Delta_Phi_Slices 3]
#define     Ks_CoorSubCmd_Back_To_Back_EM_Term         "Back_To_Back_EM_Term"
#define     Ki_CoorSubCmd_Back_To_Back_EM_Term          1285


//[L1CAL_to_L1FW Jet_Free_Term 0   Use_Ref_Set 1 Use_Ref_Set_Veto 2 Min_Delta_Phi_Slices 3]
#define     Ks_CoorSubCmd_Jet_Free_Term                "Jet_Free_Term"
#define     Ki_CoorSubCmd_Jet_Free_Term                 1290




//[L1Cal_Exclude  EM_Tower TT_Eta(20) TT_Phi(23)]
//[L1Cal_Exclude  HD_Tower TT_Eta(20) TT_Phi(23)]
#define     Ks_CoorCmd_L1Cal_Exclude                   "L1Cal_Exclude"
#define     Ki_CoorCmd_L1Cal_Exclude                    1300





//[L1Cal_Exclude  EM_Tower TT_Eta(20) TT_Phi(23)]
#define     Ks_CoorSubCmd_EM_Tower                     "EM_Tower"
#define     Ki_CoorSubCmd_EM_Tower                      1350

//[L1Cal_Exclude  HD_Tower TT_Eta(20) TT_Phi(23)]
#define     Ks_CoorSubCmd_HD_Tower                     "HD_Tower"
#define     Ki_CoorSubCmd_HD_Tower                      1360




//[L1CAL_to_L1FW Jet_All_Term               1 Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW Jet_Central_Term           1 Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW EM_All_Term                1 Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW EM_Central_Term            1 Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW Tau_All_Term               1 Use_Ref_Set   0 Use_Tau_Ratio_Set 1 Count_Threshold 2]
//[L1CAL_to_L1FW Tau_Central_Term           1 Use_Ref_Set   0 Use_Tau_Ratio_Set 1 Count_Threshold 2]
//[L1CAL_to_L1FW Isolated_EM_All_Term       1 Use_Ref_Set   0 Count_Threshold 2]
//[L1CAL_to_L1FW Isolated_EM_Central_Term   1 Use_Ref_Set   0 Count_Threshold 2]
//[L1CAL_to_L1FW Back_To_Back_EM_Term       1 Use_Ref_Set   0 Min_Delta_Phi_Slices 3]
#define     Ks_CoorKeyword_Use_Ref_Set                 "Use_Ref_Set"
#define     Ki_CoorKeyword_Use_Ref_Set                  1400

//[L1CAL_to_L1FW  Acoplanar_Jet_Term          0  Use_Ref_Set1  1  Use_Ref_Set2      2  Min_Delta_Phi_Slices  2]
//[L1CAL_to_L1FW  NonCollinear_LowEt_Jet_Term 0  Use_Ref_Set1  1  Use_Ref_Set2      2  Min_Delta_Phi_Slices  2]
//[L1CAL_to_L1FW  NonCollinear_Mono_Jet_Term  0  Use_Ref_Set1  1  Use_Ref_Set2      2  Min_Delta_Phi_Slices  3]
#define     Ks_CoorKeyword_Use_Ref_Set1                "Use_Ref_Set1"
#define     Ki_CoorKeyword_Use_Ref_Set1                 1410
#define     Ks_CoorKeyword_Use_Ref_Set2                "Use_Ref_Set2"
#define     Ki_CoorKeyword_Use_Ref_Set2                 1420

//[L1CAL_to_L1FW  Jet_Free_Term               0  Use_Ref_Set   1  Use_Ref_Set_Veto  2  Min_Delta_Phi_Slices  3]
#define     Ks_CoorKeyword_Use_Ref_Set_Veto            "Use_Ref_Set_Veto"
#define     Ki_CoorKeyword_Use_Ref_Set_Veto             1450


//[L1CAL_to_L1FW  Acoplanar_Jet_Term          0  Use_Ref_Set1  1  Use_Ref_Set2      2  Min_Delta_Phi_Slices  2]
//[L1CAL_to_L1FW  NonCollinear_LowEt_Jet_Term 0  Use_Ref_Set1  1  Use_Ref_Set2      2  Min_Delta_Phi_Slices  2]
//[L1CAL_to_L1FW  NonCollinear_Mono_Jet_Term  0  Use_Ref_Set1  1  Use_Ref_Set2      2  Min_Delta_Phi_Slices  3]
//[L1CAL_to_L1FW  Jet_Free_Term               0  Use_Ref_Set   1  Use_Ref_Set_Veto  2  Min_Delta_Phi_Slices  3]
//[L1CAL_to_L1FW  Back_To_Back_EM_Term        1  Use_Ref_Set   0  Min_Delta_Phi_Slices  3]
#define     Ks_CoorKeyword_Min_Delta_Phi_Slices        "Min_Delta_Phi_Slices"
#define     Ki_CoorKeyword_Min_Delta_Phi_Slices         1470


//[L1CAL_to_L1FW Tau_All_Term               1 Use_Ref_Set   0 Use_Tau_Ratio_Set 1 Count_Threshold 2]
//[L1CAL_to_L1FW Tau_Central_Term           1 Use_Ref_Set   0 Use_Tau_Ratio_Set 1 Count_Threshold 2]
#define     Ks_CoorKeyword_Use_Tau_Ratio_Set           "Use_Tau_Ratio_Set"
#define     Ki_CoorKeyword_Use_Tau_Ratio_Set            1480



//[L1CAL_to_L1FW Jet_All_Term               1 Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW Jet_Central_Term           1 Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW EM_All_Term                1 Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW EM_Central_Term            1 Use_Ref_Set   0 Count_Threshold 4]
//[L1CAL_to_L1FW Tau_All_Term               1 Use_Ref_Set   0 Use_Tau_Ratio_Set 1 Count_Threshold 2]
//[L1CAL_to_L1FW Tau_Central_Term           1 Use_Ref_Set   0 Use_Tau_Ratio_Set 1 Count_Threshold 2]
//[L1CAL_to_L1FW Isolated_EM_All_Term       1 Use_Ref_Set   0 Count_Threshold 2]
//[L1CAL_to_L1FW Isolated_EM_Central_Term   1 Use_Ref_Set   0 Count_Threshold 2]
#define     Ks_CoorKeyword_Count_Threshold             "Count_Threshold"
#define     Ki_CoorKeyword_Count_Threshold              1500



//[L1CAL_Algo_Param EM_Isolation_Et_Cut TT_Eta(-16:16) TT_Phi(1:32) Energy_Threshold 1.0]
//[L1CAL_Algo_Param TT_Tau_EtCore_Cut TT_Eta(-16:16) TT_Phi(1:32) Energy_Threshold 8.0]
//[L1CAL_Algo_Param TT_Global_Sum_Et_Cut TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 1.0]
//[L1CAL_to_L1FW Missing_Et_Term            1 Energy_Threshold 10.0]
//[L1CAL_to_L1FW Total_Et_Term              1 Energy_Threshold 10.0]
#define     Ks_CoorKeyword_Energy_Threshold            "Energy_Threshold"
#define     Ki_CoorKeyword_Energy_Threshold             1550



//[L1Cal_Ref_Set EM_Et_Ref_Set  0 TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 10.0]
//[L1Cal_Ref_Set Jet_Et_Ref_Set 0 TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 10.0]
//[L1Cal_Ref_Set TT_Et_Ref_Set  0 TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 10.0]
//[L1Cal_Exclude  EM_Tower TT_Eta(20) TT_Phi(23)]
//[L1Cal_Exclude  HD_Tower TT_Eta(20) TT_Phi(23)]
#define     Ks_CoorKeyword_TT_Eta                      "TT_Eta"
#define     Ki_CoorKeyword_TT_Eta                       1600

//[L1Cal_Ref_Set EM_Et_Ref_Set  0 TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 10.0]
//[L1Cal_Ref_Set Jet_Et_Ref_Set 0 TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 10.0]
//[L1Cal_Ref_Set TT_Et_Ref_Set  0 TT_Eta(-20:20) TT_Phi(1:32) Energy_Threshold 10.0]
//[L1Cal_Exclude  EM_Tower TT_Eta(20) TT_Phi(23)]
//[L1Cal_Exclude  HD_Tower TT_Eta(20) TT_Phi(23)]
#define     Ks_CoorKeyword_TT_Phi                      "TT_Phi"
#define     Ki_CoorKeyword_TT_Phi                       1650


// now only used in TRGMR messages, but historically left here 
#define     Ks_CoorKeyword_Value                       "Value"
#define     Ki_CoorKeyword_Value                        1750

