///////////////////////////////////////////////////////////////////////
// Macros shared by 
//    MessageCoorParser 
//    and MessageMgrParser 
//
// Split off 20-Sep-2005
///////////////////////////////////////////////////////////////////////


/*-------------------------------------------------------------------------------*/
//Simple Macros for Adding keywords
/////////////////////////////////////////////////////////////////////
#define ADD_COOR_COMMAND( COMMAND )                                 \
    _poTokenizer->AddEntry        ( Ks_CoorCmd_##COMMAND,           \
                                    Ki_CoorCmd_##COMMAND ) ;        \
/////////////////////////////////////////////////////////////////////
#define ADD_COOR_SUB_COMMAND( SUB_COMMAND )                         \
    _poTokenizer->AddEntry        ( Ks_CoorSubCmd_##SUB_COMMAND,    \
                                    Ki_CoorSubCmd_##SUB_COMMAND );  \
/////////////////////////////////////////////////////////////////////
#define ADD_COOR_KEYWORD( SUB_COMMAND )                             \
    _poTokenizer->AddEntry        ( Ks_CoorKeyword_##SUB_COMMAND,   \
                                    Ki_CoorKeyword_##SUB_COMMAND);  \
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
#define ADD_TRGMGR_COMMAND( COMMAND )                               \
    _poTokenizer->AddEntry        ( Ks_TrgMgrCmd_##COMMAND,         \
                                    Ki_TrgMgrCmd_##COMMAND ) ;      \
/////////////////////////////////////////////////////////////////////
#define ADD_TRGMGR_SUB_COMMAND( SUB_COMMAND )                       \
    _poTokenizer->AddEntry        ( Ks_TrgMgrSubCmd_##SUB_COMMAND,  \
                                    Ki_TrgMgrSubCmd_##SUB_COMMAND );\
/////////////////////////////////////////////////////////////////////
#define ADD_TRGMGR_KEYWORD( SUB_COMMAND )                           \
    _poTokenizer->AddEntry        ( Ks_TrgMgrKeyword_##SUB_COMMAND, \
                                    Ki_TrgMgrKeyword_##SUB_COMMAND);\
/////////////////////////////////////////////////////////////////////



/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
//Macros for error messages used in the ParseInterpret_Generic and ParseInterpret_L1Cal 
/////////////////////////////////////////////////////////////////////////////
#define ERROR_COMMON_PRE()                                                  \
    {   eReturnStatus = Reply_Bad ;                                         \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_COMMON_POST()                                                 \
        strcat ( sReplyText, " at Char #" ) ;                               \
        if ( poTokenEntry == NULL )                                         \
            poTokenEntry = _poCoorCommandLine->m_lTokenList.LastEntry( ) ;  \
        strcat ( sReplyText, I_to_A ( poTokenEntry->GetKey().uiCharNum ) ) ;\
        strcat ( sReplyText, " in Command String>" ) ;                      \
        CConsoleAccess::ErrorLine     ( sReplyText ) ;                      \
        _poCoorCommandLine->CopyReplyText ( sReplyText ) ;                  \
        goto Done ;                                                         \
    }                                                                       \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_UNEXPECTED_TOKEN()                                            \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Unexpected Token after Command" ) ;          \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_TOKEN_NOT_KEYWORD()                                           \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Token not a Keyword" ) ;                     \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_MISSING_NUMBER()                                              \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Missing Number after Keyword" ) ;            \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_NUMBER_NOT_ASSERTED()                                         \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Expected Asserted Number" ) ;                \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_MISSING_NUMBER_LIST()                                         \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Missing Number List" ) ;                     \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_OBJECT_NUMBER_OUT_OF_RANGE()                                  \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Object Number Out of Range" ) ;              \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_MISSING_UPPER_BOUND()                                         \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Missing Upper Bound of Item Range" ) ;       \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_OPPOSITE_POLARITIES()                                         \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Opposite Polarities in Range Bounds" ) ;     \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_MISSING_SUB_KEYWORD()                                         \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Missing Sub Keyword" ) ;                     \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_ILLEGAL_SUB_KEYWORD()                                         \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Sub Keyword Illegal Here" ) ;                \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_SUB_KEYWORD_ONLY_FOR_ASSERTED_OBJECTS()                       \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Sub Keyword Accepts Only Asserted Objects" );\
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_KEYWORD_ILLEGAL_AT_START()                                    \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Keyword Illegal at Start of Command" );      \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_MISSING_OPEN_PARENTHESIS()                                    \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Missing Open Parenthesis" ) ;                \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_MISSING_CLOSE_PARENTHESIS()                                   \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Missing Close Parenthesis" ) ;               \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_ILLEGAL_TAB_CHIP_RANGE()                                      \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<TT Range Illegal wrt. TAB Chip" ) ;        \
        strcat ( sReplyText, " in Command String>" ) ;                      \
        CConsoleAccess::ErrorLine     ( sReplyText ) ;                      \
        _poCoorCommandLine->CopyReplyText ( sReplyText ) ;                  \
        goto Done ;                                                         \
    }                                                                       \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_ILLEGAL_POWER_OF_2()                                          \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Illegal Ratio for Power Of 2" ) ;            \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
#define ERROR_ILLEGAL_VALUE()                                               \
        ERROR_COMMON_PRE()                                                  \
        strcpy ( sReplyText, "<Illegal Value" ) ;                           \
        ERROR_COMMON_POST()                                                 \
/////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////
#define SWAP_UI_VALUES( uiValue1, uiValue2 )                                \
    {                                                                       \
        unsigned int uitemp ;                                               \
        uitemp   = uiValue1 ;                                               \
        uiValue1 = uiValue2 ;                                               \
        uiValue2 = uitemp ;                                                 \
    }                                                                       \
/////////////////////////////////////////////////////////////////////////////




/////////////////////////////////////////////////////////////////////////////////////////////
#define GET_TAB_REFSET_NUMBER( COPY_HERE )                                                  \
                                                                                            \
            poTokenEntry = _poCoorCommandLine->m_lTokenList.NextEntry( poTokenEntry ) ;     \
                                                                                            \
            if ( poTokenEntry == NULL )                                                     \
                ERROR_MISSING_NUMBER() ;                                                    \
                                                                                            \
            eTokenType = poTokenEntry->GetKey().eTokenType ;                                \
                                                                                            \
            if ( eTokenType != TokenIsValueAsserted )                                       \
                ERROR_NUMBER_NOT_ASSERTED() ;                                               \
                                                                                            \
            uiRefSetNum = poTokenEntry->GetValue ( ) ;                                      \
                                                                                            \
            if ( ( uiRefSetNum < KiMinIndexInCoorCmd_RefSet_Tab )                           \
              || ( uiRefSetNum > KiMaxIndexInCoorCmd_RefSet_Tab ) )                         \
              ERROR_OBJECT_NUMBER_OUT_OF_RANGE() ;                                          \
                                                                                            \
            /*copy the Ref Set Number */                                                    \
            COPY_HERE = uiRefSetNum ;                                                       \
                                                                                            \
/////////////////////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////////////////////////
#define PARSE_TT_RANGE( LABEL_Look_For_TT_Range )                                               \
                /*** Next Token should be an open parenthesis                               ***/\
                poTokenEntry = _poCoorCommandLine->m_lTokenList.NextEntry( poTokenEntry ) ;     \
                                                                                                \
                if ( poTokenEntry == NULL )                                                     \
                    ERROR_MISSING_OPEN_PARENTHESIS() ;                                          \
                                                                                                \
                eTokenType = poTokenEntry->GetKey().eTokenType ;                                \
                                                                                                \
                if ( eTokenType != TokenIsOpenParenthesis )                                     \
                    ERROR_MISSING_OPEN_PARENTHESIS() ;                                          \
                                                                                                \
                                                                                                \
                /*** Next Token should be a Positive or Negative Value or Lower Bound       ***/\
                poTokenEntry = _poCoorCommandLine->m_lTokenList.NextEntry( poTokenEntry ) ;     \
                                                                                                \
                while ( poTokenEntry != NULL )                                                  \
                {                                                                               \
                                                                                                \
                    eTokenType = poTokenEntry->GetKey().eTokenType ;                            \
                                                                                                \
                    /*** get this out of the way so that the rest must be numbers and ranges***/\
                    if ( eTokenType == TokenIsCloseParenthesis )                                \
                    {                                                                           \
                        /*** Get the next token before jumping to interpret rest of command ***/\
                        poTokenEntry = _poCoorCommandLine->m_lTokenList.NextEntry(poTokenEntry);\
                        goto LABEL_Look_For_TT_Range ;                                          \
                    }                                                                           \
                                                                                                \
                    uiItemIndex = poTokenEntry->GetValue ( ) ;                                  \
                                                                                                \
                    /*** check index magnitude                                              ***/\
                    if ( ( ( uiKeyword == Ki_CoorKeyword_TT_Eta )                               \
                        && ( ( uiItemIndex < KiMin_TT_Eta_Magn )                                \
                          || ( uiItemIndex > KiMax_TT_Eta_Magn ) ) )                            \
                      || ( ( uiKeyword == Ki_CoorKeyword_TT_Phi )                               \
                        && ( ( uiItemIndex < KiMin_TT_Phi )                                     \
                          || ( uiItemIndex > KiMax_TT_Phi ) ) ) )                               \
                        ERROR_OBJECT_NUMBER_OUT_OF_RANGE() ;                                    \
                                                                                                \
                    switch ( eTokenType )                                                       \
                    {                                                                           \
                    /*** plain indices                                                      ***/\
                    case TokenIsValueAsserted :                                                 \
                        if ( uiKeyword == Ki_CoorKeyword_TT_Eta )                               \
                            poCoorCommand->m_xTT.aalTT_Eta[eTT_Eta_Pos][uiItemIndex] = true ;   \
                        else /* ( uiKeyword == Ki_CoorKeyword_TT_Phi ) */                       \
                            poCoorCommand->m_xTT.alTT_Phi[uiItemIndex] = true ;                 \
                        break ;                                                                 \
                                                                                                \
                    case TokenIsValueNegated :                                                  \
                        if ( uiKeyword == Ki_CoorKeyword_TT_Eta )                               \
                            poCoorCommand->m_xTT.aalTT_Eta[eTT_Eta_Neg][uiItemIndex] = true ;   \
                        else /* ( uiKeyword == Ki_CoorKeyword_TT_Phi ) */                       \
                            ERROR_NUMBER_NOT_ASSERTED() ;                                       \
                        break ;                                                                 \
                                                                                                \
                    /*** Lower Bounds                                                       ***/\
                    case TokenIsValueLower :                                                    \
                    case TokenIsValueLowerNeg :                                                 \
                                                                                                \
                        uiItemIndexLower = uiItemIndex ;                                        \
                                                                                                \
                        /*** Remember if the lower bound was a positive or negative         ***/\
                        if ( eTokenType == TokenIsValueLower )                                  \
                            ePolarityIndexLower = eTT_Eta_Pos ;                                 \
                        else /* eTokenType == TokenIsValueLowerNeg ) */                         \
                            ePolarityIndexLower = eTT_Eta_Neg ;                                 \
                                                                                                \
                        /*** Next token should be the upper bound                           ***/\
                        poTokenEntry = _poCoorCommandLine->m_lTokenList.NextEntry(poTokenEntry);\
                                                                                                \
                        if ( poTokenEntry == NULL )                                             \
                            ERROR_MISSING_UPPER_BOUND() ;                                       \
                                                                                                \
                        eTokenType = poTokenEntry->GetKey().eTokenType ;                        \
                                                                                                \
                        /*** Remember if the upper bound was a positive or negative         ***/\
                        if ( eTokenType == TokenIsValueUpper )                                  \
                            ePolarityIndexUpper = eTT_Eta_Pos ;                                 \
                        else if ( eTokenType == TokenIsValueUpperNeg )                          \
                            ePolarityIndexUpper = eTT_Eta_Neg ;                                 \
                        else                                                                    \
                            ERROR_MISSING_UPPER_BOUND() ;                                       \
                                                                                                \
                        /*** Remember if the upper bound                                    ***/\
                        uiItemIndexUpper = poTokenEntry->GetValue ( ) ;                         \
                                                                                                \
                        /*** check index magnitude                                          ***/\
                        if ( ( ( uiKeyword == Ki_CoorKeyword_TT_Eta )                           \
                            && ( ( uiItemIndexUpper < KiMin_TT_Eta_Magn )                       \
                              || ( uiItemIndexUpper > KiMax_TT_Eta_Magn ) ) )                   \
                          || ( ( uiKeyword == Ki_CoorKeyword_TT_Phi )                           \
                            && ( ( uiItemIndexUpper < KiMin_TT_Phi )                            \
                              || ( uiItemIndexUpper > KiMax_TT_Phi ) ) ) )                      \
                            ERROR_OBJECT_NUMBER_OUT_OF_RANGE() ;                                \
                                                                                                \
                        /*** fill Eta Range while watching for crossing index zero          ***/\
                        if ( uiKeyword == Ki_CoorKeyword_TT_Eta )                               \
                        {                                                                       \
                            if ( ePolarityIndexLower == ePolarityIndexUpper )                   \
                            {                                                                   \
                                if ( uiItemIndexLower > uiItemIndexUpper )                      \
                                    SWAP_UI_VALUES( uiItemIndexLower, uiItemIndexUpper ) ;      \
                                                                                                \
                                for ( uiItemIndex  = uiItemIndexLower ;                         \
                                      uiItemIndex <= uiItemIndexUpper ;                         \
                                      uiItemIndex ++ )                                          \
                                poCoorCommand->m_xTT.aalTT_Eta[ePolarityIndexLower][uiItemIndex]\
                                    = true ;                                                    \
                            }                                                                   \
                            else /* ( ePolarityIndexLower != ePolarityIndexUpper ) */           \
                            {                                                                   \
                                for ( uiItemIndex  = 1 ;                                        \
                                      uiItemIndex <= uiItemIndexLower ;                         \
                                      uiItemIndex ++ )                                          \
                                poCoorCommand->m_xTT.aalTT_Eta[ePolarityIndexLower][uiItemIndex]\
                                    = true ;                                                    \
                                                                                                \
                                for ( uiItemIndex  = 1 ;                                        \
                                      uiItemIndex <= uiItemIndexUpper ;                         \
                                      uiItemIndex ++ )                                          \
                                poCoorCommand->m_xTT.aalTT_Eta[ePolarityIndexUpper][uiItemIndex]\
                                    = true ;                                                    \
                            }                                                                   \
                        }                                                                       \
                        /*** fill Phi Range                                                 ***/\
                        else /* ( uiKeyword == Ki_CoorKeyword_TT_Phi ) */                       \
                        {   /*Attention: we used ETT_Eta_Sign instead of ESignalState */        \
                            if ( ( ePolarityIndexLower != eTT_Eta_Pos )                         \
                              || ( ePolarityIndexUpper != eTT_Eta_Pos ) )                       \
                            ERROR_NUMBER_NOT_ASSERTED() ;                                       \
                                                                                                \
                            if ( uiItemIndexLower > uiItemIndexUpper )                          \
                                SWAP_UI_VALUES( uiItemIndexLower, uiItemIndexUpper ) ;          \
                                                                                                \
                            for ( uiItemIndex  = uiItemIndexLower ;                             \
                                  uiItemIndex <= uiItemIndexUpper ;                             \
                                  uiItemIndex ++ )                                              \
                                poCoorCommand->m_xTT.alTT_Phi[uiItemIndex] = true ;             \
                        }                                                                       \
                        break ;                                                                 \
                                                                                                \
                    default :                                                                   \
                        ERROR_UNEXPECTED_TOKEN() ;                                              \
                                                                                                \
                    } /* switch ( eTokenType ) */                                               \
                                                                                                \
                    /*** Get the next token before "while" test                             ***/\
                    poTokenEntry = _poCoorCommandLine->m_lTokenList.NextEntry( poTokenEntry ) ; \
                                                                                                \
                }/* while ( poTokenEntry != NULL ) */                                           \
                                                                                                \
                ERROR_MISSING_CLOSE_PARENTHESIS() ;                                             \
/////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////
#define GET_THRESHOLD_FLOAT_VALUE()                                                             \
            /*** first token is always the integral part of the threhold                    ***/\
            poTokenEntry = _poCoorCommandLine->m_lTokenList.NextEntry( poTokenEntry ) ;         \
                                                                                                \
            if ( poTokenEntry == NULL )                                                         \
                ERROR_MISSING_NUMBER() ;                                                        \
                                                                                                \
            eTokenType = poTokenEntry->GetKey().eTokenType ;                                    \
                                                                                                \
            if ( eTokenType != TokenIsValueAsserted )                                           \
                ERROR_NUMBER_NOT_ASSERTED() ;                                                   \
                                                                                                \
            /*** copy the integer part of the Ref Set Threshold Value                       ***/\
            poCoorCommand->m_fdThreshold = (double) poTokenEntry->GetValue ( ) ;                \
                                                                                                \
            /*** there may be an additional token for the decimal part                      ***/\
            poTokenEntry = _poCoorCommandLine->m_lTokenList.NextEntry( poTokenEntry ) ;         \
                                                                                                \
            if ( poTokenEntry != NULL )                                                         \
            {                                                                                   \
                eTokenType = poTokenEntry->GetKey().eTokenType ;                                \
                                                                                                \
                if ( eTokenType == TokenIsValueDecimal )                                        \
                {                                                                               \
                                                                                                \
                    /*** compute the location of the decimal point                          ***/\
                    const char* pcDecimalPoint ;                                                \
                    pcDecimalPoint = _poCoorCommandLine->GetAtChar(                             \
                                                poTokenEntry->GetKey().uiCharNum - 1 ) ;        \
                    /*** convert the string to double float and add it to the integral part ***/\
                    char* pcEndChar ;                                                           \
                    poCoorCommand->m_fdThreshold +=  strtod ( pcDecimalPoint, &pcEndChar ) ;    \
                                                                                                \
                    /*** get the next token                                                 ***/\
                    poTokenEntry = _poCoorCommandLine->m_lTokenList.NextEntry( poTokenEntry ) ; \
                }                                                                               \
            }                                                                                   \
                                                                                                \
            /*** if we reached the end of the line we "rewind" to the last token            ***/\
            if ( poTokenEntry == NULL )                                                         \
                poTokenEntry = _poCoorCommandLine->m_lTokenList.LastEntry( ) ;                  \
                                                                                                \
/////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////
#define GET_THRESHOLD_INT_VALUE()                                                               \
            /*** first token is always the integral part of the threhold                    ***/\
            poTokenEntry = _poCoorCommandLine->m_lTokenList.NextEntry( poTokenEntry ) ;         \
                                                                                                \
            if ( poTokenEntry == NULL )                                                         \
                ERROR_MISSING_NUMBER() ;                                                        \
                                                                                                \
            eTokenType = poTokenEntry->GetKey().eTokenType ;                                    \
                                                                                                \
            if ( eTokenType != TokenIsValueAsserted )                                           \
                ERROR_NUMBER_NOT_ASSERTED() ;                                                   \
                                                                                                \
            /*** copy the integer part of the Ref Set Threshold Value                       ***/\
            poCoorCommand->m_uiValue = poTokenEntry->GetValue ( ) ;                             \
                                                                                                \
/////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
#define FILL_ETA_RANGE_IF_OMITTED()                                                         \
    {                                                                                       \
        bool    lEtaRangeEmpty = true ;                                                     \
        for ( uiItemIndex  = KiMin_TT_Eta_Magn ;                                            \
              uiItemIndex <= KiMax_TT_Eta_Magn ;                                            \
              uiItemIndex ++ )                                                              \
        if ( ( poCoorCommand->m_xTT.aalTT_Eta[eTT_Eta_Pos][uiItemIndex] == true )           \
          || ( poCoorCommand->m_xTT.aalTT_Eta[eTT_Eta_Neg][uiItemIndex] == true ) )         \
        {                                                                                   \
            lEtaRangeEmpty = false ;                                                        \
            break ;                                                                         \
        }                                                                                   \
        if ( lEtaRangeEmpty ) /*implicitly fill in current coverage but never eta 19,20*/   \
        {                     /*eta 19,20 must always be explictely specified */            \
            unsigned long   ulTTEtaSign ;                                                   \
            unsigned long   ulTTEtaMagn ;                                                   \
            for ( ulTTEtaSign  = CL1Cal::mg_poL1Cal->f_ulTTEtaSignMin () ;                  \
                  ulTTEtaSign <= CL1Cal::mg_poL1Cal->f_ulTTEtaSignMax () ;                  \
                  ulTTEtaSign++ )                                                           \
            for ( ulTTEtaMagn  = CL1Cal::mg_poL1Cal->f_ulTTEtaMagnMin () ;                  \
                 (ulTTEtaMagn <= CL1Cal::mg_poL1Cal->f_ulTTEtaMagnMax ())/*implicit covrge*/\
               &&(ulTTEtaMagn <= KiMax_TT_Eta_Normal ) ; /*eta=19,20 not implicitely added*/\
                  ulTTEtaMagn++ )                                                           \
                poCoorCommand->m_xTT.aalTT_Eta[ulTTEtaSign][ulTTEtaMagn] = true ;           \
        }                                                                                   \
    }                                                                                       \
/////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////////////
#define FILL_PHI_RANGE_IF_OMITTED()                                                         \
    {                                                                                       \
        bool    lPhiRangeEmpty = true ;                                                     \
        for ( uiItemIndex  = KiMin_TT_Phi ; uiItemIndex <= KiMax_TT_Phi ; uiItemIndex ++ )  \
        if ( poCoorCommand->m_xTT.alTT_Phi[uiItemIndex] == true )                           \
        {                                                                                   \
            lPhiRangeEmpty = false ;                                                        \
            break ;                                                                         \
        }                                                                                   \
        if ( lPhiRangeEmpty )                                                               \
        {                                                                                   \
            unsigned long   ulTTPhi ;                                                       \
            for ( ulTTPhi      = CL1Cal::mg_poL1Cal->f_ulTTPhiMin () ;                      \
                  ulTTPhi     <= CL1Cal::mg_poL1Cal->f_ulTTPhiMax () ;                      \
                  ulTTPhi++ )                                                               \
                poCoorCommand->m_xTT.alTT_Phi[ulTTPhi] = true ;                             \
        }                                                                                   \
    }                                                                                       \
/////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////////////
#define CHECK_NEXT_TOKEN_IS_KEYWORD( KEYWORDCODE )                                          \
                                                                                            \
            poTokenEntry = _poCoorCommandLine->m_lTokenList.NextEntry( poTokenEntry ) ;     \
                                                                                            \
            if ( poTokenEntry == NULL )                                                     \
                ERROR_MISSING_SUB_KEYWORD() ;                                               \
                                                                                            \
            eTokenType = poTokenEntry->GetKey().eTokenType ;                                \
                                                                                            \
            if ( eTokenType != TokenIsKeyword )                                             \
                ERROR_MISSING_SUB_KEYWORD() ;                                               \
                                                                                            \
            if ( poTokenEntry->GetValue() != KEYWORDCODE )                                  \
              ERROR_ILLEGAL_SUB_KEYWORD() ;                                                 \
                                                                                            \
/////////////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////////////////////
#define GET_GAB_REFSET_NUMBER( COPY_HERE )                                                  \
                                                                                            \
            poTokenEntry = _poCoorCommandLine->m_lTokenList.NextEntry( poTokenEntry ) ;     \
                                                                                            \
            if ( poTokenEntry == NULL )                                                     \
                ERROR_MISSING_NUMBER() ;                                                    \
                                                                                            \
            eTokenType = poTokenEntry->GetKey().eTokenType ;                                \
                                                                                            \
            if ( eTokenType != TokenIsValueAsserted )                                       \
                ERROR_NUMBER_NOT_ASSERTED() ;                                               \
                                                                                            \
            uiRefSetNum = poTokenEntry->GetValue ( ) ;                                      \
                                                                                            \
            if ( ( uiRefSetNum < KiMinIndexInCoorCmd_RefSet_Gab )                           \
              || ( uiRefSetNum > KiMaxIndexInCoorCmd_RefSet_Gab ) )                         \
              ERROR_OBJECT_NUMBER_OUT_OF_RANGE() ;                                          \
                                                                                            \
            /*copy the Ref Set Number */                                                    \
            COPY_HERE = uiRefSetNum ;                                                       \
                                                                                            \
/////////////////////////////////////////////////////////////////////////////////////////////


