/*-------------------------------------------------------------------------------*/
  /*
    MonitPoolData.h
    11-Oct-2005
  */
/*-------------------------------------------------------------------------------*/

// Monitoring Data Record definition
#define NT_MSVCPP // direct L1CalTcc_MonitData.hpp in the definition of 64 bit variables

#include "trigmon/L1CalTcc_MonitData.hpp"

class CMonitPoolData
{
/////////////////////////////
// Constructor/Destructor
public:

     CMonitPoolData ();

    ~CMonitPoolData ();

/////////////////////////////
// Attributes
#if ( defined ( VME_IO_NONE ) || defined ( VME_IO_FAKE ) ) 
public:
#else
private:
#endif

    // common components used in several blocks below
    static  L1CalTcc_Block_Header              mg_xHeader ;
    static  L1CalTcc_BeamX_Number              mg_xBeamX ;

    // L1 Cal Monitoring Data
    static  L1CalTcc_Block_Adf_OutputEt        mg_xBlock_Adf_Et ;
    static  L1CalTcc_Block_TabGab_Status       mg_xBlock_TabGab_Status ;

public:

    // a map to go from the 36 populated bunches to their tick number
    static  const unsigned long                mg_aIndexToTick [kL1CalTcc_Tot_LiveBX] ;

/////////////////////////////
// Operations
public:

    static  ESuccess  UpdateMonitData             ( EYesNo              _eynTriggered,
                                                    EYesNo              _eynFillBlankData ) ;


    static  ESuccess  RetrieveAdfOutputEt         ( L1CalTcc_Block_Adf_OutputEt*        _pxBlock_Adf_Et ) ;

    static  ESuccess  RetrieveTabGabStatus        ( L1CalTcc_Block_TabGab_Status*       _pxBlock_TabGab_Status  ) ;

};
