/*-------------------------------------------------------------------------------*/
  /*
    MonitPoolManager.h
    11-Oct-2005
  */
#ifndef __MonitPoolManager__
#define __MonitPoolManager__
/*-------------------------------------------------------------------------------*/

#include "thread_util/Thread.hpp"
#include "thread_util/Thread_Util.hpp"
using     namespace thread_util ;

//#include "L1Cal_IIb_TCC/ListOfL1fwCardAddresses.h" // for the LED Line-up
//#include "L1Cal_IIb_TCC/TemplateLedLineUp.h" 

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
using namespace thread_util ; //needed when switched to thread_util V00-10-01

class CMonitPoolManagerThread : public Thread
{
public:

    CMonitPoolManagerThread () ;
   ~CMonitPoolManagerThread () ;

public:

    //LED Line-up for L1 Accept Scaler
//    TLedLineUp <20> *m_poLedL1Accept ;

    // Remember when the last time the Moni Data was Captured (in milliseconds)
    // This is a volatile variable as it may be changed by another thread (maybe in the future)
    static volatile uint64   mg_uqmsTimeLastCapture ;

protected:

    //Flag showing that Monit Pool is serving Blank Data
    EYesNo          m_eynFillBlankData ;
    EYesNo          m_eynBlankDataDone ;

public:

    // There is only one Monit Pool Manager running, this is a pointer to it
    static CMonitPoolManagerThread*  mg_pMonitPoolManager ;

public:

    virtual void* run () ;

} ;


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
#endif // __MonitPoolManager__
