/*-------------------------------------------------------------------------------*/
  /*
    NevisCard.h
    Class CNevisCard
    06-Apr-2006
  */
#ifndef __NevisCard__
#define __NevisCard__
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/NevisTabChip.h"
#include "L1Cal_IIb_TCC/HsroVrbCard.h"
#include "tabgab/tcc_to_tabgab.h"

/*-------------------------------------------------------------------------------*/

// a general purpose routine to report the status from a tabgab routine

ESuccess ReportTabGabStatus ( EStatus   _eStatus,
                              CString   _osTabGabRoutineName, 
                              CString   _osCallingRoutineName ) ;

/*-------------------------------------------------------------------------------*/

class CNevisCard : public CHsroChannel 
{
/////////////////////////////
// Constructor/Destructor
public:

            CNevisCard ( unsigned char   _ubModuleNum,       // the VME SCL Module Num for this card
                         CString*        _posCardDescription = NULL ) ; 

            ~CNevisCard ( );

protected:


/////////////////////////////
// Attributes
public:

    //String describing the card functionality
    CString             m_osCardDescription ;

protected:

    unsigned char       m_ubModuleNum ;

    EYesNo              m_ynThisCardReadout ; 

/////////////////////////////
// Operations
public:

    ESuccess            Initialize        ( ) ;

    TCString            f_osModuleNum     ( ) ; // e.g. return "@Module#0"
    unsigned char       f_ubModuleNum     ( ) { return m_ubModuleNum ; } ;

    EYesNo              f_ynThisCardReadout ( ) { return m_ynThisCardReadout ; } ;



protected:

///////////////////////////////////////////
// Access Privileges outside of this class

// special access privilege so that CHsroChannel::FurtherConstruct  
// can set the m_ynThisCardReadout flag 
friend class CHsroChannel ;

};

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
#endif // __NevisCard__
