/*-------------------------------------------------------------------------------*/
  /*
    NevisTabCard.h
    Class CNevisTabCard
    14-Sep-2005
  */
#ifndef __NevisTabCard__
#define __NevisTabCard__
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/NevisCard.h"
#include "L1Cal_IIb_TCC/NevisTabChip.h"
#include "L1Cal_IIb_TCC/HsroChannel.h"

/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/

class CNevisTabCard : public CNevisCard
{
/////////////////////////////
// Constructor/Destructor

public:

            CNevisTabCard ( unsigned char   _ubModuleNum,       // the VME SCL Module Num for this card
                            CString*        _posCardDescription = NULL,
                            unsigned long   _ulTTPhi_By4        = 0 ) ; 

           ~CNevisTabCard ( );

protected:


/////////////////////////////
// Attributes

public:

    //The Trigger Towers serviced by this card
    unsigned char       m_ulTTPhiBy4 ;      // the phi segment 0=1:4, 1=5:8, etc

    // The Main Array Data handling FPGAs
    CNevisTabChip*      m_apoMaFpga[eTot_TT_Eta_Sign][eTot_TT_Eta_By4] ;

protected:

/////////////////////////////
// Operations

public:

    ESuccess        Initialize         ( ) ;

    ESuccess        CaptureChLinkStatus         ( ) ;

    ESuccess        VerifyChLinkStatus          ( EYesNo          _eDeSkewAsNeeded = No,
                                                  EYesNo          _eForConsistency = No ) ;
    
    ESuccess        VerifyChLink_DeSkewAsNeeded ( )  
                                                    { EYesNo   eDeSkewAsNeeded = Yes ;
                                                      EYesNo   eForConsistency = No ;
                                                      return   VerifyChLinkStatus ( eDeSkewAsNeeded, 
                                                                                    eForConsistency ) ; } ;

    ESuccess        VerifyChLink_ForConsistency ( )  
                                                    { EYesNo   eDeSkewAsNeeded = No ;
                                                      EYesNo   eForConsistency = Yes ;
                                                      return   VerifyChLinkStatus ( eDeSkewAsNeeded, 
                                                                                    eForConsistency ) ; } ;

protected:

///////////////////////////////////////////
// Access Privileges outside of this class

// special access privilege so that the Chip constructor 
// can read the Module address, etc 
friend class CNevisTabChip ;

};

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
#endif // __NevisTabCard__
