/*-------------------------------------------------------------------------------*/
  /*
    ResourceLocks.h
    Class CResourceLocks
    29-Nov-2000
  */
/*-------------------------------------------------------------------------------*/

class ACE_Thread_Mutex ; // forward declaration

class CResourceLocks
{
/////////////////////////////
// Constructor/Destructor
public:

/////////////////////////////
// Attributes
public:

    // A Mutex protection used to synchronize writing messages to the screen
    static  ACE_Thread_Mutex                mg_oMutexScreenIO ;

    // A Mutex protection used to synchronize the Nevis Screen IO interface
    static  ACE_Thread_Mutex                mg_oMutexNevisScreenIO ;

    // A Mutex protection used to synchronize writing messages to the LogFile
    static  ACE_Thread_Mutex                mg_oMutexLogFile ;

    // A Mutex protection used to prevent a thread from changing
    // the status of the L1FW to NON-Operational at critical times
    static  ACE_Thread_Mutex                mg_oMutexL1CalOperational ;

    // A Mutex protection used to prevent interference during Trigger IO.
    static  ACE_Thread_Mutex                mg_oMutexTriggerIO ;

    // A Mutex protection used to prevent the Monit Data Pool
    // to be updated while it is being served or vice versa
    static  ACE_Thread_Mutex                mg_oMutexMonitDataPool ;

    // A Mutex protection used to prevent a new Monit Data Capture
    // until the Monit data has all been readout by the requester
    static  ACE_Thread_Mutex                mg_oMutexCaptureMonitData ;

/////////////////////////////
// Operations
public:

    static  ESuccess  Acquire_LogFile ( ) ;
    static  ESuccess  TryAcquire_LogFile ( ) ;
    static  ESuccess  Release_LogFile ( ) ;

    static  ESuccess  Acquire_ScreenIO ( ) ;
    static  ESuccess  TryAcquire_ScreenIO ( ) ;
    static  ESuccess  Release_ScreenIO ( ) ;

    static  ESuccess  Acquire_NevisScreenIO ( ) ;
    static  ESuccess  TryAcquire_NevisScreenIO ( ) ;
    static  ESuccess  Release_NevisScreenIO ( ) ;

    static  ESuccess  Acquire_L1CalOperational ( ) ;
    static  ESuccess  TryAcquire_L1CalOperational ( ) ;
    static  ESuccess  Release_L1CalOperational ( ) ;

    static  ESuccess  Acquire_TriggerIO ( ) ;       // unused so far
    static  ESuccess  TryAcquire_TriggerIO ( ) ;
    static  ESuccess  Release_TriggerIO ( ) ;

    static  ESuccess  Acquire_MonitDataPool ( ) ;
    static  ESuccess  TryAcquire_MonitDataPool ( ) ;
    static  ESuccess  Release_MonitDataPool ( ) ;

    static  ESuccess  Acquire_CaptureMonitData ( ) ;
    static  ESuccess  TryAcquire_CaptureMonitData ( ) ;
    static  ESuccess  Release_CaptureMonitData ( ) ;

};

