// StdAfx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

/*-------------------------------------------------------------------------------*/
#if defined (__STDAFX__) // prevent double definition
#else
    #define __STDAFX__

/*-------------------------------------------------------------------------------*/

#ifdef WIN32

    //DZero specific compile flags needed for DZero code on Win32
    #include "/projects/DZero_PreProcessor_Flags.h"

#else

    #if !defined ( Linux ) 
        #define Linux               // define platform
    #endif

    #define NO_MS_CSTRING       // use std::string to implement CString
    #define NO_MS_CONSOLE       // no control of the console, e.g. colors

//    #define VME_IO_FAKE         // use Fake IO to memory
    #define VME_IO_BIT3_MMAP    // use Memory Map

    #define SITE_DZERO          // dzero site e.g. for card coordinates

#endif

//Global Constants used various places
#include "L1Cal_IIb_TCC/GlobalConstants.h"

//Custom Data Type Definitions
#include "L1Cal_IIb_TCC/CustomDataTypes.h"

// include the standard library
#include <stdlib.h>

//use with  UpdateData() & DoDataExchange() to write to screen or to read from screen
#define KWriteToScreen FALSE
#define KReadFromScreen TRUE


// vesion information
#include "L1Cal_IIb_TCC/L1Cal_IIb_TCC_Version.h"


// Things defined in MS MFC, but not in ANSI
#if defined ( NO_MS_CSTRING )

    // Replace MS CString usage with standard library string
    #include "L1Cal_IIb_TCC/HandleCString.h"

    // Standard constants
    #undef  FALSE
    #define FALSE   0

    #undef  TRUE
    #define TRUE    1

#endif


// define Sleep for unix version
#ifdef WIN32
#else
    void Sleep( unsigned long milliseconds ) ;
#endif

// define usleep (used by tab software) for windows version
#ifdef WIN32
    int usleep(unsigned int microseconds) ;
#endif




// Things defined in MS CPP, but not in ANSI
#ifdef WIN32
#else

    // Standard constants
//    #undef  NULL
//    #define NULL    0

    //from STDLIB.H
    #define _MAX_FNAME  256 /* max. length of file name component */
    #define _MAX_DIR    256 /* max. length of path component */

#endif



#ifdef WIN32

    #define _X86_
    #define WINVER 0x0400
    #include <windef.h>
    #include <winbase.h>

#endif

/*-------------------------------------------------------------------------------*/
#endif //__STDAFX__
