/*-------------------------------------------------------------------------------*/
  /*
     TemplateBinome.h
     Template Class TBinomialEntry
     19-Oct-99
  */
#ifndef __TemplateBinome__
#define __TemplateBinome__
/*-------------------------------------------------------------------------------*/
#include <string.h>

//Global Constants used various places
#include "L1Cal_IIb_TCC/GlobalConstants.h"

//Custom Data Type Definitions
#include "L1Cal_IIb_TCC/CustomDataTypes.h"

#if !defined Win32 
    #include "L1Cal_IIb_TCC/UtilsStrings.h"  // for stricmp
#endif

template < class T_Key, class T_Value > class TBinomialEntry
{
/////////////////////////////
// Constructor/Destructor
public:

	 TBinomialEntry   ( const T_Key*                            _poEntryKey, 
                        const T_Value*                          _poEntryValue,
                        TBinomialEntry < T_Key, T_Value > *     _poLinkPrev = NULL ) 
                                    { 
                                        if ( _poEntryKey   == NULL ) 
                                            m_poEntryKey   = new T_Key ;
                                        else
                                            m_poEntryKey   = new T_Key   ( *_poEntryKey ) ;
    
                                        if ( _poEntryValue == NULL ) 
                                            m_poEntryValue = new T_Value ;
                                        else
                                            m_poEntryValue = new T_Value ( *_poEntryValue ) ;

                                        m_poLinkPrev   = _poLinkPrev ; 
                                        m_poLinkNext   = NULL ; 
                                    } ;

    ~TBinomialEntry   () 
                                    { 
                                        delete m_poEntryKey ;
                                        delete m_poEntryValue ; 
                                    } ;

/////////////////////////////
// Attributes
public:

private:

    T_Key*                                  m_poEntryKey ;
    T_Value*                                m_poEntryValue ;

    TBinomialEntry < T_Key, T_Value > *     m_poLinkPrev ;
    TBinomialEntry < T_Key, T_Value > *     m_poLinkNext ;

/////////////////////////////
// Operations
public:

    const T_Key         GetKey        ( )        const { return *m_poEntryKey   ; } ;

    const T_Value       GetValue      ( )        const { return *m_poEntryValue ; } ;

    T_Key*              GetAtKey      ( )        { return m_poEntryKey   ; } ;

    T_Value*            GetAtValue    ( )        { return m_poEntryValue ; } ;

    TBinomialEntry < T_Key, T_Value > *   
                        GetNext       ( )        const { return m_poLinkNext   ; } ; 

    TBinomialEntry < T_Key, T_Value > *   
                        GetPrev       ( )        const { return m_poLinkPrev   ; } ;

    void                SetLinkNext   ( TBinomialEntry < T_Key, T_Value > *  _poLinkNext )
                                                 { m_poLinkNext = _poLinkNext ; return ; } ;

    EYesNo              MatchKey      ( const T_Key*  _poEntryKey )    
                                                 const { if ( *_poEntryKey == *m_poEntryKey ) 
                                                             return Yes ;
                                                         else
                                                             return No ;
                                                        } ;

    void                ModifyKey        ( const T_Key*   _poEntryKey )       { *m_poEntryKey   = *_poEntryKey   ; return ; } ;

    void                ModifyValue      ( const T_Value* _poEntryValue )     { *m_poEntryValue = *_poEntryValue ; return ; } ;

} ;

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
#endif // __TemplateBinome__
