/*-------------------------------------------------------------------------------*/
  /*
     TemplateDictionary.h
     Template Class TDictionary
     19-Oct-99
  */
#ifndef __TemplateDictionary__
#define __TemplateDictionary__
/*-------------------------------------------------------------------------------*/

//Simple List Template
#include "L1Cal_IIb_TCC/TemplateList.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

template < class T_Key, class T_Value > class TDictionary : TList < T_Key, T_Value >
{
/////////////////////////////
// Constructor/Destructor

public:

    TDictionary    ( ) { m_poCachedLastAccessed = NULL ; } ;

    ~TDictionary    ( ) { } ;

/////////////////////////////
// Attributes

public:


private:

    TBinomialEntry < T_Key, T_Value > *     m_poCachedLastAccessed ;

/////////////////////////////
// Operations

public:

    TBinomialEntry < T_Key, T_Value > *   
                        LocateEntry   ( const T_Key*    _poEntryKey ) ;

    ESuccess            AddEntry      ( const T_Key*    _poEntryKey, 
                                        const T_Value*  _poEntryValue ) ;

    ESuccess            AddEntry      ( const T_Key     _oEntryKey, 
                                        const T_Value*  _poEntryValue ) 
                                             { return AddEntry ( &_oEntryKey, _poEntryValue ) ; };

    ESuccess            AddEntry      ( const T_Key*    _poEntryKey, 
                                        const T_Value   _oEntryValue ) 
                                             { return AddEntry ( _poEntryKey, &_oEntryValue ) ; };

    ESuccess            AddEntry      ( const T_Key     _oEntryKey, 
                                        const T_Value   _oEntryValue ) 
                                             { return AddEntry ( &_oEntryKey, &_oEntryValue ) ; };

    ESuccess            ModifyEntry   ( const T_Key*    _poEntryKey, 
                                        const T_Value*  _poEntryValue ) ;

/////////////////////////////
// Overloaded assignement operator
public:

} ;


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
template < class T_Key, class T_Value > 
ESuccess            TDictionary < T_Key, T_Value > 
                               ::ModifyEntry  ( const T_Key*        _poEntryKey, 
                                                const T_Value*      _poEntryValue ) 
{
	ESuccess            eReturnStatus = Ok ;
    TBinomialEntry < T_Key, T_Value > *     poEntry ;

    //\\//

    poEntry = LocateEntry ( _poEntryKey ) ;

    if ( poEntry == NULL ) 
    {
        CConsoleAccess::InternalErrorLine ( " Internal Error/TList::ModifyEntry: Entry doesn't exist" ) ;
        eReturnStatus = Error ;
    }
    else
    {
        poEntry->*TList < T_Key, T_Value >::m_poEntryValue = *_poEntryValue ;
    }

    return eReturnStatus ;
} ;


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
template < class T_Key, class T_Value > 
TBinomialEntry < T_Key, T_Value > *      TDictionary < T_Key, T_Value > 
                                                    ::LocateEntry   ( const T_Key* _poEntryKey ) 
{
    TBinomialEntry < T_Key, T_Value > *     poEntry ;

    //\\//

    //First, try the last Accessed Entry 
    if ( m_poCachedLastAccessed != NULL )
    {
        if ( m_poCachedLastAccessed->MatchKey ( _poEntryKey ) == Yes )
        {
    	    poEntry = m_poCachedLastAccessed ;
            goto Done ;
        }
    }

    //If above failed, go through the whole list, starting from the end
    poEntry = TList < T_Key, T_Value >::LastEntry () ;
    while ( poEntry != NULL )
    {
        if ( poEntry->MatchKey ( _poEntryKey ) == Yes )
        {
            m_poCachedLastAccessed = poEntry ;
            goto Done ;
        }
        poEntry = PrevEntry ( poEntry ) ;
    }

Done:
    return poEntry ;
} ;

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
// Override base class AddEntry to avoid creating multiple entries with the same key
template < class T_Key, class T_Value > 
ESuccess            TDictionary < T_Key, T_Value > 
                               ::AddEntry     ( const T_Key*        _poEntryKey, 
                                                const T_Value*      _poEntryValue ) 
{
	ESuccess            eReturnStatus = Ok ;
    TBinomialEntry < T_Key, T_Value > *     poEntry ;

    //\\//

    poEntry = LocateEntry ( _poEntryKey ) ;
    if ( poEntry != NULL ) 
    {
        CConsoleAccess::InternalErrorLine ( " Internal Error/TList::AddEntry: Key already exists" ) ;
        eReturnStatus = Error ;
    }
    else
    {
        eReturnStatus  = TList< T_Key, T_Value >::AddEntry ( _poEntryKey, _poEntryValue ) ;

        m_poCachedLastAccessed = TList < T_Key, T_Value >::LastEntry ( ) ;
    }

    return eReturnStatus ;
} ;


/*-------------------------------------------------------------------------------*/
#endif // __TemplateDictionary__
