/*-------------------------------------------------------------------------------*/
  /*
     UtilsParsing.h
     7-Oct-99
  */
/*-------------------------------------------------------------------------------*/
// Maximum Keyword length
// used to limit damages when input string "has a problem"
#define     KiMaxTokenLength        32

/*------------------------------------------------------------------*/
// Find the first character of the next KeyWord, value or syntax element
//
// i.e. find the first non space or tab character
//
// Return NULL pointer if no such character is found before 
//              the end of string NULL character
//
// Return NULL pointer if argument is NULL pointer

char*           FirstTokenBegin         ( const char* _acString ) ;
/*------------------------------------------------------------------*/


/*------------------------------------------------------------------*/
// Find the length of the leading keyword, integer value, or syntax element
//
// i.e. find the index to the first space, tab, or special syntax 
//              character i.e. ":", "-", "(", or ")" 
//
// Return 1 if the first character already is one of the special syntax 
//              characters above even if the next character is not
//              a space or a tab.
//
// Return 0 if the first character is a space, tab, or
//              the end of string NULL character.
//
// Return 0 if argument is NULL pointer


unsigned int    FirstTokenLength        ( const char* _acString ) ;
/*------------------------------------------------------------------*/


