//////////////////////////////////////////////////////////////////////////////
// File: L1CalTcc_MonitData_Request.hpp
// Created: 11-Oct-2005 Philippe Laurens 
//////////////////////////////////////////////////////////////////////////////

#ifndef __L1CalTcc_MonitData_Request__
#define __L1CalTcc_MonitData_Request__

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Variable Size Definitions
//////////////////////////////////////////////////////////////////////////////
#include "trigmon/L1CalTcc_MonitData_BasicTypes.hpp"

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// Enumerated type to describe the Data Block type being requested 
// and specified in field ulBlockType of L1CalTcc_Monit_Request.
// This block Type will also be returned by TCC to the client 
// in the field ulBlockType of Tcc_Block_Header.

enum   L1CalTcc_BlockType
{
    eL1CalTcc_BlockType_Adf_OutputEt          = 100, // 
//    eL1CalTcc_BlockType_Adf_RawAdc            = 101, // 
    eL1CalTcc_BlockType_TabGab_Status         = 200  // 
//    eL1CalTcc_BlockType_Tab_xxxxx             = 300, // 
//    eL1CalTcc_BlockType_Gab_xxxxx             = 400  // 
} ;

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
// This is the Request packet expected by TCC's Monitoring Server
///////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////
// Use the enumerated type L1CalTcc_BlockType to request a particular Data Block Type:
// the Monitoring client should send an ITC Opaque Message 
// to the L1Cal TCC Monitoring Server at d0tcc3.fnal.gov IP Port #52348
// with the following content

struct L1CalTcc_Monit_Request
{
    uint32  ulBlockType ;              /* Use a value of enum type L1CalTcc_Block_Type */
} ;


#endif // __L1CalTcc_MonitData_Request__

