/*-------------------------------------------------------------------------------*/
  /*
    AdfChipFpga_T7.cpp
    Class AdfChipFpga
    16-May-2005
  */
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/StdAfx.h"

#include                            "L1Cal_IIb_TCC/AdfChipFpga_T7.h"

#include "L1Cal_IIb_TCC/HandleResultFile.h"

#include "L1Cal_IIb_TCC/MonitPoolData.h" // for kL1CalTcc_Tot_LiveBX and CMonitPoolData::mg_aIndexToTick

#include "L1Cal_IIb_TCC/UtilsStrings.h"
#include "L1Cal_IIb_TCC/UtilsBits.h"

#include "L1Cal_IIb_TCC/HandleConsole.h"

#if  ( defined ( VME_IO_FAKE )  || defined ( VME_IO_NONE ) )  
#include <math.h> // for fake histogram
#endif

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CAdfChipFpga_T7::CAdfChipFpga_T7()
{
    // TODO: add one-time construction code here

}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CAdfChipFpga_T7::CAdfChipFpga_T7  ( CAdfCardBase*   _poMotherCard,
                                    unsigned char   _ubChipAddress )

               : CAdfChipFpga     (                 _poMotherCard,  // this calls the base class contructor
                                                    _ubChipAddress )
{

    unsigned int eTtType ;
    unsigned int uiRelEta ;
    unsigned int uiRelPhi ;

    //\\//

    m_eRawAdc_MemMode_Current  = eRawAdc_MemMode_CaptureMonitor ;
    m_eAdfOut_MemMode_Current  = eAdfOut_MemMode_CaptureMonitor ;

    m_poGlb_RawAdcAddrGen_Ctrl
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            KiRegAddrGlb_RawAdcAddrGen_Ctrl, // Relative Address
                            0xffff,              // Write Mask
                            0xffff ) ;           // Read Mask

    m_poGlb_RawAdcAddrGen_Size
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            KiRegAddrGlb_RawAdcAddrGen_Size, // Relative Address
                            0xffff,              // Write Mask
                            0xffff ) ;           // Read Mask

    m_poGlb_RawAdcAddrGen_Curr
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            KiRegAddrGlb_RawAdcAddrGen_Curr,// Relative Address
                            0x0000,              // Write Mask
                            0xffff ) ;           // Read Mask


    m_poGlb_FinalOutAddrGen_Ctrl
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            KiRegAddrGlb_FinalOutAddrGen_Ctrl, // Relative Address
                            0xffff,              // Write Mask
                            0xffff ) ;           // Read Mask

    m_poGlb_FinalOutAddrGen_Size
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            KiRegAddrGlb_FinalOutAddrGen_Size, // Relative Address
                            0xffff,              // Write Mask
                            0xffff ) ;           // Read Mask

    m_poGlb_FinalOutAddrGen_Curr
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            KiRegAddrGlb_FinalOutAddrGen_Curr,// Relative Address
                            0x0000,              // Write Mask
                            0xffff ) ;           // Read Mask


    m_poGlb_Status
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            KiRegAddrGlb_Status,// Relative Address
                            0x0000,              // Write Mask
                            0xffff ) ;           // Read Mask

    m_poGlb_RawAdc_State
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            KiRegAddrGlb_RawAdc_State,// Relative Address
                            0x0000,              // Write Mask
                            0xffff ) ;           // Read Mask

    m_poGlb_FinalOut_Sample
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            KiRegAddrGlb_FinalOut_Sample,// Relative Address
                            0x0000,              // Write Mask
                            0xffff ) ;           // Read Mask

    for ( uiRelEta  = 0 ; uiRelEta  < KiTotEtaPerAdfFpga ; uiRelEta  ++ )
    for ( uiRelPhi  = 0 ; uiRelPhi  < KiTotPhiPerAdfFpga ; uiRelPhi  ++ )
    for ( eTtType   = 0 ; eTtType   < eTot_TT_Chan_Type  ; eTtType ++ )
    {
        m_a3poTt_RawAdc[uiRelEta][uiRelPhi][eTtType]
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            uiRelEta * KiRegAddrTt_BaseShiftPerEta
                          + uiRelPhi * KiRegAddrTt_BaseShiftPerPhi
                          + KiRegAddrTt_RawAdc_BaseOffset
                          + eTtType, // Relative Address
                            0xffff,              // Write Mask
                            0xffff ) ;           // Read Mask

        m_a3poTt_InputCtrl[uiRelEta][uiRelPhi][eTtType]
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            uiRelEta * KiRegAddrTt_BaseShiftPerEta
                          + uiRelPhi * KiRegAddrTt_BaseShiftPerPhi
                          + KiRegAddrTt_InputCtrl_BaseOffset
                          + eTtType, // Relative Address
                            0xffff,              // Write Mask
                            0xffff ) ;           // Read Mask

        m_a3poTt_OutputCtrl[uiRelEta][uiRelPhi][eTtType]
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            uiRelEta * KiRegAddrTt_BaseShiftPerEta
                          + uiRelPhi * KiRegAddrTt_BaseShiftPerPhi
                          + KiRegAddrTt_OutputCtrl_BaseOffset
                          + eTtType, // Relative Address
                            0xffff,              // Write Mask
                            0xffff ) ;           // Read Mask

        m_a3poTt_PrnSeed[uiRelEta][uiRelPhi][eTtType]
        = new CAdfRegBase ( this,                // link back to the Mother Fpga
                            uiRelEta * KiRegAddrTt_BaseShiftPerEta
                          + uiRelPhi * KiRegAddrTt_BaseShiftPerPhi
                          + KiRegAddrTt_PrnSeed_BaseOffset
                          + eTtType, // Relative Address
                            0xffff,              // Write Mask
                            0x0000 ) ;           // Read Mask



        m_a3poTt_MemBlkRawAdc[uiRelEta][uiRelPhi][eTtType]
        = new CAdfRegRawAdc ( this,                // link back to the Mother Fpga
                            uiRelEta * KiRegAddrTt_BaseShiftPerEta
                          + uiRelPhi * KiRegAddrTt_BaseShiftPerPhi
                          + KiRegAddrTt_MemBlkRawAdc_BaseOffset
                          + eTtType * KiRegAddrTt_MemBlkRawAdc_Size ) ; // Relative Address

        m_a3poTt_MemBlkEtLookup[uiRelEta][uiRelPhi][eTtType]
        = new CAdfRegEtLookup ( this,                // link back to the Mother Fpga
                            uiRelEta * KiRegAddrTt_BaseShiftPerEta
                          + uiRelPhi * KiRegAddrTt_BaseShiftPerPhi
                          + KiRegAddrTt_MemBlkEtLookup_BaseOffset
                          + eTtType * KiRegAddrTt_MemBlkEtLookup_Size ) ;

    }

    for ( uiRelEta  = 0 ; uiRelEta  < KiTotEtaPerAdfFpga ; uiRelEta  ++ )
    for ( uiRelPhi  = 0 ; uiRelPhi  < KiTotPhiPerAdfFpga ; uiRelPhi  ++ )
    {
        m_a2poTt_MemBlkEmHdOut[uiRelEta][uiRelPhi]
        = new CAdfRegOutputEt ( this,                // link back to the Mother Fpga
                            uiRelEta * KiRegAddrTt_BaseShiftPerEta
                          + uiRelPhi * KiRegAddrTt_BaseShiftPerPhi
                          + KiRegAddrTt_MemBlkEmHdOut_BaseOffset ) ; // Relative Address
    }
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CAdfChipFpga_T7::~CAdfChipFpga_T7()
{
    unsigned int eTtType ;
    unsigned int uiRelEta ;
    unsigned int uiRelPhi ;

    //\\//

    delete m_poGlb_RawAdcAddrGen_Ctrl ;
    delete m_poGlb_RawAdcAddrGen_Size ;
    delete m_poGlb_RawAdcAddrGen_Curr ;
    delete m_poGlb_FinalOutAddrGen_Ctrl ;
    delete m_poGlb_FinalOutAddrGen_Size ;
    delete m_poGlb_FinalOutAddrGen_Curr ;
    delete m_poGlb_Status ;
    delete m_poGlb_RawAdc_State ;
    delete m_poGlb_FinalOut_Sample ;

    for ( uiRelEta  = 0 ; uiRelEta  < KiTotEtaPerAdfFpga ; uiRelEta  ++ )
    for ( uiRelPhi  = 0 ; uiRelPhi  < KiTotPhiPerAdfFpga ; uiRelPhi  ++ )
    for ( eTtType   = 0 ; eTtType < eTot_TT_Chan_Type  ; eTtType ++ )
    {
        delete m_a3poTt_RawAdc[uiRelEta][uiRelPhi][eTtType] ;
        delete m_a3poTt_InputCtrl[uiRelEta][uiRelPhi][eTtType] ;
        delete m_a3poTt_OutputCtrl[uiRelEta][uiRelPhi][eTtType] ;
        delete m_a3poTt_PrnSeed[uiRelEta][uiRelPhi][eTtType] ;
        delete m_a3poTt_MemBlkRawAdc[uiRelEta][uiRelPhi][eTtType] ;
        delete m_a3poTt_MemBlkEtLookup[uiRelEta][uiRelPhi][eTtType] ;
    }

    for ( uiRelEta  = 0 ; uiRelEta  < KiTotEtaPerAdfFpga ; uiRelEta  ++ )
    for ( uiRelPhi  = 0 ; uiRelPhi  < KiTotPhiPerAdfFpga ; uiRelPhi  ++ )
    {
        delete m_a2poTt_MemBlkEmHdOut[uiRelEta][uiRelPhi] ;
    }
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::Initialize     ( EYesNo              _eSkipInitLookup )

{
    ESuccess        eReturnStatus = Ok ;

    unsigned int eTtType ;
    unsigned int uiRelEta ;
    unsigned int uiRelPhi ;

    TuwRegWord      uwTemp ;

    //\\//

    // reset the Modified flag of all registers
    // so that they may be initialized even if their content had changed
    m_poGlb_RawAdcAddrGen_Ctrl->f_vClearModified () ;
    m_poGlb_RawAdcAddrGen_Size->f_vClearModified () ;
    m_poGlb_RawAdcAddrGen_Curr->f_vClearModified () ;
    m_poGlb_FinalOutAddrGen_Ctrl->f_vClearModified () ;
    m_poGlb_FinalOutAddrGen_Size->f_vClearModified () ;
    m_poGlb_FinalOutAddrGen_Curr->f_vClearModified () ;
    m_poGlb_Status->f_vClearModified () ;
    m_poGlb_RawAdc_State->f_vClearModified () ;
    m_poGlb_FinalOut_Sample->f_vClearModified () ;

    for ( uiRelEta  = 0 ; uiRelEta  < KiTotEtaPerAdfFpga ; uiRelEta  ++ )
    for ( uiRelPhi  = 0 ; uiRelPhi  < KiTotPhiPerAdfFpga ; uiRelPhi  ++ )
    for ( eTtType   = 0 ; eTtType < eTot_TT_Chan_Type  ; eTtType ++ )
    {
        m_a3poTt_RawAdc[uiRelEta][uiRelPhi][eTtType]->f_vClearModified () ;
        m_a3poTt_InputCtrl[uiRelEta][uiRelPhi][eTtType]->f_vClearModified () ;
        m_a3poTt_OutputCtrl[uiRelEta][uiRelPhi][eTtType]->f_vClearModified () ;
        m_a3poTt_PrnSeed[uiRelEta][uiRelPhi][eTtType]->f_vClearModified () ;
//        m_a3poTt_MemBlkRawAdc[uiRelEta][uiRelPhi][eTtType]->f_vClearModified () ;
    }

    for ( uiRelEta  = 0 ; uiRelEta  < KiTotEtaPerAdfFpga ; uiRelEta  ++ )
    for ( uiRelPhi  = 0 ; uiRelPhi  < KiTotPhiPerAdfFpga ; uiRelPhi  ++ )
    {
        m_a2poTt_MemBlkEmHdOut[uiRelEta][uiRelPhi]->f_vClearModified () ;
    }

    ////////////////////////////////////////////////////////////////////

    //    II.1)  Set the Raw ADC Mem Blk Address Generator Highest Address
    //
    //        During one full turn, the Raw ADC Mem Blk uses  4 * 159 = 636
    //        memory locations.  The value that needs to be loaded into the
    //        Highest Address register is 2 less than this.  It is 1 less
    //        because the address sequence starts at zero.  It is another 1 less
    //        because the generator will stop on the cycle after it reaches
    //        this count.
    //
    //        After loading this register we can be guaranteed that the
    //        Address Generator will actually stop within one turn, i.e.
    //        within 21 usec  after you negate its control bit that enables
    //        it to make multiple passes through its address sequence.
    //
    //        At Register Address 0x201=513   Write 634
    //
    uwTemp = 4 * KiTotTicksInTurn - 2 ;
    if ( m_poGlb_RawAdcAddrGen_Size->f_okWriteReg ( &uwTemp ) != Ok )
        eReturnStatus = Error ;


    //    II.2)   Stop the Raw ADC Mem Blk Address Generator
    //
    //        The intent of this step is to Stop the Address Generator
    //        and to put it into a default state.
    //
    //          Do not enable the Address Generator to play multiple passes
    //          through its address sequence.  Set bit #1 to low.
    //
    //          Do not enable the Save Monitor Data signal to stop the
    //          Address Generator.  Set bit #2 to low.
    //
    //          Do not allow the Address Generator to assert its
    //          Raw ADC Mem Blk GLOBAL A-Port Write Enable signal.
    //          Set bit #3 to low.
    //
    //        At Register Address 0x200=512   Write 0x0000
    //
    //        Note that TCC has no convenient way to actually force the
    //        Address Generator to Stop.  All that TCC can do is to let it
    //        finish playing through the current cycle of its address sequence.
    //
    //        At this point, to be absolutely safe, we must wait 21 usec.
    //
    //          The issue here is that to be guaranteed that the Address
    //          Generator will not be running and continue to run after
    //          you execute the  next  step, you must first be certain that
    //          it has stopped.  TCC can not conveniently force it to stop
    //          so you must let the current cycle of the address sequence
    //          play through.
    //
    //          The above register write also implies one post-write
    //          read-check.  We write the same value again, and there will
    //          thus be one pre-write read-check, one write, and one
    //          post-write read-check. Before the value is cahnged
    //          in the next step, here will also be another pre-write
    //          read-check. This gives a total of 5 VME IOs before
    //          the register value is changed. One extra write should be
    //          enough to cover 5x5=25us, but we write it twice anyway,
    //          for good measure.
    //
    //        At Register Address 0x200=512   Write 0x0000  2 more times
    //
    uwTemp = 0x0000 ;
    for ( int wait = 0 ; wait < 3 ; wait ++ ) // do it 3 times to burn > 1 turn = 21 us
    if ( m_poGlb_RawAdcAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
    {
        eReturnStatus = Error ;
        goto Abort ;
    }


    //    II.3)  Setup the Raw ADC Mem Blk Address Generator
    //
    //        Now we want to prepare the Address Generator so that when
    //        it is started sometime later, it will be in the correct mode
    //        to collect Monitoring Data.
    //
    //        We do it in this order, i.e. first setting the various options
    //        in the Address Generator and then later start it running, so
    //        that we are not setting options and starting it running all on
    //        the same clock edge.
    //
    //          Do Not start the Address Generator.  Set bit #0 low.
    //
    //          DO enable the Address Generator to play multiple passes
    //          through its address sequence.  Set bit #1 high.
    //
    //          DO enable the Save Monitor Data signal to stop the
    //          Address Generator.  Set bit #2 high.
    //
    //          DO allow the Address Generator to assert its
    //          Raw ADC Mem Blk GLOBAL A-Port Write Enable signal
    //          while it is running.  Set bit #3 high.
    //
    //        At Register Address 0x200=512   Write 0x000E
    //
    uwTemp = kuiAddrGen_FreeRun_BitMask
           | kuiAddrGen_FollowScld_BitMask
           | kuiAddrGen_WriteEnable_BitMask ;
    if ( m_poGlb_RawAdcAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
    {
        eReturnStatus = Error ;
        goto Abort ;
    }

    //    II.4)   Set the Final Output Mem Blk Address Generator Highest Address
    //
    //        The Final Output Address Generator is handled in the
    //        same way as the Raw ADC Address Generator except that
    //        its Highest Address register is loaded with  157  i.e. 159 - 2.
    //
    //        At Register Address 0x204=516   Write 157
    //
    uwTemp = KiTotTicksInTurn - 2 ;
    if ( m_poGlb_FinalOutAddrGen_Size->f_okWriteReg ( &uwTemp ) != Ok )
        eReturnStatus = Error ;


    //    II.5)   Stop the Final Output Mem Blk Address Generator
    //
    //        At Register Address 0x203=515   Write 0x0000  3 times
    //
    uwTemp = 0x0000 ;
    for ( int wait = 0 ; wait < 3 ; wait ++ ) // do it 3 times to burn > 1 turn = 21 us
    if ( m_poGlb_FinalOutAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
        eReturnStatus = Error ;


    //    II.6)   Setup the Final Output Mem Blk Address Generator
    //
    //        At Register Address 0x200=515   Write 0x000E
    //
    uwTemp = kuiAddrGen_FreeRun_BitMask
           | kuiAddrGen_FollowScld_BitMask
           | kuiAddrGen_WriteEnable_BitMask ;
    if ( m_poGlb_FinalOutAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
        eReturnStatus = Error ;


    //    II.7) Per TT Registers
    //
    //        These actions are repeated for both EM and HD channels of
    //        all 2 x eta and 4 x phi coordinates handled by this FPGA.
    //
    //        note: the initialization order is collapsed below, as each step
    //        #a through #d below is first performed on the EM channel,
    //        then each step is repeated for the HD channel of each tower.
    //
    for ( uiRelEta  = 0 ; uiRelEta  < KiTotEtaPerAdfFpga ; uiRelEta  ++ )
    for ( uiRelPhi  = 0 ; uiRelPhi  < KiTotPhiPerAdfFpga ; uiRelPhi  ++ )
    {
        for ( eTtType   = 0 ; eTtType   < eTot_TT_Chan_Type  ; eTtType ++ )
        {

            //         II.7.a)  TT Reg #2   for TT = 0,0     0,0 EM  INPUT Section Control
            //                  TT Reg #3   for TT = 0,0     0,0 HD  INPUT Section Control
            //
            //            bits  7:0   set to 00    Set the top Comparator Reference to zero.
            //            bits 11:8   set to 0     Set the ADC Data Alignment Delay
            //                                       to the minimum value.
            //            bit 12      set to 0     Select the ADC Data to send to the Filter
            //            bit 14      set to 0     Set the Raw ADC Mem Blk A-Port Write Enable
            //                                       for the EM part of this TT to follow
            //                                       the Global  Raw ADC Mem Blk Wrt Enable.
            //
            //            At Register Address 0x302=770 (for the relative (0,0) EM tower)   Write 0x0000
            //            At Register Address 0x303=771 (for the relative (0,0) HD tower)   Write 0x0000
            //
            uwTemp = 0x0000 ;
            if ( m_a3poTt_InputCtrl[uiRelEta][uiRelPhi][eTtType]->f_okWriteReg ( &uwTemp ) != Ok )
                eReturnStatus = Error ;


            //         II.7.b)  TT Reg #4   for TT = 0,0     0,0 EM  OUTPUT Section Control
            //                  TT Reg #5   for TT = 0,0     0,0 HD  OUTPUT Section Control
            //
            //            bits  7:0   set to 08   Set the value of the "Constant" EM Et Data.
            //            bits 10:8   set to 4    Set Output Mux Control to select Filter Output
            //                                      data for Live Crossings and to select
            //                                      "Constant" Et data for all other Ticks.
            //            bit 12      set to 0    Setthe Output Data Mem Blk A-Port Write Enable
            //                                         for the EM part of this TT to follow
            //                                         the Global  Output Data Mem Blk Wrt Enable.
            //
            //            At Register Address 0x304=772 (for the relative (0,0) EM tower)   Write 0x0408
            //            At Register Address 0x305=773 (for the relative (0,0) HD tower)   Write 0x0408
            //
            uwTemp = 0x0408 ;
            if ( m_a3poTt_OutputCtrl[uiRelEta][uiRelPhi][eTtType]->f_okWriteReg ( &uwTemp ) != Ok )
                eReturnStatus = Error ;


            //         II.7.c)  TT Reg #6   for TT = 0,0     0,0 EM   PRN Seed
            //                  TT Reg #7   for TT = 0,0     0,0 HD   PRN Seed
            //
            //            Set the PRN Seed to $FFFF  i.e. lock the PRN Generator at Hi.
            //            The PRN Generator is not running but let's load this register
            //            to be extra safe.
            //
            //            At Register Address 0x306=774 (for the relative (0,0) EM tower)   Write 0xffff
            //            At Register Address 0x307=775 (for the relative (0,0) HD tower)   Write 0xffff
            //
            uwTemp = 0xffff ;
            if ( m_a3poTt_PrnSeed[uiRelEta][uiRelPhi][eTtType]->f_okWriteReg ( &uwTemp ) != Ok )
                eReturnStatus = Error ;


            //         II.7.d) Initialize Et Lookup Memory
            //
            //            This step is executed only when the card is initialized directly
            //            from the GUI menu, given by its card slot coordinates.
            //            In this casethe memory is loaded with the default one-to-one
            //            memory lookup (with saturation at 255).
            //
            //            This step is skipped if the ADF card initialized as part of
            //            the high level COOR initialization command.  The Lookup Et
            //            initialization will happen (shortly after) during the
            //            initialization of the trigger towers. cf. Appendix A.
            //
            if ( _eSkipInitLookup != Yes )
            if ( m_a3poTt_MemBlkEtLookup[uiRelEta][uiRelPhi][eTtType]->f_okLoadLookup ( ) != Ok )
            {
                eReturnStatus = Error ;
                goto Abort ;
            }

        }

        // Initialize the memory usage type
        m_eRawAdc_MemMode_Current   = eRawAdc_MemMode_CaptureMonitor ;
        m_eAdfOut_MemMode_Current   = eAdfOut_MemMode_CaptureMonitor ;

    }

Abort:

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::RequestNewRawAdcData      ( ETT_Chan_Type       _eTtType,
                                                      unsigned long       _ulRelEta,
                                                      unsigned long       _ulRelPhi,
                                                      unsigned int        _uiThreshold )

{
    ESuccess        eReturnStatus = Ok ;

    //\\//

    if ( (_uiThreshold / 4) > kuiTtInputCtrl_Thresh_BitMask )
    {
        CConsoleAccess::InternalErrorLine ( " Internal Error/CAdfChipFpga_T7::RequestNewRawAdcData: Threshold out of range" ) ;
        _uiThreshold = 4 * kuiTtInputCtrl_Thresh_BitMask ;
    }


    // Set the Comparator Reference (which can be zero)
    // without disturbing the rest (delay, etc)
    if ( SetRawAdcThresh        ( _eTtType,
                                  _ulRelEta,
                                  _ulRelPhi,
                                  fubTruncToByte ( _uiThreshold / 4 ) ) != Ok )
        eReturnStatus = Error ;

    // Prepare the Address generator (which starts it too)
    if ( _uiThreshold != 0 )
    {
        // Enable free running feature.
        // Enable writing to memory
        if ( f_okRawAdc_MemMode    ( _eTtType,
                                     _ulRelEta,
                                     _ulRelPhi,
                                      eRawAdc_MemMode_CaptureAtThresh ) != Ok )
        eReturnStatus = Error ;
    }
    else
    {
        // Enable one pass play
        // Enable writing to memory
        if ( f_okRawAdc_MemMode    ( _eTtType,
                                     _ulRelEta,
                                     _ulRelPhi,
                                      eRawAdc_MemMode_CaptureImmediate ) != Ok )
        eReturnStatus = Error ;
    }

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::CheckRawAdcDataCaptured   ( ETT_Chan_Type       _eTtType,
                                                      unsigned long       _ulRelEta,
                                                      unsigned long       _ulRelPhi )

{
    ESuccess        eReturnStatus = Ok ;

    TuwRegWord      uwTargetMask ;
    TuwRegWord      uwTemp ;

    //\\//

    // Glog Reg #7   Raw ADC capture status
    // Look for the bit identifying this tower to be set high
    uwTargetMask = 0x0001 << ( 8*_ulRelEta + 2*_ulRelPhi + _eTtType ) ;

    if ( m_poGlb_RawAdc_State->f_okReadReg( &uwTemp ) != Ok )

        eReturnStatus = Error ;

    else
    {
        if ( ( uwTemp & uwTargetMask ) != 0x0000 )
#if defined ( VME_IO_FAKE )
            eReturnStatus = Ok ; // pretend it's done
#else
            eReturnStatus = Warning ; // This tower wasn't yet captured
#endif
    }

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::ADC_Capture           ( ETT_Chan_Type       _eTtType,
                                                  unsigned long       _ulRelEta,
                                                  unsigned long       _ulRelPhi,
                                                  unsigned int        _uiThreshold,
                                                  unsigned int        _uiMaxWaitSec,
                                                  TAdcArrayT7         _auwAdcArray,
                                                  CResultFile*        _poCaptureFile )

{
    ESuccess        eReturnStatus = Ok ;

    ESuccess        eCapturedStatus ;

    unsigned int    iWaitNum ;
    TuwRegWord      uwMaxAdcValue = 0 ;

    const int       kRegAddrIncr = 1 ; // We need to increment the addr to get successive samples

    //\\//

    // let's zero out the array to avoid confusion in case of error
    for ( int iSampleNum = 0 ; iSampleNum < KiAdfAdcSampleLength_T7 ; iSampleNum  ++ )
        _auwAdcArray[iSampleNum] = 0 ;

    // Request a New Sample
    if ( RequestNewRawAdcData  ( _eTtType,
                                 _ulRelEta,
                                 _ulRelPhi,
                                 _uiThreshold ) != Ok )
    {
        eReturnStatus = Error ;
        CConsoleAccess::ErrorLine     ( (CString) " Failure Requesting Data Capture" ) ;
        goto Abort ;
    }

    // Wait until the ADF card finds a turn with data above threshold
    // A Null threshold is a special case that directly captured a single turn
    iWaitNum = 0 ;
    if ( _uiThreshold != 0 )
    {
        while ( 1 )
        {
            // Get New Sample
            eCapturedStatus = CheckRawAdcDataCaptured  ( _eTtType,
                                                         _ulRelEta,
                                                         _ulRelPhi ) ;

            if ( eCapturedStatus == Error )
            {
                eReturnStatus = Error ;
                CConsoleAccess::ErrorLine     ( (CString) " Failure Checking for Data Capture" ) ;
                goto Abort ;
            }

            else if ( eCapturedStatus == Ok )
            {
                goto Captured ;
            }

            else // Not captured yet
            {
                if ( iWaitNum > _uiMaxWaitSec*10 ) // we timed out
                {
                    eReturnStatus = Error ;
                    CConsoleAccess::ErrorLine     ( (CString) " Timed Out After Waiting "
                                                            + F_to_A( float(iWaitNum)/10, 1 )
                                                            + " sec" ) ;
                    goto Abort ;
                }
                else // wait longer
                {
                    iWaitNum ++ ;
                    Sleep ( KiSleepOneTenthSecond ) ;
                }
            }
        }
    }

Captured:

    // Read the samples
    if ( m_a3poTt_MemBlkRawAdc[_ulRelEta][_ulRelPhi][_eTtType]
                ->f_okReadBlock( _auwAdcArray,
                                  KiAdfAdcSampleLength_T7,
                                  kRegAddrIncr,
                                 &uwMaxAdcValue ) != Ok )
    {
        CConsoleAccess::ErrorLine     ( (CString) " Failure Reading Data Captured" ) ;
        eReturnStatus = Error ;
    }
    else 
    {
        // report success
        CConsoleAccess::WriteLine     ( (CString) " Waited "
                                                + F_to_A( float(iWaitNum)/10, 1 )
                                                + " sec, and Found Max = "
                                                + I_to_A ( uwMaxAdcValue ) ) ;
        // write the file, if so requested
        if ( _poCaptureFile != NULL )
        for ( int iSampleNum = 0 ; iSampleNum < KiAdfAdcSampleLength_T7 ; iSampleNum  ++ )
            _poCaptureFile->WriteLine ( I_to_A ( _auwAdcArray[iSampleNum] ) ) ;

    }

Abort:

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::ADC_HistoLiveX        ( ETT_Chan_Type       _eTtType,
                                                  unsigned long       _ulRelEta,
                                                  unsigned long       _ulRelPhi,
                                                  TAdcHisto* const    _kpauwHistogram,
                                                  const unsigned long _kulSampleSize,
                                                  unsigned short*     _puwDacValue )
{
    ESuccess        eReturnStatus = Ok ;

    unsigned long   ulBinNum ;
    unsigned long   ulLiveXNum ;
    unsigned long   ulSampleNum ;
    unsigned long   ulSubTick_0 = 0 ;
    TuwRegWord      uwReadData ;


    //\\//

    //clear the histogram
    for ( ulBinNum  = 0 ; 
          ulBinNum <= KiAdfDacMaxOutput ;
          ulBinNum  ++ )
         (*_kpauwHistogram)[ulBinNum] = 0 ;

    // Request the first Sample
    if ( f_okRawAdc_MemMode    ( _eTtType,
                                 _ulRelEta,
                                 _ulRelPhi,
                                  eRawAdc_MemMode_CaptureImmediate ) != Ok )
    {
        eReturnStatus = Error ;
        CConsoleAccess::ErrorLine     ( (CString) " Failure Requesting Data Capture" ) ;
        goto Abort ;
    }

    // Fill the histogram
    ulSampleNum = 0 ;
    while ( ulSampleNum < _kulSampleSize )
    {
        // Read just the Live Crossing samples
        for ( ulLiveXNum = 0 ; ulLiveXNum < kL1CalTcc_Tot_LiveBX ; ulLiveXNum ++ ) 
        {
            if ( m_a3poTt_MemBlkRawAdc[_ulRelEta][_ulRelPhi][_eTtType]
                        ->ReadMonitRawAdc( &uwReadData,
                                            CMonitPoolData::mg_aIndexToTick[ulLiveXNum],
                                            ulSubTick_0 ) != Ok )
                eReturnStatus = Error ;

            //mask off the upper bits
            //the 10 bit ADC samples are read in bits 9:0
            //Bit 12 shows the state of the Live_BX signal.
            //Bit #13 shows the state of the Begin_of_Turn signal.
            //Bits #10, 11, 14, 15 are always be written by the A-Port as Low.
            uwReadData &= KiAdfDacMaxOutput ;

#if  ( defined ( VME_IO_FAKE )  || defined ( VME_IO_NONE ) )  

            double fCenterBin ;
            double fSample ;
            fCenterBin = -0.138 * (double) (*_puwDacValue) + 507.0 ;
            fSample = fCenterBin + 4.75 * pow ( ( (double)rand()/(double)RAND_MAX - 0.5 ) , 3.0 );
            if ( fSample <     0.0 ) fSample =   0.1 ;
            if ( fSample >= 1023.0 ) fSample = 1022.9 ;
            uwReadData = (unsigned short) (fSample  + 0.5) ;

#endif
            //increment histogram
            (*_kpauwHistogram)[uwReadData] += 1 ;

            //keep track of entry count
            ulSampleNum ++ ;
            if ( ulSampleNum == _kulSampleSize ) goto Done ;
        }

        // Request a new snapshot
        if ( f_okRawAdc_MemMode    ( _eTtType,
                                     _ulRelEta,
                                     _ulRelPhi,
                                      eRawAdc_MemMode_CaptureImmediate ) != Ok )
            eReturnStatus = Error ;
    }

Done:


Abort:

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::ADC_HistoEachSubTick  ( ETT_Chan_Type       _eTtType,
                                                  unsigned long       _ulRelEta,
                                                  unsigned long       _ulRelPhi,
                                                  Ta3uwSTicksHisto*   _pa2uwHistogram,
                                                  const unsigned long _kulSampleSize )
{
    ESuccess        eReturnStatus = Ok ;

    unsigned long   ulBinNum ;
    unsigned long   ulTickNum ;
    unsigned long   ulSubTickNum ;
    unsigned long   ulSampleNum ;
    TuwRegWord      uwReadData ;

    //\\//

    //clear the histogram (note Tick number goes 1:159 but we clear 0 for gould measure)
    for ( ulTickNum    = 0 ; ulTickNum    <= KiTotTicksInTurn    ; ulTickNum ++ ) 
    for ( ulSubTickNum = 0 ; ulSubTickNum <  KiTotSamplesPerTick ; ulSubTickNum ++ ) 
    for ( ulBinNum  = 0    ; ulBinNum     <= KiAdfDacMaxOutput   ; ulBinNum  ++ )
         (*_pa2uwHistogram)[ulTickNum][ulSubTickNum][ulBinNum] = 0 ;

    // Request the first Sample
    if ( f_okRawAdc_MemMode    ( _eTtType,
                                 _ulRelEta,
                                 _ulRelPhi,
                                  eRawAdc_MemMode_CaptureImmediate ) != Ok )
    {
        eReturnStatus = Error ;
        CConsoleAccess::ErrorLine     ( (CString) " Failure Requesting Data Capture" ) ;
        goto Abort ;
    }

    // Fill the histogram
    for ( ulSampleNum = 0 ; ulSampleNum < _kulSampleSize ; ulSampleNum ++ )
    {
        // Read all Raw ADC samples
        for ( ulTickNum    = 1 ; ulTickNum    <= KiTotTicksInTurn    ; ulTickNum ++ ) 
        for ( ulSubTickNum = 0 ; ulSubTickNum < KiTotSamplesPerTick ; ulSubTickNum ++ ) 
        {
            if ( m_a3poTt_MemBlkRawAdc[_ulRelEta][_ulRelPhi][_eTtType]
                        ->ReadMonitRawAdc( &uwReadData,
                                            ulTickNum,
                                            ulSubTickNum ) != Ok )
                eReturnStatus = Error ;

            //mask off the upper bits
            //the 10 bit ADC samples are read in bits 9:0
            //Bit 12 shows the state of the Live_BX signal.
            //Bit #13 shows the state of the Begin_of_Turn signal.
            //Bits #10, 11, 14, 15 are always be written by the A-Port as Low.
            uwReadData &= KiAdfDacMaxOutput ;

#if  ( defined ( VME_IO_FAKE )  || defined ( VME_IO_NONE ) )  

            static double fCenterBin = 50.0 ;
            double fSample ;
            fSample = fCenterBin 
                    + (double) ulTickNum
                    + (double) ulSubTickNum
                    + 4.75 * pow ( ( (double)rand()/(double)RAND_MAX - 0.5 ) , 3.0 );
            if ( fSample <    0.0 ) fSample =   0.1 ;
            if ( fSample >= 255.0 ) fSample = 254.9 ;
            uwReadData = (unsigned char) (fSample  + 0.5) ;

#endif
            //increment histogram
            (*_pa2uwHistogram)[ulTickNum][ulSubTickNum][uwReadData] += 1 ;
        }

        // Request a new snapshot
        if ( f_okRawAdc_MemMode    ( _eTtType,
                                     _ulRelEta,
                                     _ulRelPhi,
                                      eRawAdc_MemMode_CaptureImmediate ) != Ok )
            eReturnStatus = Error ;
    }

Abort:

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::OutputEt_HistoEachLiveX     ( ETT_Chan_Type       _eTtType,
                                                        unsigned long       _ulRelEta,
                                                        unsigned long       _ulRelPhi,
                                                        Ta2uwLiveXHisto*    _pa2uwHistogram,
                                                        const unsigned long _kulSampleSize )
{
    ESuccess        eReturnStatus = Ok ;

    EAdfOut_MemMode_Type    ePrevious_MemMode ;

    unsigned long   ulBinNum ;
    unsigned long   ulLiveXNum ;
    unsigned long   ulSampleNum ;
    unsigned char   ubReadDataEm ;
    unsigned char   ubReadDataHd ;

    //\\//

    //clear the histogram 
    for ( ulLiveXNum = 0 ; ulLiveXNum <  kL1CalTcc_Tot_LiveBX ; ulLiveXNum ++ ) 
    for ( ulBinNum  = 0  ; ulBinNum   <= KiAdfEtMaxOutput     ; ulBinNum ++ )
         (*_pa2uwHistogram)[ulLiveXNum][ulBinNum] = 0 ;

    // remember the previous memory mode (i.e. probably eAdfOut_MemMode_CaptureMonitor)
    ePrevious_MemMode = m_eAdfOut_MemMode_Current ;

    // Request the first Sample
    if ( f_okAdfOut_MemMode    ( _eTtType,
                                 _ulRelEta,
                                 _ulRelPhi,
                                  eAdfOut_MemMode_CaptureImmediate ) != Ok )
    {
        eReturnStatus = Error ;
        CConsoleAccess::ErrorLine     ( (CString) " Failure Requesting Data Capture" ) ;
        goto Abort ;
    }

    // Fill the histogram
    for ( ulSampleNum = 0 ; ulSampleNum < _kulSampleSize ; ulSampleNum ++ )
    {
        // Read all Live X samples
        for ( ulLiveXNum = 0 ; ulLiveXNum < kL1CalTcc_Tot_LiveBX ; ulLiveXNum ++ ) 
        {
            if ( m_a2poTt_MemBlkEmHdOut[_ulRelEta][_ulRelPhi]
                        ->ReadMonitOutputEt( &ubReadDataEm,
                                             &ubReadDataHd,
                                              CMonitPoolData::mg_aIndexToTick[ulLiveXNum] ) != Ok )
                eReturnStatus = Error ;

#if  ( defined ( VME_IO_FAKE )  || defined ( VME_IO_NONE ) )  

            static double fCenterBin = 50.0 ;
            double fSample ;
            fSample = fCenterBin 
                    + (double) ulLiveXNum
                    + 4.75 * pow ( ( (double)rand()/(double)RAND_MAX - 0.5 ) , 3.0 );
            if ( fSample <    0.0 ) fSample =   0.1 ;
            if ( fSample >= 255.0 ) fSample = 254.9 ;
            ubReadDataEm = (unsigned char) (fSample  + 0.5) ;
            ubReadDataHd = (unsigned char) (fSample  + 0.5) ;

#endif
            //increment histogram
            if ( _eTtType == eTT_EM ) 
                (*_pa2uwHistogram)[ulLiveXNum][ubReadDataEm] += 1 ;
            else
                (*_pa2uwHistogram)[ulLiveXNum][ubReadDataHd] += 1 ;
        }

        // Request a new snapshot
        if ( f_okAdfOut_MemMode    ( _eTtType,
                                     _ulRelEta,
                                     _ulRelPhi,
                                      eAdfOut_MemMode_CaptureImmediate ) != Ok )
            eReturnStatus = Error ;
    }

    // restore the previous memory mode if needed (i.e. probably eAdfOut_MemMode_CaptureMonitor)
    if ( ePrevious_MemMode != eAdfOut_MemMode_CaptureImmediate ) 
        if ( f_okAdfOut_MemMode    ( _eTtType,
                                     _ulRelEta,
                                     _ulRelPhi,
                                      ePrevious_MemMode ) != Ok )
            eReturnStatus = Error ;

Abort:

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::ExcludeTower        ( ETT_Chan_Type           _eTtType,
                                                const unsigned long     _ulRelEta,
                                                const unsigned long     _ulRelPhi )
{
    ESuccess        eReturnStatus = Ok ;

    //\\//

    //check input parameters
    if ( ( _ulRelEta >= KiTotEtaPerAdfFpga )
      || ( _ulRelPhi >= KiTotPhiPerAdfFpga )
      || ( _eTtType  >= eTot_TT_Chan_Type ) )
    {
        eReturnStatus = Error ;
        CConsoleAccess::InternalErrorLine ( (CString) "CAdfChipFpga_T7::ExcludeTower: Illegal Parameter" ) ;
        goto Abort ;
    }

    // Set Output Mux Control to "Constant Et Data" always
    // selected as the Final Output data.
    if ( f_okAdfOut_MuxMode     ( _eTtType,
                                  _ulRelEta,
                                  _ulRelPhi,
                                  eAdfOut_MuxMode_Constant_Always ) != Ok )
        eReturnStatus = Error ;

Abort:

    if ( eReturnStatus != Ok )
    CConsoleAccess::ErrorLine ( (CString) "Error trying to Exclude a Trigger Tower" ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::SetOutputConstant   ( ETT_Chan_Type           _eTtType,
                                                const unsigned long     _ulRelEta,
                                                const unsigned long     _ulRelPhi,
                                                unsigned char           _ubConstantData )
{
    ESuccess        eReturnStatus = Ok ;

    TuwRegWord      uwTemp ;

    //\\//

    //check input parameters
    if ( ( _ulRelEta         >= KiTotEtaPerAdfFpga )
      || ( _ulRelPhi         >= KiTotPhiPerAdfFpga )
      || ( _eTtType          >= eTot_TT_Chan_Type ) )
    {
        eReturnStatus = Error ;
        CConsoleAccess::InternalErrorLine ( (CString) "CAdfChipFpga_T7::SetOutputConstant: Illegal Parameter" ) ;
        goto Abort ;
    }

    //     bits  7:0   simu data   Set the value of the "Constant" EM/HD Et Data.
    //     bits 10:8   set to 001  Set Output Mux Control to "Constant Et Data" always
    //                               selected as the Final Output data.
    //     bit 12      Untouched   Control of monitoring memory

    // first read back previous programming
    if ( m_a3poTt_OutputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okReadReg ( &uwTemp ) != Ok )
        eReturnStatus = Error ;

    // compute new control value
    uwTemp = ( uwTemp & (~kuiTtOutputCtrl_FixedData_BitMask) ) // clear fixed data
           | _ubConstantData ;                                 // new fixed data

    // program new value
    if ( m_a3poTt_OutputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okWriteReg ( &uwTemp ) != Ok )
        eReturnStatus = Error ;

Abort:

    if ( eReturnStatus != Ok )
    CConsoleAccess::ErrorLine ( (CString) "Error trying to Program Constant Value Output" ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::SetRawAdcThresh     ( ETT_Chan_Type           _eTtType,
                                                const unsigned long     _ulRelEta,
                                                const unsigned long     _ulRelPhi,
                                                unsigned char           _ubThreshold )
{
    ESuccess        eReturnStatus = Ok ;

    TuwRegWord      uwTemp ;

    //\\//

    //check input parameters
    if ( ( _ulRelEta         >= KiTotEtaPerAdfFpga )
      || ( _ulRelPhi         >= KiTotPhiPerAdfFpga )
      || ( _eTtType          >= eTot_TT_Chan_Type ) )
    {
        eReturnStatus = Error ;
        CConsoleAccess::InternalErrorLine ( (CString) "CAdfChipFpga_T7::SetRawAdcThresh: Illegal Parameter" ) ;
        goto Abort ;
    }

    //     bits  7:0   Modify      Top Comparator Reference
    //     bits 11:8   Untouched   ADC Data Alignment Delay
    //     bit 12      Untouched   Select the ADC Data to send to the Filter
    //     bit 14      Untouched   Raw ADC Mem Blk A-Port Write Enable

    // first read back previous programming
    if ( m_a3poTt_InputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okReadReg ( &uwTemp ) != Ok )
        eReturnStatus = Error ;

    // compute new control value
    uwTemp = ( uwTemp & (~kuiTtInputCtrl_Thresh_BitMask) ) // save everything but clear the Delay Value
           |  _ubThreshold ;                               // set new Threshold data 

    // program new value
    if ( m_a3poTt_InputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okWriteReg ( &uwTemp ) != Ok )
        eReturnStatus = Error ;

Abort:

    if ( eReturnStatus != Ok )
    CConsoleAccess::ErrorLine ( (CString) "Error trying to Set Trigger Tower Comparator Threshold" ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::SetAlignmentDelay   ( ETT_Chan_Type           _eTtType,
                                                const unsigned long     _ulRelEta,
                                                const unsigned long     _ulRelPhi,
                                                unsigned char           _ubAlignmentDelay )
{
    ESuccess        eReturnStatus = Ok ;

    TuwRegWord      uwTemp ;

    //\\//

    //check input parameters
    if ( ( _ulRelEta         >= KiTotEtaPerAdfFpga )
      || ( _ulRelPhi         >= KiTotPhiPerAdfFpga )
      || ( _eTtType          >= eTot_TT_Chan_Type )
      || ( _ubAlignmentDelay >  KiAdfMaxAlignmentDelay ) )
    {
        eReturnStatus = Error ;
        CConsoleAccess::InternalErrorLine ( (CString) "CAdfChipFpga_T7::SetAlignmentDelay: Illegal Parameter" ) ;
        goto Abort ;
    }

    //     bits  7:0   Untouched   Top Comparator Reference
    //     bits 11:8   Untouched   ADC Data Alignment Delay
    //     bit 12      Modify      Select the ADC Data to send to the Filter
    //     bit 14      Untouched   Raw ADC Mem Blk A-Port Write Enable

    // first read back previous programming
    if ( m_a3poTt_InputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okReadReg ( &uwTemp ) != Ok )
        eReturnStatus = Error ;

    // compute new control value
    uwTemp = ( uwTemp & (~kuiTtInputCtrl_Delay_BitMask) )          // save everything but clear the Delay Value
           | ( _ubAlignmentDelay << kuiTtInputCtrl_Delay_Shift ) ; // set new delay data

    // program new value
    if ( m_a3poTt_InputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okWriteReg ( &uwTemp ) != Ok )
        eReturnStatus = Error ;

Abort:

    if ( eReturnStatus != Ok )
    CConsoleAccess::ErrorLine ( (CString) "Error trying to Set Trigger Tower Alignment Delay" ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::SetSimuRawAdc     ( ETT_Chan_Type           _eTtType,
                                              const unsigned long     _ulRelEta,
                                              const unsigned long     _ulRelPhi,
                                              const unsigned short    _uwSimuRawAdc,
                                              const unsigned long     _ulTickNum,
                                              const unsigned long     _ulSubTickNum )
{
    ESuccess        eReturnStatus = Ok ;

    //\\//

    //check input parameters
    if ( ( _ulRelEta         >= KiTotEtaPerAdfFpga )
      || ( _ulRelPhi         >= KiTotPhiPerAdfFpga )
      || ( _eTtType          >= eTot_TT_Chan_Type ) )
    {
        eReturnStatus = Error ;
        CConsoleAccess::InternalErrorLine ( (CString) "CAdfChipFpga_T7::SetSimuRawAdc: Illegal Parameter" ) ;
        goto Abort ;
    }

    // program new value
    if ( m_a3poTt_MemBlkRawAdc[_ulRelEta]
                              [_ulRelPhi]
                              [_eTtType]
             ->SetSimuRawAdc ( _uwSimuRawAdc,
                               _ulTickNum,
                               _ulSubTickNum ) != Ok )
        eReturnStatus = Error ;

Abort:

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::SetSimuOutputEt       ( ETT_Chan_Type           _eTtType,
                                                  const unsigned long     _ulRelEta,
                                                  const unsigned long     _ulRelPhi,
                                                  const unsigned char     _ubSimuOutputEt,
                                                  const unsigned long     _ulTickNum )
{
    ESuccess        eReturnStatus = Ok ;

    //\\//

    //check input parameters
    if ( ( _ulRelEta         >= KiTotEtaPerAdfFpga )
      || ( _ulRelPhi         >= KiTotPhiPerAdfFpga )
      || ( _eTtType          >= eTot_TT_Chan_Type ) )
    {
        eReturnStatus = Error ;
        CConsoleAccess::InternalErrorLine ( (CString) "CAdfChipFpga_T7::SetSimuOutputEt: Illegal Parameter" ) ;
        goto Abort ;
    }

    // program new value
    if ( m_a2poTt_MemBlkEmHdOut[_ulRelEta]
                               [_ulRelPhi]
             ->SetSimuOutputEt( _eTtType,
                                _ubSimuOutputEt,
                                _ulTickNum ) != Ok )
        eReturnStatus = Error ;

Abort:

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::ReadMonitOutputEt     ( const unsigned long     _ulRelEta,
                                                  const unsigned long     _ulRelPhi,
                                                  unsigned char*          _pubMonitOutputEtEm,
                                                  unsigned char*          _pubMonitOutputEtHd,
                                                  const unsigned long     _ulTickNum )
{
    ESuccess        eReturnStatus = Ok ;

    //\\//

    //check input parameters
    if ( ( _ulRelEta         >= KiTotEtaPerAdfFpga )
      || ( _ulRelPhi         >= KiTotPhiPerAdfFpga ) )
    {
        eReturnStatus = Error ;
        CConsoleAccess::InternalErrorLine ( (CString) "CAdfChipFpga_T7::ReadMonitOutputEt: Illegal Parameter" ) ;
        goto Abort ;
    }

    // read the pair of EM/HD value
    if ( m_a2poTt_MemBlkEmHdOut[_ulRelEta]
                               [_ulRelPhi]
             ->ReadMonitOutputEt  ( _pubMonitOutputEtEm,
                                    _pubMonitOutputEtHd,
                                    _ulTickNum ) != Ok )
        eReturnStatus = Error ;

Abort:

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::f_okLoadPRNSeed       ( ETT_Chan_Type           _eTtType,
                                                  const unsigned long     _ulRelEta,
                                                  const unsigned long     _ulRelPhi,
                                                  const unsigned short    _uwSeed )
{
    ESuccess        eReturnStatus = Ok ;

    //\\//

    //check input parameters
    if ( ( _ulRelEta         >= KiTotEtaPerAdfFpga )
      || ( _ulRelPhi         >= KiTotPhiPerAdfFpga )
      || ( _eTtType          >= eTot_TT_Chan_Type ) )
    {
        eReturnStatus = Error ;
        CConsoleAccess::InternalErrorLine ( (CString) "CAdfChipFpga_T7::f_okLoadPRNSeed: Illegal Parameter" ) ;
        goto Abort ;
    }

    // program new value
    if ( m_a3poTt_PrnSeed[_ulRelEta][_ulRelPhi][_eTtType]->f_okWriteReg ( &_uwSeed ) != Ok )
        eReturnStatus = Error ;

Abort:

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::f_okRestartRawAdcAddrGen  ( )
{
    // Restart the Raw ADC Address Generator
    return m_poGlb_RawAdcAddrGen_Ctrl->f_okPulseBitsLow ( kuiAddrGen_Start_BitMask ) ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CAdfChipFpga_T7::f_okRestartOutputEtAddrGen ( )
{
    // Restart the Output Et Address Generator
    return m_poGlb_FinalOutAddrGen_Ctrl->f_okPulseBitsLow ( kuiAddrGen_Start_BitMask ) ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess   CAdfChipFpga_T7::f_okRawAdc_MuxMode    ( ETT_Chan_Type           _eTtType,
                                                    const unsigned long     _ulRelEta,
                                                    const unsigned long     _ulRelPhi,
                                                    ERawAdc_MuxMode_Type    _eRawAdc_MuxMode )
{
    ESuccess        eReturnStatus = Ok ;

    //\\//

    //check input parameters
    if ( ( _ulRelEta              >= KiTotEtaPerAdfFpga )
      || ( _ulRelPhi              >= KiTotPhiPerAdfFpga )
      || ( _eTtType               >= eTot_TT_Chan_Type )
      || ( _eRawAdc_MuxMode       <  0 )
      || ( _eRawAdc_MuxMode       >= eTot_RawAdc_MuxMode_Type ) )
    {
        eReturnStatus = Error ;
        CConsoleAccess::InternalErrorLine ( (CString) "CAdfChipFpga_T7::f_okRawAdc_MuxMode: Illegal Parameter" ) ;
        goto Abort ;
    }

    //     bits  7:0   Untouched   Top Comparator Reference
    //     bits 11:8   Untouched   ADC Data Alignment Delay
    //     bit 12      Modify      Select the ADC Data to send to the Filter
    //     bit 14      Untouched   Raw ADC Mem Blk A-Port Write Enable

    // This is a single control bit, we can just clear or set it
    switch ( _eRawAdc_MuxMode )
    {
        case eRawAdc_MuxMode_BlsAligned :
            if ( m_a3poTt_InputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okClearRegBits( kuiTtInputCtrl_SendSimuData_BitMask ) != Ok )
                eReturnStatus = Error ;
            break ;

        case eRawAdc_MuxMode_SimuTurn :
            if ( m_a3poTt_InputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okForceRegBits( kuiTtInputCtrl_SendSimuData_BitMask ) != Ok )
                eReturnStatus = Error ;
            break ;

        #if defined WIN32
        #else // linux complains that the case eTot_handled is not 
        default :
        break ;
        #endif
    }

Abort:

    if ( eReturnStatus != Ok )
    CConsoleAccess::ErrorLine ( (CString) "Error trying to Set Type of ADC data sent to Filter" ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess   CAdfChipFpga_T7::f_okRawAdc_MemMode    ( ETT_Chan_Type           _eTtType,
                                                    const unsigned long     _ulRelEta,
                                                    const unsigned long     _ulRelPhi,
                                                    ERawAdc_MemMode_Type    _eRawAdc_MemMode )
{
    ESuccess        eReturnStatus = Ok ;

    TuwRegWord      uwTemp ;

    //\\//

    //check input parameters
    if ( ( _ulRelEta             >= KiTotEtaPerAdfFpga )
      || ( _ulRelPhi             >= KiTotPhiPerAdfFpga )
      || ( _eTtType              >= eTot_TT_Chan_Type )
      || ( _eRawAdc_MemMode      <  0 )
      || ( _eRawAdc_MemMode      >= eTot_RawAdc_MemMode_Type ) )
    {
        eReturnStatus = Error ;
        CConsoleAccess::InternalErrorLine ( (CString) "CAdfChipFpga_T7::f_okRawAdc_MemMode: Illegal Parameter" ) ;
        goto Abort ;
    }

    switch ( _eRawAdc_MemMode )
    {
        case eRawAdc_MemMode_CaptureMonitor :

            // set the address generator only if the mode has changed
            if ( m_eRawAdc_MemMode_Current != _eRawAdc_MemMode ) 
            {
                // Stop the Address Generator and put it into a default state.
                uwTemp = 0x0000 ;
                for ( int wait = 0 ; wait < 3 ; wait ++ ) // do it 3 times to burn > 1 turn = 21 us
                if ( m_poGlb_RawAdcAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;

                // Prepare the Address Generator so that when it is started sometime later,
                // it will be in the correct mode to collect Monitoring Data.
                uwTemp = kuiAddrGen_FreeRun_BitMask
                       | kuiAddrGen_FollowScld_BitMask
                       | kuiAddrGen_WriteEnable_BitMask ;
                if ( m_poGlb_RawAdcAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;
            }

            // Now set the Per Trigger Tower control register to follow the global Write Enable
            if ( m_a3poTt_InputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okClearRegBits( kuiTtInputCtrl_StopOnThresh_BitMask ) != Ok )
                eReturnStatus = Error ;

        break ;

        case eRawAdc_MemMode_CaptureAtThresh   :

            if ( m_eRawAdc_MemMode_Current != _eRawAdc_MemMode ) 
            {
                // Stop the Address Generator and put it into a default state.
                uwTemp = 0x0000 ;
                for ( int wait = 0 ; wait < 3 ; wait ++ ) // do it 3 times to burn > 1 turn = 21 us
                if ( m_poGlb_RawAdcAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;

                // Prepare the Address Generator so that when it is started sometime later,
                // it will be in the correct mode to capture a turn with energy deposit above threshold
                uwTemp = kuiAddrGen_FreeRun_BitMask
                       | kuiAddrGen_WriteEnable_BitMask ;
                if ( m_poGlb_RawAdcAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;
            }

            // Now set the Per Trigger Tower control register to stop recording at the end of a turn with energy above threshold
            if ( m_a3poTt_InputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okForceRegBits( kuiTtInputCtrl_StopOnThresh_BitMask ) != Ok )
                eReturnStatus = Error ;

        break ;

        case eRawAdc_MemMode_CaptureImmediate :

            if ( m_eRawAdc_MemMode_Current != _eRawAdc_MemMode ) 
            {
                // Stop the Address Generator and put it into a default state.
                uwTemp = 0x0000 ;
                for ( int wait = 0 ; wait < 3 ; wait ++ ) // do it 3 times to burn > 1 turn = 21 us
                if ( m_poGlb_RawAdcAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;

                // Prepare the Address Generator so that when it is started sometime later,
                // it will be in the correct mode to capture a turn with energy deposit above threshold
                uwTemp = kuiAddrGen_WriteEnable_BitMask ;
                if ( m_poGlb_RawAdcAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;
            }

            // Now set the Per Trigger Tower control register to follow the global Write Enable
            if ( m_a3poTt_InputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okClearRegBits( kuiTtInputCtrl_StopOnThresh_BitMask ) != Ok )
                eReturnStatus = Error ;

        break ;

        case eRawAdc_MemMode_PlaySimuTurn  :

            if ( m_eRawAdc_MemMode_Current != _eRawAdc_MemMode ) 
            {
                // Stop the Address Generator and put it into a default state.
                uwTemp = 0x0000 ;
                for ( int wait = 0 ; wait < 3 ; wait ++ ) // do it 3 times to burn > 1 turn = 21 us
                if ( m_poGlb_RawAdcAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;

                // Prepare the Address Generator so that when it is started sometime later,
                // it will be in the correct mode to play Simulated Data.
                uwTemp = kuiAddrGen_FreeRun_BitMask ;
                if ( m_poGlb_RawAdcAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;
            }

            // The Per Trigger Tower control register as the global Write Enable will never be set
            // We program this register bit any way, for consistency
            if ( m_a3poTt_InputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okClearRegBits( kuiTtInputCtrl_StopOnThresh_BitMask ) != Ok )
                eReturnStatus = Error ;

        break ;

        #if defined WIN32
        #else // linux complains that the case eTot_handled is not 
        default :
        break ;
        #endif
    }

    // Remember the (new or not) Monitor Memory type
    m_eRawAdc_MemMode_Current = _eRawAdc_MemMode ;

    //Start the Address Generator
    //If the mode has not changed, the start bit is already high, 
    //so we just set this bit low first, then high.
    if ( m_poGlb_RawAdcAddrGen_Ctrl->f_okPulseBitsLow ( kuiAddrGen_Start_BitMask ) != Ok )
        eReturnStatus = Error ;
    //don't leave this function before the address generator his guaranteed to be started
    //which may take up to 21 us, so we do another few do-nothing IOs to the same place
    if ( m_poGlb_RawAdcAddrGen_Ctrl->f_okForceRegBits ( kuiAddrGen_Start_BitMask ) != Ok )
        eReturnStatus = Error ;

Abort:

    if ( eReturnStatus != Ok )
    CConsoleAccess::ErrorLine ( (CString) "Error trying to Set Usage of Raw ADC Memory" ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess   CAdfChipFpga_T7::f_okAdfOut_MuxMode    ( ETT_Chan_Type           _eTtType,
                                                    const unsigned long     _ulRelEta,
                                                    const unsigned long     _ulRelPhi,
                                                    EAdfOut_MuxMode_Type    _eAdfOut_MuxMode )
{
    ESuccess        eReturnStatus = Ok ;

    TuwRegWord      uwTemp ;

    //\\//

    //check input parameters
    if ( ( _ulRelEta              >= KiTotEtaPerAdfFpga )
      || ( _ulRelPhi              >= KiTotPhiPerAdfFpga )
      || ( _eTtType               >= eTot_TT_Chan_Type )
      || ( _eAdfOut_MuxMode       <  0 )
      || ( _eAdfOut_MuxMode       >= eTot_AdfOut_MuxMode_Type ) )
    {
        eReturnStatus = Error ;
        CConsoleAccess::InternalErrorLine ( (CString) "CAdfChipFpga_T7::f_okAdfOut_MuxMode: Illegal Parameter" ) ;
        goto Abort ;
    }

    //     bits  7:0   Untouched   Set the value of the "Constant" EM/HD Et Data.
    //     bits 10:8   Modify      Set Output Mux Control
    //     bit 12      Untouched   Control of monitoring memory

    // first read back previous programming
    if ( m_a3poTt_OutputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okReadReg ( &uwTemp ) != Ok )
        eReturnStatus = Error ;

    // compute new control value
    switch ( _eAdfOut_MuxMode )
    {
        case eAdfOut_MuxMode_Filtered_Always :
            uwTemp = ( uwTemp & (~kuiTtOutputCtrl_MuxSel_BitMask) )  // clear the Mux Select field
                   | kuiTtOutputCtrl_MuxSel_Filter_Always ;          // set new value
            break ;
        case eAdfOut_MuxMode_Filtered_LiveX  :
            uwTemp = ( uwTemp & (~kuiTtOutputCtrl_MuxSel_BitMask) )
                   | kuiTtOutputCtrl_MuxSel_Filter_LiveX ;
            break ;
        case eAdfOut_MuxMode_Constant_Always :
            uwTemp = ( uwTemp & (~kuiTtOutputCtrl_MuxSel_BitMask) )
                   | kuiTtOutputCtrl_MuxSel_ConstEt_Always ;
            break ;
        case eAdfOut_MuxMode_Prn_Always      :
            uwTemp = ( uwTemp & (~kuiTtOutputCtrl_MuxSel_BitMask) )
                   | kuiTtOutputCtrl_MuxSel_PRN_Always ;
            break ;
        case eAdfOut_MuxMode_Prn_LiveX      :
            uwTemp = ( uwTemp & (~kuiTtOutputCtrl_MuxSel_BitMask) )
                   | kuiTtOutputCtrl_MuxSel_PRN_LiveX ;
            break ;
        case eAdfOut_MuxMode_SimuTurn_Always:
            uwTemp = ( uwTemp & (~kuiTtOutputCtrl_MuxSel_BitMask) )
                   | kuiTtOutputCtrl_MuxSel_SimulBlock_Always ;
            break ;
        case eAdfOut_MuxMode_SimuTurn_LiveX :
            uwTemp = ( uwTemp & (~kuiTtOutputCtrl_MuxSel_BitMask) )
                   | kuiTtOutputCtrl_MuxSel_SimulBlock_LiveX ;
            break ;

        #if defined WIN32
        #else // linux complains that the case eTot_handled is not 
        default :
        break ;
        #endif
    }

    // program new value
    if ( m_a3poTt_OutputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okWriteReg ( &uwTemp ) != Ok )
        eReturnStatus = Error ;

Abort:

    if ( eReturnStatus != Ok )
    CConsoleAccess::ErrorLine ( (CString) "Error trying to Set Type of Output Et sent to TAB" ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess   CAdfChipFpga_T7::f_okAdfOut_MemMode    ( ETT_Chan_Type            _eTtType,
                                                    const unsigned long      _ulRelEta,
                                                    const unsigned long      _ulRelPhi,
                                                    EAdfOut_MemMode_Type     _eAdfOut_MemMode )
{
    ESuccess        eReturnStatus = Ok ;

    TuwRegWord      uwTemp ;

    //\\//

    //check input parameters
    if ( ( _ulRelEta             >= KiTotEtaPerAdfFpga )
      || ( _ulRelPhi             >= KiTotPhiPerAdfFpga )
      || ( _eTtType              >= eTot_TT_Chan_Type )
      || ( _eAdfOut_MemMode      <  0 )
      || ( _eAdfOut_MemMode      >= eTot_AdfOut_MemMode_Type ) )
    {
        eReturnStatus = Error ;
        CConsoleAccess::InternalErrorLine ( (CString) "CAdfChipFpga_T7::f_okAdfOut_MemMode: Illegal Parameter" ) ;
        goto Abort ;
    }

    switch ( _eAdfOut_MemMode )
    {
        case eAdfOut_MemMode_CaptureMonitor    :

            // set the address generator only if the mode has changed
            if ( m_eAdfOut_MemMode_Current != _eAdfOut_MemMode )
            {
                //  Stop the Address Generator and put it into a default state.
                uwTemp = 0x0000 ;
                for ( int wait = 0 ; wait < 3 ; wait ++ ) // do it 3 times to burn > 1 turn = 21 us
                if ( m_poGlb_FinalOutAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;

                // Prepare the Address Generator so that when it is started sometime later,
                // it will be in the correct mode to collect Monitoring Data.
                uwTemp = kuiAddrGen_FreeRun_BitMask
                       | kuiAddrGen_FollowScld_BitMask
                       | kuiAddrGen_WriteEnable_BitMask ;
                if ( m_poGlb_FinalOutAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;
            }

            // Now set the Per Trigger Tower control register to follow the global Write Enable
            if ( m_a3poTt_OutputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okClearRegBits( kuiTtOutputCtrl_StopOnThresh_BitMask ) != Ok )
                eReturnStatus = Error ;

        break ;

        case eAdfOut_MemMode_CaptureAtThresh:

            // set the address generator only if the mode has changed
            if ( m_eAdfOut_MemMode_Current != _eAdfOut_MemMode )
            {
                //  Stop the Address Generator and put it into a default state.
                uwTemp = 0x0000 ;
                for ( int wait = 0 ; wait < 3 ; wait ++ ) // do it 3 times to burn > 1 turn = 21 us
                if ( m_poGlb_FinalOutAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;

                // Prepare the Address Generator so that when it is started sometime later,
                // it will be in the correct mode to collect Monitoring Data.
                uwTemp = kuiAddrGen_FreeRun_BitMask
                       | kuiAddrGen_WriteEnable_BitMask ;
                if ( m_poGlb_FinalOutAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;
            }

            // Now set the Per Trigger Tower control register to stop recording at the end of a turn with energy above threshold
            if ( m_a3poTt_OutputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okForceRegBits( kuiTtOutputCtrl_StopOnThresh_BitMask ) != Ok )
                eReturnStatus = Error ;

        break ;

        case eAdfOut_MemMode_CaptureImmediate :

            // set the address generator only if the mode has changed
            if ( m_eAdfOut_MemMode_Current != _eAdfOut_MemMode )
            {
                //  Stop the Address Generator and put it into a default state.
                uwTemp = 0x0000 ;
                for ( int wait = 0 ; wait < 3 ; wait ++ ) // do it 3 times to burn > 1 turn = 21 us
                if ( m_poGlb_FinalOutAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;

                // Prepare the Address Generator so that when it is started sometime later,
                // it will be in the correct mode to collect Monitoring Data.
                uwTemp = kuiAddrGen_WriteEnable_BitMask ;
                if ( m_poGlb_FinalOutAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;
            }

            // Now set the Per Trigger Tower control register to follow the global Write Enable
            if ( m_a3poTt_OutputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okClearRegBits( kuiTtOutputCtrl_StopOnThresh_BitMask ) != Ok )
                eReturnStatus = Error ;

        break ;

        case eAdfOut_MemMode_PlaySimuTurn   :

            // set the address generator only if the mode has changed
            if ( m_eAdfOut_MemMode_Current != _eAdfOut_MemMode )
            {
                //  Stop the Address Generator and put it into a default state.
                uwTemp = 0x0000 ;
                for ( int wait = 0 ; wait < 3 ; wait ++ ) // do it 3 times to burn > 1 turn = 21 us
                if ( m_poGlb_FinalOutAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;

                // Prepare the Address Generator so that when it is started sometime later,
                // it will be in the correct mode to collect Monitoring Data.
                uwTemp = kuiAddrGen_FreeRun_BitMask ;
                if ( m_poGlb_FinalOutAddrGen_Ctrl->f_okWriteReg ( &uwTemp ) != Ok )
                    eReturnStatus = Error ;
            }

            // The Per Trigger Tower control register as the global Write Enable will never be set
            // We program this register bit any way, for consistency
            if ( m_a3poTt_OutputCtrl[_ulRelEta][_ulRelPhi][_eTtType]->f_okClearRegBits( kuiTtOutputCtrl_StopOnThresh_BitMask ) != Ok )
                eReturnStatus = Error ;

        break ;

        #if defined WIN32
        #else // linux complains that the case eTot_handled is not 
        default :
        break ;
        #endif
    }

    // Remember the new (or not) Monitor Memory type
    m_eAdfOut_MemMode_Current = _eAdfOut_MemMode ;

    //Start the address generator
    //If the mode has not changed, the start bit is already high, 
    //so we just set this bit low first, then high.
    if ( m_poGlb_FinalOutAddrGen_Ctrl->f_okPulseBitsLow ( kuiAddrGen_Start_BitMask ) != Ok )
        eReturnStatus = Error ;
    //don't leave this function before the address generator his guaranteed to be started
    //which may take up to 21 us, so we do another few do-nothing IOs to the same place
    if ( m_poGlb_FinalOutAddrGen_Ctrl->f_okForceRegBits ( kuiAddrGen_Start_BitMask ) != Ok )
        eReturnStatus = Error ;

Abort:

    if ( eReturnStatus != Ok )
    CConsoleAccess::ErrorLine ( (CString) "Error trying to Set Usage of Output Et Memory" ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

