/*-------------------------------------------------------------------------------*/
  /*
    CommandFileSelfMsg.cpp
    17-Nov-99
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"

#include "L1Cal_IIb_TCC/GlobalConstants.h"
#include "L1Cal_IIb_TCC/CustomDataTypes.h"

#include "L1Cal_IIb_TCC/HandleCommandFiles.h"

#include                            "L1Cal_IIb_TCC/CommandFileSelfMsg.h"

#include "L1Cal_IIb_TCC/HandleCoorConnection.h"

#include "L1Cal_IIb_TCC/UtilsStrings.h"
//#include "L1Cal_IIb_TCC/UtilsBits.h"

#include "L1Cal_IIb_TCC/HandleItcClient.h"

// static means created only once throughout life of program (to avoid wasting time)
// *AND* internal linkage (to avoid clash between modules)
#include "L1Cal_IIb_TCC/HandleConsole.h"
static  CConsoleAccess oConsole ;

// global variables
// Fake Message ID to tack onto each Message
const CString   osFakeMsgID ( "[FromMsgFile] " );
const int       iLenFakeMsgID = osFakeMsgID.GetLength() ;

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CommandFileSelfMsg       ( CString	                        _osCommand_File_Name,
                                    Custom_Structure_SelfMsg*       _pxCustom, 
                                    void*                           _pDlgThis )
{
	ESuccess            eReturnStatus = Ok ;

    ESuccess            eSuccess ;
    Parse_Structure     xParse ;

    CString             oMsg ;

    //\\//

    // write to console 
	oConsole.WriteLine ( "" ) ;

	oConsole.WriteLine ( (CString) "%%% Send Self Message Command File : "
                        		 +  _osCommand_File_Name ) ;
    
    // Initialize the Command File Parser control Structure
    eSuccess = Init_Parse_Structure ( &xParse ) ;

    xParse.pacFile_Name = LPCTSTR(_osCommand_File_Name) ;

    //register the legal keywords and 
    //the call back points for the apropriate keywords
    xParse.Actions.pfSend_Msg_To_Self  = (fKeyword_Action*) SelfMsg_Action_Parse_Send_Msg_To_Self ;
    
    // Initialize Total Number of register IO performed
    _pxCustom->uiTotCommand = 0 ;

    // call the general purpose command file parser 
    eSuccess = Read_Command_File ( &xParse, _pxCustom, _pDlgThis ) ;

	oConsole.WriteLine ( "" ) ;

    if ( eSuccess == Ok  )
    {
        oMsg = "%%%Done after Executing   "
             + I_to_A ( _pxCustom->uiTotCommand  )
             + " Send Self Message Commands" ;
        oConsole.WriteLine ( oMsg ) ;
    }
    else
    {
        oMsg = "%%%Abort after Executing   "
             + I_to_A ( _pxCustom->uiTotCommand  )
             + " Send Self Message Commands" ;
        oConsole.ErrorLine ( oMsg ) ;
    	eReturnStatus = Error ;
    }

    return eReturnStatus ;
}


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess SelfMsg_Action_Parse_Send_Msg_To_Self    ( void* _pxParse, 
                                                    void* _pxCustom,
                                                    void* _pDlgThis )
{
    Parse_Structure*                pxParse         = (Parse_Structure*)                _pxParse ;
    Custom_Structure_SelfMsg*       pxCustom_Self   = (Custom_Structure_SelfMsg*)       _pxCustom ;
//    Dlg_Msg*                        pDlgThis        = (Dlg_Msg*)                        _pDlgThis ;

    ESuccess        eSuccess ;
    ESuccess        eReturnStatus = Ok ;

    CString         osMessage ;

    //\\//

    // check all other keywords have been assigned
    // Does not apply here

    // Increment Total Number of register IO performed
    pxCustom_Self->uiTotCommand++ ;

    // pre-pend a message ID
    osMessage = osFakeMsgID + pxParse->Values.osGeneric_String_Parameter ;

    //verify the client connection already exists
    if ( ItcClient::m_poConnection_as_Coor_to_Self == NULL ) 
        InitCoorConnectionClient () ;
    else if ( ItcClient::m_poConnection_as_Coor_to_Self->IsNotInitialized() )
        InitCoorConnectionClient () ;

    //clear the last reply
    ItcClient::m_poConnection_as_Coor_to_Self->ClearReply () ;

    //send the message to Self
    eSuccess = ItcClient::m_poConnection_as_Coor_to_Self->SendMessage ( (LPCTSTR) osMessage ) ;
/*
    //Update the box showing the message being sent
    //if we were called from the dialog box
    if ( ( pDlgThis != NULL )
      && ( pDlgThis->m_bShow_Progress ) )
    {
        pDlgThis->m_osSelf_Message = pxParse->Values.osGeneric_String_Parameter ;
        pDlgThis->m_osReplyMessage = "_Waiting for Reply" ;
        pDlgThis->UpdateData(KWriteToScreen);	
	    pDlgThis->UpdateWindow() ; // ask for window repaint
        // prepare status in case no Reply is retrieved
        pDlgThis->m_osReplyMessage += "....Timed out" ;	
    }
    
    // We don't wait for the message to be executed because (1) SendMessage already waits .1 sec
    // and (2) we shouldn't wait too long because this command file may have been called
    // from within a message (e.g. initialize) and the additional messages 
    // created here are just being queued up

    if ( ( pDlgThis != NULL )
      && ( pDlgThis->m_bShow_Progress ) )
    {
        // if we are called interactively we can afford to wait some more, 
        // but no longer two seconds for message acknowledgement
        for ( int i = 0 ; i < 20 ; i++ )
        {
            if ( ItcClient::m_poConnection_as_Coor_to_Self->HasReplied ( ) == Ok )   break ;
            Sleep ( 100 ) ; // wait .1 second = 100 millisecond
        }

        // retrieve reply, if any has arrived
        ItcClient::m_poConnection_as_Coor_to_Self->LastReply ( &pDlgThis->m_osReplyMessage ) ;

        // remove Message ID field (if present) for display
        if ( pDlgThis->m_osReplyMessage.Left( iLenFakeMsgID ) == osFakeMsgID )
            pDlgThis->m_osReplyMessage = pDlgThis->m_osReplyMessage.Mid( iLenFakeMsgID ) ;

        pDlgThis->UpdateData(KWriteToScreen);	
	    pDlgThis->UpdateWindow() ; // ask for window repaint
    }
*/
    if ( eSuccess != Ok ) eReturnStatus = eSuccess ;

//Done:

    return eReturnStatus ;
}

