/*-------------------------------------------------------------------------------*/
  /*
     GuiCommand.cpp
     2-Nov-04
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"

#include                            "L1Cal_IIb_TCC/GuiCommand.h"

#include "L1Cal_IIb_TCC/UtilsParsing.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*
CGuiCommand::CGuiCommand () 
{
    ResetCommand () ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*
CGuiCommand::~CGuiCommand () 
{
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*
void CGuiCommand::ResetCommand () 
{
    m_uiGuiCmdCode      = Ki_GuiCmd_None ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CGuiCommandLine::CGuiCommandLine () 
{
//    m_poGuiCommand = NULL ;
    ResetCommandLine () ;

    // initialize the XML parser
    m_pDOMparser = new XercesDOMParser();
    m_pDOMparser->setValidationScheme(XercesDOMParser::Val_Always);    // optional.
    m_pDOMparser->setDoNamespaces(true);    // optional

    m_pDOMerrHandler = (ErrorHandler*) new HandlerBase();
    m_pDOMparser->setErrorHandler( m_pDOMerrHandler );

}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CGuiCommandLine::~CGuiCommandLine () 
{
//    if ( m_poGuiCommand != NULL ) delete ( m_poGuiCommand ) ;

    delete m_pDOMparser ;
    delete m_pDOMerrHandler ;

}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void CGuiCommandLine::ResetCommandLine () 
{
    m_psRawCommand              = NULL ;

    m_psReplyText               = NULL ;

    m_uiCurrentReplyLength      = 0 ;
    
//    if ( m_poGuiCommand != NULL )  delete ( m_poGuiCommand ) ;
//    m_poGuiCommand = new ( CGuiCommand ) ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void CGuiCommandLine::NewRawCommand  ( const char*     _psGuiCommand,
                                       char*           _psReplyText,
                                       unsigned int    _uiMaxReplyLength )

{ 
    //\\//

    ResetCommandLine () ;

    m_psRawCommand              = _psGuiCommand ; 
    m_pcCurrentCommandCharNum   = _psGuiCommand ;
    m_pcCurrentTokenCharNum     = _psGuiCommand ;

    m_psReplyText               = _psReplyText ; 
    m_psReplyText[0]            = 0 ;
    m_uiCurrentReplyLength      = 0 ;
    m_uiMaxReplyLength          = _uiMaxReplyLength ;

    return ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
char*    CGuiCommandLine::GetNextToken  ( char*           _psToken ) 
// The raw command is parsed to locate the next token.
// The calling routine supplies the buffer to copy the token to.
// The routine returns a pointer to the argument that was passed.
// Not being able to find a token is handled by writing the supplied string
// with the null string, meaning the value pointed to is the NULL character (i.e.=0) 
{ 
    char*           pcToken ;
    unsigned int    uiTokenLength ;

    //\\//

    // initialize returned argument to Null String
    _psToken[0] = 0 ;

    // Locate the next keyword, and advance the current parsing position
    pcToken         = FirstTokenBegin(m_pcCurrentCommandCharNum) ;
    uiTokenLength   = FirstTokenLength(pcToken) ;
    m_pcCurrentTokenCharNum   = pcToken ;
    m_pcCurrentCommandCharNum = pcToken + uiTokenLength ;

    //maybe there were no more tokens
    if ( pcToken == 0 )         goto Done ;

    // strncat is prefered over strncpy because it does not pad
    // the destination string with NULLs to reach the specified number of chars
    // and always appends a NULL character at the end of the resulting string
    strncat ( _psToken, pcToken, uiTokenLength ) ;
    // note also that FirstTokenLength() checked against maximum Token length

Done:

    return _psToken ;
}


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void CGuiCommandLine::CopyReplyText  ( const char*     _psPreplyText )

{ 
    //\\//

    // strncat is prefered over strncpy because it does not pad
    // the destination string with NULLs to reach the specified number of chars
    // and always appends a NULL character at the end of the resulting string
    m_psReplyText[0] = 0 ;
    strncat ( m_psReplyText, _psPreplyText, m_uiMaxReplyLength ) ;

    // remember the current length of the reply string
    m_uiCurrentReplyLength = strlen ( m_psReplyText ) ;
    
    return ;
}


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void CGuiCommandLine::AppendReplyText  ( const char*     _psPreplyText )

{ 
    //\\//

    // Add the new characters, starting at the known current end of the string
    // to minimize the search for the NULL character within strncat
    strncat ( &m_psReplyText[m_uiCurrentReplyLength], 
              _psPreplyText, 
              m_uiMaxReplyLength - m_uiCurrentReplyLength ) ;
    
    // remember the current length of the reply string
    m_uiCurrentReplyLength += strlen ( &m_psReplyText[m_uiCurrentReplyLength] ) ;
    
    return ;
}

