/*-------------------------------------------------------------------------------*/
  /*
     GuiCommandConsumer.cpp
     02-Nov-2004
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"

#include                            "L1Cal_IIb_TCC/GuiCommandConsumer.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus CGuiCommandConsumer::ConsumeGuiCommand      ( const char*         _psCommandText,
                                                                char*               _psReplyText,
                                                                unsigned int        _uiMaxReplyLength ) 
{ 
    EGuiCommandStatus  eReturnStatus = GuiReply_Ok ;

    //\\//

    //Get a hold of the new command
    NewRawCommand ( _psCommandText, _psReplyText, _uiMaxReplyLength ) ;

    //Parse XML string
    eReturnStatus = CGuiCommandParser::ParseXmlMessage    ( this ) ;

    if ( eReturnStatus == GuiReply_Ok )
    {
        //find gui command (and adopt document)
        eReturnStatus = CGuiCommandParser::FindGuiCommand    ( this ) ;

        //dispatch/execute the command
        if ( eReturnStatus == GuiReply_Ok )
            eReturnStatus = CGuiCommandDispatcher::GuiCommandDispatch ( this, this ) ;

        //release XML document
        CGuiCommandParser::ReleaseXmlMessage    ( this ) ;
    }

    return eReturnStatus ;
}

