/*-------------------------------------------------------------------------------*/
  /*
     GuiCommandExecuter.cpp
     02-Nov-2004
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"
//#include <math.h>

#include                            "L1Cal_IIb_TCC/GuiCommandExecuter.h"

#include "L1Cal_IIb_TCC/AdfRegBase.h"
#include "L1Cal_IIb_TCC/HandleConfigAdfFpga.h"

#include "L1Cal_IIb_TCC/GuiDlgIoVme.h"
#include "L1Cal_IIb_TCC/GuiDlgTestRandReg.h"

#include "L1Cal_IIb_TCC/AdfDacCtrl.h"

#include "L1Cal_IIb_TCC/HandleHardwareAccess.h"
#include "L1Cal_IIb_TCC/HandleBit3Adaptor61x.h"

#include "L1Cal_IIb_TCC/HandleResultFile.h"

#include "L1Cal_IIb_TCC/NevisCard.h"
#include "tabgab/vmescl.h"

#include "L1Cal_IIb_TCC/L1Cal.h"
#include "L1Cal_IIb_TCC/HsroL1Cal.h"

#include "L1Cal_IIb_TCC/MonitPoolData.h" // for kL1CalTcc_Tot_LiveBX and CMonitPoolData::mg_aIndexToTick

#include "L1Cal_IIb_TCC/HandleCommandFiles.h"
#include "L1Cal_IIb_TCC/CommandFileVmeIO.h"
#include "L1Cal_IIb_TCC/CommandFileRegisterIO.h"
#include "L1Cal_IIb_TCC/CommandFileSerialIO.h"
#include "L1Cal_IIb_TCC/CommandFileConfigFpga.h"
#include "L1Cal_IIb_TCC/CommandFileTrigTwrInfo.h"
#include "L1Cal_IIb_TCC/CommandFileSelfMsg.h"
#include "L1Cal_IIb_TCC/CommandFileMaster.h"

#include "L1Cal_IIb_TCC/T962.h"

#include "L1Cal_IIb_TCC/HandleConsole.h"
#include "L1Cal_IIb_TCC/UtilsStrings.h"
#include "L1Cal_IIb_TCC/UtilsFiles.h"
#include "L1Cal_IIb_TCC/UtilsBits.h"

/*-------------------------------------------------------------------------------*/

// Tab/Gab software

#include "tabgab/tcc_to_tabgab_config.h"

#include "tabgab/vmescl.h"
#include "tabgab/util.h"

/*-------------------------------------------------------------------------------*/
// macros used in many of the commands
/////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////
#define APPEND_STATUS_TO_REPLY()                                                    \
    /* append success/error to reply text*/                                         \
    if ( _poGuiCommandLine != NULL )                                                \
        _poGuiCommandLine->AppendReplyText ( sReplyText ) ;                         \
    if ( eReturnStatus == GuiReply_Ok )                                             \
        CConsoleAccess::WriteLine     ( sReplyText ) ;                              \
    else                                                                            \
        CConsoleAccess::ErrorLine     ( sReplyText ) ;                              \
/////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////
#define APPEND_STATUS_TO_REPLY_NO_INFOLINE()                                                    \
    /* append success/error to reply text*/                                         \
    if ( _poGuiCommandLine != NULL )                                                \
        _poGuiCommandLine->AppendReplyText ( sReplyText ) ;                         \
    if ( eReturnStatus != GuiReply_Ok )                                             \
        CConsoleAccess::ErrorLine     ( sReplyText ) ;                              \
/////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////
#define CHECK_FOR_IO_ERROR()                                                        \
    if ( eReturnStatus == Reply_Bad )                                               \
        strcpy ( sReplyText, "<IO Error During Command Execution>" ) ;              \
/////////////////////////////////////////////////////////////////////////////////////


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Vio_ReadReg                   ( unsigned int        _uiVmeAddress,
                                                                        unsigned long       _ulRepeatCnt,
                                                                        char*               _psAddressSpace,
                                                                        char*               _psDataSize,
                                                                        char*               _psAccessPriv,
                                                                        char*               _psAccessType,
                                                                        char*               _psBit3Access,
                                                                        CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    unsigned long       ulDataIn ;

    //\\//


    CGuiCommandPrinter::Vio_ReadReg    ( _uiVmeAddress,
                                         _ulRepeatCnt,
                                         _psAddressSpace,
                                         _psDataSize,
                                         _psAccessPriv,
                                         _psAccessType,
                                         _psBit3Access,
                                         _poGuiCommandLine ) ;

    if ( DlgIoVme_ReadReg  ( _uiVmeAddress, 
                             &ulDataIn,
                             _ulRepeatCnt,
                             _psAddressSpace,
                             _psDataSize,
                             _psAccessPriv,
                             _psAccessType,
                             _psBit3Access )  != Ok )
        eReturnStatus = GuiReply_Bad ;

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Data
                                  + " " 
                                  + KsGuiXml_In 
                                  + "=\"" 
                                  + I_to_A ( ulDataIn )
                                  + "\"/></"
                                  + KsGuiXml_Reply 
                                  + ">" ) ;
    
    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Vio_WriteReg                  ( unsigned int        _uiVmeAddress,
                                                                        unsigned int        _uiDataOut,
                                                                        unsigned long       _ulRepeatCnt,
                                                                        char*               _psAddressSpace,
                                                                        char*               _psDataSize,
                                                                        char*               _psAccessPriv,
                                                                        char*               _psAccessType,
                                                                        char*               _psBit3Access,
                                                                        CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    unsigned long       ulDataIn ;

    //\\//

    CGuiCommandPrinter::Vio_WriteReg   ( _uiVmeAddress,
                                         _uiDataOut,
                                         _ulRepeatCnt,
                                         _psAddressSpace,
                                         _psDataSize,
                                         _psAccessPriv,
                                         _psAccessType,
                                         _psBit3Access,
                                         _poGuiCommandLine ) ;
    
    if ( DlgIoVme_WriteReg  ( _uiVmeAddress, 
                              _uiDataOut, 
                              &ulDataIn,
                              _ulRepeatCnt,
                              _psAddressSpace,
                              _psDataSize,
                              _psAccessPriv,
                              _psAccessType,
                              _psBit3Access  )  != Ok )
        eReturnStatus = GuiReply_Bad ;

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Data
                                  + " " 
                                  + KsGuiXml_In 
                                  + "=\"" 
                                  + I_to_A ( ulDataIn )
                                  + "\"/></"
                                  + KsGuiXml_Reply 
                                  + ">" ) ;
    
    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Rio_ReadReg                  ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiChipNum,
                                                                       unsigned int        _uiRegAddr,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    TuwRegWord      uwDataIn ;
 
    //\\//

    CGuiCommandPrinter::Rio_ReadReg   ( _uiMasterNum,
                                        _uiSlaveNum,
                                        _uiSlotNum,
                                        _uiChipNum,
                                        _uiRegAddr,
                                        _poGuiCommandLine ) ;

	// Make sure we start with an initialized adaptor
    CHardwareAccess::mg_poBit3BusAdaptor->ClearBit3Status ( ) ;

    CAdfRegBase oReg  ( fubTruncToByte(_uiMasterNum),
                        fubTruncToByte(_uiSlaveNum),
                        fubTruncToByte(_uiSlotNum),
                        fubTruncToByte(_uiChipNum),
                        fuwTruncToWord(_uiRegAddr) ) ;

	oReg.f_okReadReg ( &uwDataIn ) ;

    // Show current action
    CConsoleAccess::WriteLine ( (CString) " Register Read= " 
	  	                                + I_to_A( uwDataIn, 5, 10, ' ' )
		                                + " =" 
                                        + I_to_A( uwDataIn, 4, 16,'0' )
		                                + " =" 
                                        + I_to_A( uwDataIn, 16, 2,'0' ) 
		                                + "  " 
                                        + oReg.f_osVmeAddress() ) ;
    CConsoleAccess::WriteLine ( (CString) "_" 
                                        + oReg.f_osRegAddress() ) ;

    // check bit3 status 
    if ( CHardwareAccess::mg_poBit3BusAdaptor->CheckBit3Status ( ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Data
                                  + " " 
                                  + KsGuiXml_In 
                                  + "=\"" 
                                  + I_to_A ( uwDataIn )
                                  + "\"/></"
                                  + KsGuiXml_Reply 
                                  + ">" ) ;
    
    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Rio_WriteReg                 ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiChipNum,
                                                                       unsigned int        _uiRegAddr,
                                                                       unsigned int        _uiDataOut,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    TuwRegWord      uwDataIn ;
 
    //\\//

    CGuiCommandPrinter::Rio_WriteReg  ( _uiMasterNum,
                                        _uiSlaveNum,
                                        _uiSlotNum,
                                        _uiChipNum,
                                        _uiRegAddr,
                                        _uiDataOut,
                                        _poGuiCommandLine ) ;
    
	// Make sure we start with an initialized adaptor
    CHardwareAccess::mg_poBit3BusAdaptor->ClearBit3Status ( ) ;

    CAdfRegBase oReg  ( fubTruncToByte(_uiMasterNum),
                        fubTruncToByte(_uiSlaveNum),
                        fubTruncToByte(_uiSlotNum),
                        fubTruncToByte(_uiChipNum),
                        fuwTruncToWord(_uiRegAddr) ) ;

    oReg.f_okWriteReg ( (TuwRegWord*) &_uiDataOut ) ;
    uwDataIn = oReg.f_uwLastRead() ;

    // Show current action
    CConsoleAccess::WriteLine ( (CString) " Register Write= " 
	  	                                + I_to_A( _uiDataOut, 5, 10, ' ' )
		                                + " =" 
                                        + I_to_A( _uiDataOut, 4, 16,'0' )
		                                + " =" 
                                        + I_to_A( _uiDataOut, 16, 2,'0' ) 
		                                + "  " 
                                        + oReg.f_osVmeAddress() ) ;
    CConsoleAccess::WriteLine ( (CString) "_" 
                                        + oReg.f_osRegAddress() ) ;

    // check bit3 status 
    if ( CHardwareAccess::mg_poBit3BusAdaptor->CheckBit3Status ( ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Data
                                  + " " 
                                  + KsGuiXml_In 
                                  + "=\"" 
                                  + I_to_A ( uwDataIn )
                                  + "\"/></"
                                  + KsGuiXml_Reply 
                                  + ">" ) ;
    
    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Mio_MultiRead                ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiChipNum,
                                                                       unsigned int        _uiRegAddr,
                                                                       unsigned int        _uiRegSamples, 
                                                                       unsigned int        _uiCondMask,
                                                                       unsigned int        _uiCondValue,
                                                                       unsigned int        _uiMax_Try,
                                                                       unsigned int        _uiRegDumpToFile,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;
    
    CResultFile*        poDumpFile = NULL ;
    unsigned int        uiTotMatch ;
    unsigned int        uiTotReadTry ; 

    CString             osDumpFileName = "None" ;

    //\\//

    CGuiCommandPrinter::Mio_MultiRead ( _uiMasterNum,
                                        _uiSlaveNum,
                                        _uiSlotNum,
                                        _uiChipNum,
                                        _uiRegAddr,
                                        _uiRegSamples, 
                                        _uiCondMask,
                                        _uiCondValue,
                                        _uiMax_Try,
                                        _uiRegDumpToFile,
                                        _poGuiCommandLine ) ;

    if ( _uiRegDumpToFile != 0 )
    {
        //build a File Name
        osDumpFileName = "MioDump_" ;
        osDumpFileName += (CString) KsVersion
                          + "_" 
                          + DateTag ()
                          + ".dat" ;
        AddFileVersion ( &osDumpFileName ) ;
        // create object
        poDumpFile = new CResultFile ( osDumpFileName ) ;
        // Open a file to write register samples
        if ( poDumpFile->OpenForWrite () != Ok )
        {
            CConsoleAccess::ErrorLine ( "Failed Creating Dump File" ) ;
            poDumpFile = NULL ; // the histogramming routine will not write
        }
    }



    CAdfRegBase oReg  ( fubTruncToByte(_uiMasterNum),
                        fubTruncToByte(_uiSlaveNum),
                        fubTruncToByte(_uiSlotNum),
                        fubTruncToByte(_uiChipNum),
                        fuwTruncToWord(_uiRegAddr) ) ;

    // Show current action
    CConsoleAccess::WriteLine ( (CString) " Looking for " 
	  	                                + I_to_A( _uiRegSamples )
		                                + " Sample(s) w/ Condition Mask/Val= " 
                                        + I_to_A( _uiCondMask, 4, 16,'0' )
		                                + "/" 
                                        + I_to_A( _uiCondValue, 4, 16,'0' )
		                                + " for up to " 
                                        + I_to_A( _uiMax_Try )
		                                + "s" ) ;
    CConsoleAccess::WriteLine ( (CString) "_" 
                                        + oReg.f_osRegAddress() ) ;

 
    // Collect the data
    TuwRegWord      uwDataIn = 0 ;
    if ( oReg.f_okMultiRead   ( &uwDataIn,
                                _uiRegSamples, 
                                _uiCondMask,
                                _uiCondValue,
                                _uiMax_Try,
                                &uiTotMatch,
                                &uiTotReadTry, 
                                 poDumpFile ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    // done with result file, delete will close the file too
    if ( poDumpFile != 0 ) delete poDumpFile ; 

    // Show current action
    if ( eReturnStatus == GuiReply_Ok) 
    {
        CConsoleAccess::WriteLine ( (CString) " First Match to Mask/Val="
                                            + I_to_A( _uiCondMask, 4, 16,'0' )
		                                    + "/" 
	  	                                    + I_to_A( _uiCondValue, 4, 16,'0' )
		                                    + " Read= " 
	  	                                    + I_to_A( uwDataIn, 5, 10, ' ' )
		                                    + " =" 
                                            + I_to_A( uwDataIn, 4, 16,'0' )
		                                    + " =" 
                                            + I_to_A( uwDataIn, 16, 2,'0' ) ) ;
        CConsoleAccess::WriteLine ( (CString) " Total Match " 
	  	                                    + I_to_A( uiTotMatch )
		                                    + " after " 
                                            + I_to_A( uiTotReadTry )
		                                    + " Reg Read" ) ;
    }
    else
        CConsoleAccess::ErrorLine ( (CString) " No Match after " 
                                            + I_to_A( uiTotReadTry )
		                                    + " Reg Read" ) ;


    // check bit3 status 
    if ( CHardwareAccess::mg_poBit3BusAdaptor->CheckBit3Status ( ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Data
                                  + " " 
                                  + KsGuiXml_In 
                                  + "=\"" 
                                  + I_to_A ( uwDataIn )
                                  + "\"/></"
                                  + KsGuiXml_Reply 
                                  + ">" ) ;
    

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Hst_10BitHisto               ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiChipNum,
                                                                       unsigned int        _uiRegAddr,
                                                                       unsigned int        _uiRegSamples, 
                                                                       unsigned int        _uiRegAddrIncr,
                                                                       unsigned int        _uiRegDumpToFile,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;
    
    CResultFile*        poAdcDumpFile = NULL ;
    TAdcHisto           auwHistogram ;

    CString             osAdcDumpFileName = "None" ;

    //\\//

    CGuiCommandPrinter::Hst_10BitHisto( _uiMasterNum,
                                        _uiSlaveNum,
                                        _uiSlotNum,
                                        _uiChipNum,
                                        _uiRegAddr,
                                        _uiRegSamples, 
                                        _uiRegAddrIncr,
                                        _uiRegDumpToFile,
                                        _poGuiCommandLine ) ;

    if ( _uiRegDumpToFile != 0 )
    {
        //build a File Name
        osAdcDumpFileName = "HstDump_" ;
        osAdcDumpFileName += (CString) KsVersion
                              + "_" 
                              + DateTag ()
                              + ".dat" ;
        AddFileVersion ( &osAdcDumpFileName ) ;
        // create object
        poAdcDumpFile = new CResultFile ( osAdcDumpFileName ) ;
        // Open a file to write register samples
        if ( poAdcDumpFile->OpenForWrite () != Ok )
        {
            CConsoleAccess::ErrorLine ( "Failed Creating Adc Dump File" ) ;
            poAdcDumpFile = NULL ; // the histogramming routine will not write
        }
    }


    CAdfRegBase oReg  ( fubTruncToByte(_uiMasterNum),
                        fubTruncToByte(_uiSlaveNum),
                        fubTruncToByte(_uiSlotNum),
                        fubTruncToByte(_uiChipNum),
                        fuwTruncToWord(_uiRegAddr) ) ;

    // Collect the histogram
    if ( oReg.f_okHisto10bits  ( &auwHistogram, _uiRegSamples, _uiRegAddrIncr, poAdcDumpFile ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    double  fAverage   = CAdfRegBase::HistoAverage10bit    ( &auwHistogram, _uiRegSamples ) ; 
    double  fDeviation = CAdfRegBase::HistoDeviation10bit  ( &auwHistogram, _uiRegSamples, fAverage ) ;

    // Show resulting histogram
    CConsoleAccess::WriteLine ( (CString) " Histogram (10 LSbits): " 
                                          + DumpHistogram  ( auwHistogram,
                                                             KiSizeOfTAdcHisto,
                                                            &fAverage,
                                                            &fDeviation ) ) ;

    // done with result file, delete will close the file too
    if ( poAdcDumpFile != 0 ) delete poAdcDumpFile ; 

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Data
                                  + " " 
                                  + KsGuiXml_Average
                                  + "=\"" 
                                  + F_to_A ( fAverage, 2, 5 )
                                  + "\" " 
                                  + KsGuiXml_Deviation
                                  + "=\"" 
                                  + F_to_A ( fDeviation, 2, 5 )
                                  + "\"/>" ) ;

    if ( _uiRegDumpToFile != 0 )
    strcat ( sReplyText, (CString) "<" 
                                  + KsGuiXml_File
                                  + " " 
                                  + KsGuiXml_Name
                                  + "=\"" 
                                  + osAdcDumpFileName
                                  + "\"/>" ) ;

    strcat ( sReplyText, (CString) "</" + KsGuiXml_Reply + ">" ) ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Sio_ReadReg                  ( unsigned int        _uiTabGab_Module,
                                                                       unsigned int        _uiChip_Address,
                                                                       unsigned int        _uiGroup_Address,
                                                                       unsigned int        _uiSerial_Address,
                                                                       unsigned int        _uiSerial_Data,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    unsigned long   ulDataIn ;
 
    //\\//

    CGuiCommandPrinter::Sio_ReadReg  ( _uiTabGab_Module,
                                       _uiChip_Address,
        		                       _uiGroup_Address,
                                       _uiSerial_Address,
                                       _uiSerial_Data,
                                       _poGuiCommandLine ) ;

	// Make sure we start with an initialized adaptor
    CHardwareAccess::mg_poBit3BusAdaptor->ClearBit3Status ( ) ;

	if ( vmescl_read_serial  ( _uiTabGab_Module, 
		                       _uiChip_Address, 
		                       _uiGroup_Address,
		                       _uiSerial_Address,
		                       _uiSerial_Data,
                              &ulDataIn )               != EXIT_SUCCESS ) 
        eReturnStatus = GuiReply_Bad ;

    // Show current action
    CConsoleAccess::WriteLine ( (CString) " Serial Read = " 
	  	                                + I_to_A( ulDataIn, 5, 10, ' ' )
		                                + " =" 
                                        + I_to_A( ulDataIn, 4, 16,'0' )
		                                + " =" 
                                        + I_to_A( ulDataIn, 16, 2,'0' ) ) ;
    CConsoleAccess::WriteLine ( (CString) "_@Module#" + I_to_A( _uiTabGab_Module,  1 )
                                         + "/Chip#"   + I_to_A( _uiChip_Address,   2 ) 
                                         + "/Group#"  + I_to_A( _uiGroup_Address,  2 )
                                         + "/SerAddr#"+ I_to_A( _uiSerial_Address, 4, 16,'0' )
                                         + "/SerData#"+ I_to_A( _uiSerial_Data,    4, 16,'0' ) ) ;

    // check bit3 status 
    if ( CHardwareAccess::mg_poBit3BusAdaptor->CheckBit3Status ( ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Data
                                  + " " 
                                  + KsGuiXml_In 
                                  + "=\"" 
                                  + I_to_A ( ulDataIn )
                                  + "\"/></"
                                  + KsGuiXml_Reply 
                                  + ">" ) ;
    
    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Sio_WriteReg                 ( unsigned int        _uiTabGab_Module,
                                                                       unsigned int        _uiChip_Address,
                                                                       unsigned int        _uiGroup_Address,
                                                                       unsigned int        _uiSerial_Address,
                                                                       unsigned int        _uiSerial_Data,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Sio_WriteReg ( _uiTabGab_Module,
                                       _uiChip_Address,
        		                       _uiGroup_Address,
                                       _uiSerial_Address,
                                       _uiSerial_Data,
                                       _poGuiCommandLine ) ;

	// Make sure we start with an initialized adaptor
    CHardwareAccess::mg_poBit3BusAdaptor->ClearBit3Status ( ) ;

	if ( vmescl_write_serial ( _uiTabGab_Module, 
		                       _uiChip_Address, 
		                       _uiGroup_Address,
		                       _uiSerial_Address,
		                       _uiSerial_Data )               != EXIT_SUCCESS ) 
        eReturnStatus = GuiReply_Bad ;

    // Show current action
    CConsoleAccess::WriteLine ( (CString) " Serial Write= " 
	  	                                + I_to_A( _uiSerial_Data, 5, 10, ' ' )
		                                + " =" 
                                        + I_to_A( _uiSerial_Data, 4, 16,'0' )
		                                + " =" 
                                        + I_to_A( _uiSerial_Data, 16, 2,'0' ) ) ;
    CConsoleAccess::WriteLine ( (CString) "_@Module#" + I_to_A( _uiTabGab_Module,  1 )
                                         + "/Chip#"   + I_to_A( _uiChip_Address,   2 ) 
                                         + "/Group#"  + I_to_A( _uiGroup_Address,  2 )
                                         + "/SerAddr#"+ I_to_A( _uiSerial_Address, 4, 16,'0' ) ) ;

    // check bit3 status 
    if ( CHardwareAccess::mg_poBit3BusAdaptor->CheckBit3Status ( ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Sio_VmeSclStatus             ( CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    unsigned long       ulStatus ;

    //\\//

    CGuiCommandPrinter::Sio_VmeSclStatus  ( _poGuiCommandLine ) ;

    CConsoleAccess::WriteLine ( (CString) " Getting VME/SCL Status " ) ;

    if ( vmescl_status_read  ( &ulStatus ) != EXIT_SUCCESS ) 
        eReturnStatus = GuiReply_Bad ;
    else
        vmescl_status_print  ( ulStatus ) ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Cfg_ConfigFPGA               ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiFpgaMask,
                                                                       char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Cfg_ConfigFPGA( _uiMasterNum,
                                        _uiSlaveNum,
                                        _uiSlotNum,
                                        _uiFpgaMask,
                                        _psFileName,
                                        _poGuiCommandLine ) ;
    
    CAdfCardBase    oTargetCard   ( _uiMasterNum,
                                    _uiSlaveNum,
                                    _uiSlotNum ) ;

    if ( ConfigureAdfFpga    ( &oTargetCard,
                               _uiFpgaMask, 
                               _psFileName ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Tcf_ConfigTabGab             ( unsigned int        _uiModuleNum,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Tcf_ConfigTabGab  ( _uiModuleNum,
                                            _poGuiCommandLine ) ;

    if ( Tab_or_Gab_Configure  ( _uiModuleNum ) != EXIT_SUCCESS )
        eReturnStatus = GuiReply_Bad ;


    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Rrt_ClearAll                 ( CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Rrt_ClearAll  ( _poGuiCommandLine ) ;
    
    DlgTestRandReg_ClearAll ( ) ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Rrt_AddRange                 ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiChipNum,
                                                                       unsigned int        _uiRegAddrStart,
                                                                       unsigned int        _uiRegAddrCount,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Rrt_AddRange    ( _uiMasterNum,
                                          _uiSlaveNum,
                                          _uiSlotNum,
                                          _uiChipNum,
                                          _uiRegAddrStart,
                                          _uiRegAddrCount,
                                          _poGuiCommandLine ) ;
    
    if ( DlgTestRandReg_AddRange( _uiMasterNum,
                                  _uiSlaveNum,
                                  _uiSlotNum,
                                  _uiChipNum,
                                  _uiRegAddrStart,
                                  _uiRegAddrCount ) != Ok )
      eReturnStatus = GuiReply_Bad ;
                                  

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Rrt_StartTest                ( unsigned int        _uiTestLoop,
                                                                       unsigned int        _uiExponent,
                                                                       bool                _lOnErrorStop,
                                                                       bool                _lOnErrorVerifyAll,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Rrt_StartTest    ( _uiTestLoop,
                                           _uiExponent,
                                           _lOnErrorStop,
                                           _lOnErrorVerifyAll,
                                           _poGuiCommandLine ) ;
    
    DlgTestRandReg_StartTest ( _uiTestLoop,
                               _uiExponent,
                               _lOnErrorStop,
                               _lOnErrorVerifyAll ) ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Adc_Capture                  ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiTtRelEta,
                                                                       unsigned int        _uiTtRelPhi,
                                                                       unsigned int        _uiTtEtaSign,
                                                                       unsigned int        _uiTtEtaMagn,
                                                                       unsigned int        _uiTtPhi,
                                                                       ETT_Chan_Type       _eTtType,
                                                                       unsigned int        _uiThreshold,
                                                                       unsigned int        _uiMaxTry,
                                                                       unsigned int        _uiAdcDumpToFile,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;
    
    CAdfCardBase*       poAdfCard ;
    CL1Cal_TrgTwr*      poTrgTwr ;

    CResultFile*        poAdcDumpFile = NULL ;
    TAdcArrayT7         auwAdcArray ;
    TuwRegWord          uwMaxAdcValue = 0 ; 

    CString             osAdcDumpFileName = "None" ;

    //\\//

    CGuiCommandPrinter::Adc_Capture   ( _uiMasterNum,
                                        _uiSlaveNum,
                                        _uiSlotNum,
                                        _uiTtRelEta,
                                        _uiTtRelPhi,
                                        _uiTtEtaSign,
                                        _uiTtEtaMagn,
                                        _uiTtPhi,
                                        _eTtType,
                                        _uiThreshold,
                                        _uiMaxTry,
                                        _uiAdcDumpToFile,
                                        _poGuiCommandLine ) ;

    if ( _uiAdcDumpToFile != 0 )
    {
        //build a File Name
        osAdcDumpFileName = "AdcCapture_" ;
        osAdcDumpFileName += (CString) KsVersion
                              + "_" 
                              + DateTag ()
                              + ".dat" ;
        AddFileVersion ( &osAdcDumpFileName ) ;
        // create object
        poAdcDumpFile = new CResultFile ( osAdcDumpFileName ) ;
        // Open a file to write register samples
        if ( poAdcDumpFile->OpenForWrite () != Ok )
        {
            CConsoleAccess::ErrorLine ( "Failed Creating Adc Capture File" ) ;
            poAdcDumpFile = NULL ; // the histogramming routine will not write
        }
    }

    // There are two ways to specify the target tower
    if ( _uiSlotNum != 0 ) 
    {
        // This Adf Card 
        poAdfCard = new CAdfCardBase  ( fubTruncToByte(_uiMasterNum),
                                        fubTruncToByte(_uiSlaveNum),
                                        fubTruncToByte(_uiSlotNum) ) ;


        // This Trigger Tower
        poTrgTwr  = new CL1Cal_TrgTwr  ( eTT_Eta_Pos,       // let's pretend this temporary tower is at positive eta
                                        _uiTtRelEta+1,      // Eta is 1-based while relative eta is 0-based
                                        _uiTtRelPhi+1,      // Phi
                                         NULL,              // pointer for linked chain (unused here)
                                         KiOutputEtZer,     // EM ADC Zeresp
                                         KiOutputEtZer,     // HD ADC Zeresp
                                         poAdfCard ) ;       // pointer to mother ADF card handling this tower
    }
    else
    {
        poTrgTwr = CL1Cal::GetTrigTwrPointer ( _uiTtEtaSign,
                                               _uiTtEtaMagn,
                                               _uiTtPhi ) ;
    }
    

    // verify the trigger tower was found
    if ( poTrgTwr == NULL ) 
    {
        eReturnStatus = GuiReply_Bad ;
        poTrgTwr = NULL ;
        strcpy ( sReplyText, (CString) "<ERROR NAME=\"No Trigger Tower Found\"/></REPLY>" ) ;
    }
    else
    {

        CConsoleAccess::WriteLine     ( (CString) " "
                                                + poTrgTwr->f_poMotherAdf()->f_osBaseAddress ()
                                                + " "
                                                + poTrgTwr->f_osTrgTwr_Coord ( _eTtType )
                                                + " Wait up to "
                                                + I_to_A( _uiMaxTry )
                                                + " second for ADC .GT."
                                                + I_to_A ( _uiThreshold, 4 ) ) ;

        //Capture successive Samples untill finding requested energy
        if ( poTrgTwr->ADC_Capture    ( _eTtType,
                                        _uiThreshold,
                                        _uiMaxTry,
                                         auwAdcArray,
                                         poAdcDumpFile ) != Ok ) 
            eReturnStatus = GuiReply_Bad ;

        // Show resulting histogram
        if ( eReturnStatus == GuiReply_Ok ) 
            CConsoleAccess::WriteLine ( (CString) " Captured : " 
                                                  + DumpPeaks     ( auwAdcArray,
                                                                    sizeof(auwAdcArray)/sizeof(TuwRegWord),
                                                                   _uiThreshold,
                                                                   &uwMaxAdcValue ) ) ;

        if ( _uiThreshold != 0 )
        {
            // Locate peaks
            CString         osDump = "" ;
            unsigned long   ulCurrentValue ;
            unsigned long   ulpreviousValue ;
            unsigned long   ulCurrentMaxValue    = 0 ;
            unsigned long   ulCurrentMaxLocation = 0 ;
            unsigned long   ulTotPeakFound       = 0 ;
            for ( int iSampleNum = 0 ; iSampleNum < KiAdfAdcSampleLength_T7 ; iSampleNum  ++ )
            {
                ulpreviousValue = ulCurrentValue ;
                ulCurrentValue  = auwAdcArray[iSampleNum] ;

                if ( ulCurrentValue > ulCurrentMaxValue ) // the level is increasing
                {
                    ulCurrentMaxValue    = ulCurrentValue ;
                    ulCurrentMaxLocation = iSampleNum ;
                }

                else if ( ulCurrentMaxValue != 0 ) // we passed a peak
                {
                    if ( ( ulCurrentValue > ulpreviousValue ) // we are done decreasing
                      || ( iSampleNum    == KiAdfAdcSampleLength_T7 -1 ) ) // or this is the end of the array
                    {
                        if ( ulCurrentMaxValue >= _uiThreshold ) // only report peaks above threshold
                        {
                            ulTotPeakFound ++ ;

                            unsigned long   ulTickNum ;
                            unsigned long   ulLiveXLocation ;
                            int iPeakToLiveX ;
                            int iPeakToLiveXMin = 600 ;
                            for ( unsigned long ulLiveXNum = 0 ; ulLiveXNum < kL1CalTcc_Tot_LiveBX ; ulLiveXNum ++ ) 
                            {
                                ulTickNum = CMonitPoolData::mg_aIndexToTick[ulLiveXNum] ;
                                 // build a one dimensional index and apply fixed address shift
                                ulLiveXLocation = KiTotSamplesPerTick * ( ulTickNum - 1 ) + CL1Cal::mg_uwOffsetTick1RawAdcMonit ;
                                // wrap around as needed
                                ulLiveXLocation %= KiTotSamplesPerTick * KiTotTicksInTurn ;
                                // calculate distance to the peak
                                iPeakToLiveX = ulCurrentMaxLocation - ulLiveXLocation ;
                                // remember the shortest distance
                                if ( abs ( iPeakToLiveX ) < abs ( iPeakToLiveXMin ) ) 
                                    iPeakToLiveXMin = iPeakToLiveX ;
                            }

                            osDump += " " 
                                    + I_to_A( ulCurrentMaxValue ) 
                                    + " @ " 
                                    + I_to_A( ulCurrentMaxLocation ) 
                                    + "(" ;
                            if ( iPeakToLiveXMin >= 0 ) osDump += "+" ;
                            osDump += I_to_A( iPeakToLiveXMin ) 
                                    + ")";
                        }
                        ulCurrentMaxValue = 0 ; // reset peak finding
                    }
                }
            }

            // report peaks
            CConsoleAccess::WriteLine     ( (CString) " "
                                                        + I_to_A( ulTotPeakFound )
                                                        + " Peak(s) Above Thresh (& dist to nearest LiveX):"
                                                        + osDump ) ;
        }

        strcpy ( sReplyText, (CString) "<" 
                                      + KsGuiXml_Data
                                      + " " 
                                      + KsGuiXml_Adc
                                      + "=\"" 
                                      + I_to_A ( uwMaxAdcValue )
                                      + "\"/>" ) ;

        if ( _uiAdcDumpToFile != 0 )
        strcat ( sReplyText, (CString) "<" 
                                      + KsGuiXml_File
                                      + " " 
                                      + KsGuiXml_Name
                                      + "=\"" 
                                      + osAdcDumpFileName
                                      + "\"/>" ) ;

        strcat ( sReplyText, (CString) "</" + KsGuiXml_Reply + ">" ) ;
    }

    APPEND_STATUS_TO_REPLY() ;

    // done with result file, delete will close the file too
    if ( poAdcDumpFile != 0 )  delete poAdcDumpFile ; 

    if ( _uiSlotNum != 0 ) 
    {
        delete poAdfCard  ;
        delete poTrgTwr ;
    }

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Dac_ProgOneDac               ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiTtRelEta,
                                                                       unsigned int        _uiTtRelPhi,
                                                                       unsigned int        _uiTtEtaSign,
                                                                       unsigned int        _uiTtEtaMagn,
                                                                       unsigned int        _uiTtPhi,
                                                                       ETT_Chan_Type       _eTtType,
                                                                       unsigned int        _uiDacValue,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    CL1Cal_TrgTwr*      poTrgTwr ;
    CAdfDacCtrl*        poDacCtrl ;

    //\\//

    CGuiCommandPrinter::Dac_ProgOneDac    ( _uiMasterNum,
                                            _uiSlaveNum,
                                            _uiSlotNum,
                                            _uiTtRelEta,
                                            _uiTtRelPhi,
                                            _uiTtEtaSign,
                                            _uiTtEtaMagn,
                                            _uiTtPhi,
                                            _eTtType,
                                            _uiDacValue,
                                            _poGuiCommandLine ) ;

    // There are two ways to specify the target tower
    if ( _uiSlotNum != 0 ) 
    {
        // temporary Dac Control Object
        poDacCtrl = new CAdfDacCtrl   ( fubTruncToByte(_uiMasterNum),
                                        fubTruncToByte(_uiSlaveNum),
                                        fubTruncToByte(_uiSlotNum) ) ;


        // temporary Trigger Tower, just to print its coordinates
        poTrgTwr  = new CL1Cal_TrgTwr  ( eTT_Eta_Pos,
                                        _uiTtRelEta, 
                                        _uiTtRelPhi ) ;

        CConsoleAccess::WriteLine     ( (CString) " Set ADF "
                                                + poDacCtrl->f_osHostCardAddress()
                                                + " Rel "
                                                + poTrgTwr->f_osTrgTwr_Coord ( _eTtType )
                                                + " i.e. Ch#"
                                                + I_to_A( 4*_uiTtRelEta + _uiTtRelPhi )
                                                + " DAC="
                                                + I_to_A ( _uiDacValue, 4 ) ) ;
    }
    else
    {
        poTrgTwr = CL1Cal::GetTrigTwrPointer ( _uiTtEtaSign,
                                               _uiTtEtaMagn,
                                               _uiTtPhi ) ;

        if ( poTrgTwr != NULL )
        {
            poDacCtrl = poTrgTwr->f_poMotherAdf()->m_poDacCtrl ;

            CConsoleAccess::WriteLine     ( (CString) " Set "
                                                    + poTrgTwr->f_osTrgTwr_Coord ( _eTtType )
                                                    + " DAC="
                                                    + I_to_A ( _uiDacValue, 4 ) ) ;
        }
    }
    
    // verify the trigger tower was found
    if ( poTrgTwr == NULL ) 
    {
        eReturnStatus = GuiReply_Bad ;
        poTrgTwr = NULL ;
        strcpy ( sReplyText, (CString) "<ERROR NAME=\"No Trigger Tower Found\"/></REPLY>" ) ;
    }
    else
    {
        //Write the DAC
        if ( poDacCtrl->f_okWriteOneDac   ( _eTtType,
                                            _uiTtRelEta,
                                            _uiTtRelPhi,
                                            _uiDacValue ) != Ok ) 
            eReturnStatus = GuiReply_Bad ;
    }

    APPEND_STATUS_TO_REPLY() ;

    if ( _uiSlotNum != 0 ) 
    {
        delete poTrgTwr ;
    }

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

EGuiCommandStatus  CGuiCommandExecuter::Dac_Find_DAC                 ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiTtRelEta,
                                                                       unsigned int        _uiTtRelPhi,
                                                                       unsigned int        _uiTtEtaSign,
                                                                       unsigned int        _uiTtEtaMagn,
                                                                       unsigned int        _uiTtPhi,
                                                                       ETT_Chan_Type       _eTtType,
                                                                       unsigned int        _uiAdcValue,
                                                                       unsigned int        _uiAdcDumpToFile,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    CAdfCardBase*       poAdfCard ;
    CL1Cal_TrgTwr*      poTrgTwr ;

    TuwRegWord          uwDacValue ;
    double              fAverage ;
    double              fDeviation ;
    double              fDevAverage ;
    bool                lShowDetails = true ;

    CString             osHistoFileName = "None" ;
    CResultFile*        poHistoFile = NULL ;

    //\\//

    CGuiCommandPrinter::Dac_Find_DAC      ( _uiMasterNum,
                                            _uiSlaveNum,
                                            _uiSlotNum,
                                            _uiTtRelEta,
                                            _uiTtRelPhi,
                                            _uiTtEtaSign,
                                            _uiTtEtaMagn,
                                            _uiTtPhi,
                                            _eTtType,
                                            _uiAdcValue,
                                            _uiAdcDumpToFile,
                                            _poGuiCommandLine ) ;

    if ( _uiAdcDumpToFile != 0 )
    {
        //build a File Name
        osHistoFileName = "Find_DAC_" ;
        osHistoFileName += (CString) KsVersion
                              + "_" 
                              + DateTag ()
                              + ".hst" ;
        AddFileVersion ( &osHistoFileName ) ;
        // create object
        poHistoFile = new CResultFile ( osHistoFileName ) ;
        // Open a file to write register samples
        if ( poHistoFile->OpenForWrite () != Ok )
        {
            CConsoleAccess::ErrorLine ( "Failed Creating Adc Dump File" ) ;
            poHistoFile = NULL ; // the histogramming routine will not write
        }
    }

    // There are two ways to specify the target tower
    if ( _uiSlotNum != 0 ) 
    {
        // This Adf Card 
        poAdfCard = new CAdfCardBase  ( fubTruncToByte(_uiMasterNum),
                                        fubTruncToByte(_uiSlaveNum),
                                        fubTruncToByte(_uiSlotNum) ) ;


        // This Trigger Tower
        poTrgTwr  = new CL1Cal_TrgTwr  ( eTT_Eta_Pos,       // let's pretend this temporary tower is at positive eta
                                        _uiTtRelEta+1,      // Eta is 1-based while relative eta is 0-based
                                        _uiTtRelPhi+1,      // Phi
                                         NULL,              // pointer for linked chain (unused here)
                                        _uiAdcValue,        // Desired Raw ADC Zeresp
                                        _uiAdcValue,        // Output Et Zeresp (unused here)
                                         poAdfCard ) ;       // pointer to mother ADF card handling this tower
    }
    else
    {
        poTrgTwr = CL1Cal::GetTrigTwrPointer ( _uiTtEtaSign,
                                               _uiTtEtaMagn,
                                               _uiTtPhi ) ;
    }
    

    // verify the trigger tower was found
    if ( poTrgTwr == NULL ) 
    {
        eReturnStatus = GuiReply_Bad ;
        poTrgTwr = NULL ;
        strcpy ( sReplyText, (CString) "<ERROR NAME=\"No Trigger Tower Found\"/></REPLY>" ) ;
    }
    else
    {
        CConsoleAccess::WriteLine     ( (CString) " "
                                                + poTrgTwr->f_poMotherAdf()->f_osBaseAddress ()
                                                + " "
                                                + poTrgTwr->f_osTrgTwr_Coord ( _eTtType )
                                                + " Find DAC for ADC="
                                                + I_to_A ( _uiAdcValue, 4 ) ) ;

        //Run Find_DAC on this tower
        if ( poTrgTwr->Find_DAC   ( _eTtType,
                                    &uwDacValue,
                                    &fAverage,
                                    &fDeviation,
                                    &fDevAverage,
                                     lShowDetails,
                                     poHistoFile ) != Ok ) 
            eReturnStatus = GuiReply_Bad ;


        strcpy ( sReplyText, (CString) "<" 
                                      + KsGuiXml_Data
                                      + " " 
                                      + KsGuiXml_Dac
                                      + "=\"" 
                                      + I_to_A ( uwDacValue )
                                      + "\" " 
                                      + KsGuiXml_Average
                                      + "=\"" 
                                      + F_to_A ( fAverage, 2, 5 )
                                      + "\" " 
                                      + KsGuiXml_Deviation
                                      + "=\"" 
                                      + F_to_A ( fDeviation, 2, 5 )
                                      + "\"/>" ) ;

        if ( _uiAdcDumpToFile != 0 )
        strcat ( sReplyText, (CString) "<" 
                                      + KsGuiXml_File
                                      + " " 
                                      + KsGuiXml_Name
                                      + "=\"" 
                                      + osHistoFileName
                                      + "\"/>" ) ;

        strcat ( sReplyText, (CString) "</" 
                                      + KsGuiXml_Reply
                                      + ">" ) ;

    }

    APPEND_STATUS_TO_REPLY() ;

    // done with result file, delete will close the file too
    if ( poHistoFile != NULL ) delete poHistoFile ; 

    if ( _uiSlotNum != 0 ) 
    {
        delete poAdfCard  ;
        delete poTrgTwr ;
    }

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Adf_InitCard                 ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Adf_InitCard  ( _uiMasterNum,
                                        _uiSlaveNum,
                                        _uiSlotNum,
                                        _poGuiCommandLine ) ;

	// Make sure we start with an initialized adaptor
    CHardwareAccess::mg_poBit3BusAdaptor->ClearBit3Status ( ) ;

    CAdfCardBase oCard( fubTruncToByte(_uiMasterNum),
                        fubTruncToByte(_uiSlaveNum),
                        fubTruncToByte(_uiSlotNum) ) ;

    // Show current action (already done by the Initialize function)
//    CConsoleAccess::WriteLine ( (CString) " Initialize Adf Card : " 
//	  	                                + oCard.f_osBaseAddress() ) ;

    // Initialize Card
    if ( oCard.Initialize ( )  != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Adf_SendPrn                  ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Adf_SendPrn   ( _uiMasterNum,
                                        _uiSlaveNum,
                                        _uiSlotNum,
                                        _poGuiCommandLine ) ;

	// Make sure we start with an initialized adaptor
    CHardwareAccess::mg_poBit3BusAdaptor->ClearBit3Status ( ) ;

    CAdfCardBase oCard( fubTruncToByte(_uiMasterNum),
                        fubTruncToByte(_uiSlaveNum),
                        fubTruncToByte(_uiSlotNum) ) ;

    // Show current action 
    CConsoleAccess::WriteLine ( (CString) " Setting up ADF Card " 
	  	                                + oCard.f_osBaseAddress() 
                                        + " to send Pseudo-Random Data" ) ;

    // Setup the Card to send Pseudo-Random Data
    if ( oCard.f_okStopPRN ( )          != Ok )         eReturnStatus = GuiReply_Bad ;
    if ( oCard.f_okLoadPRNSeeds ( )     != Ok )         eReturnStatus = GuiReply_Bad ;
    if ( oCard.f_okStartPRN ( )         != Ok )         eReturnStatus = GuiReply_Bad ;
    if ( oCard.f_okSendPseudoRandom ( ) != Ok )         eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Adf_SendBls                  ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Adf_SendBls   ( _uiMasterNum,
                                        _uiSlaveNum,
                                        _uiSlotNum,
                                        _poGuiCommandLine ) ;

	// Make sure we start with an initialized adaptor
    CHardwareAccess::mg_poBit3BusAdaptor->ClearBit3Status ( ) ;

    CAdfCardBase oCard( fubTruncToByte(_uiMasterNum),
                        fubTruncToByte(_uiSlaveNum),
                        fubTruncToByte(_uiSlotNum) ) ;

    // Show current action 
    CConsoleAccess::WriteLine ( (CString) " Setting up ADF Card " 
	  	                                + oCard.f_osBaseAddress() 
                                        + " to send BLS Data" ) ;

    // Setup the Card to send BLS Data 
    if ( oCard.f_okSendBlsData ( )          != Ok )         eReturnStatus = GuiReply_Bad ;
    if ( oCard.f_okFreezePseudoRandom ( )   != Ok )         eReturnStatus = GuiReply_Bad ;
    if ( oCard.f_okStopPRN ( )              != Ok )         eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Roc_AnalyzeEvt               ( CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Roc_AnalyzeEvt( _poGuiCommandLine ) ;

    CHsroL1Cal::mg_poHsroL1Cal->m_poVbd->Analyze() ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Roc_DumpEvt                  ( unsigned int        _ulTotLongDump,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Roc_DumpEvt   ( _ulTotLongDump,
                                        _poGuiCommandLine ) ;

    CHsroL1Cal::mg_poHsroL1Cal->m_poVbd->Dump( _ulTotLongDump ) ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Cmd_Vio_File                 ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    Custom_Structure_VmeIO          xCustom_VmeIO ;

    //\\//

    CGuiCommandPrinter::Cmd_Vio_File  ( _psFileName,
                                        _poGuiCommandLine ) ;

    if ( CommandFileVmeIO ( _psFileName, &xCustom_VmeIO) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Cmd_Rio_File                 ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    Custom_Structure_RegIO          xCustom_RegIO ;

    //\\//

    CGuiCommandPrinter::Cmd_Rio_File  ( _psFileName,
                                        _poGuiCommandLine ) ;

    if ( CommandFileRegisterIO ( _psFileName, &xCustom_RegIO ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Cmd_Sio_File                 ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    Custom_Structure_SerIO          xCustom_SerIO ;

    //\\//

    CGuiCommandPrinter::Cmd_Sio_File  ( _psFileName,
                                        _poGuiCommandLine ) ;

    if ( CommandFileSerialIO ( _psFileName, &xCustom_SerIO ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Cmd_Cfg_File                 ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    Custom_Structure_ConfigFpga          xCustom_ConfigFpga ;

    //\\//

    CGuiCommandPrinter::Cmd_Cfg_File  ( _psFileName,
                                        _poGuiCommandLine ) ;

    if ( CommandFileConfigFpga ( _psFileName, &xCustom_ConfigFpga ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Cmd_Tti_File                 ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    Custom_Structure_TT_Info          xCustom_TT_Info ;

    //\\//

    CGuiCommandPrinter::Cmd_Tti_File  ( _psFileName,
                                        _poGuiCommandLine ) ;

    if ( CommandFileTrigTwrInfo ( _psFileName, &xCustom_TT_Info ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Cmd_Msg_File                 ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    Custom_Structure_SelfMsg          xCustom_SelfMsg ;

    //\\//

    CGuiCommandPrinter::Cmd_Msg_File  ( _psFileName,
                                        _poGuiCommandLine ) ;

    if ( CommandFileSelfMsg ( _psFileName, &xCustom_SelfMsg ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Cmd_Mcf_File                 ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    Custom_Structure_Master          xCustom_Master ;

    //\\//

    CGuiCommandPrinter::Cmd_Mcf_File  ( _psFileName,
                                        _poGuiCommandLine ) ;

    if ( CommandFileMaster ( _psFileName, &xCustom_Master ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Daq_Start_Run                ( unsigned int        _uiRunNumber,
                                                                       unsigned int        _uiEventMax,
                                                                       unsigned int        _uiCoolDown,
                                                                       unsigned int        _uiModeBinary,
                                                                       char*               _psDirectory,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Daq_Start_Run   ( _uiRunNumber,
                                          _uiEventMax,
                                          _uiCoolDown,
                                          _uiModeBinary,
                                          _psDirectory,
                                          _poGuiCommandLine ) ;

    if ( CT962::mg_poT962->Start_Run    ( _uiRunNumber,
                                          _uiEventMax,
                                          _uiCoolDown,
                                          _uiModeBinary,
                                          _psDirectory ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Daq_Pause_Run            ( CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Daq_Pause_Run   ( _poGuiCommandLine ) ;

    if ( CT962::mg_poT962->Pause_Run    ( ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Daq_Resume_Run            ( CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Daq_Resume_Run   ( _poGuiCommandLine ) ;

    if ( CT962::mg_poT962->Resume_Run    ( ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Daq_Stop_Run            ( CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;

    //\\//

    CGuiCommandPrinter::Daq_Stop_Run   ( _poGuiCommandLine ) ;

    if ( CT962::mg_poT962->Stop_Run    ( ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;


    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandExecuter::Daq_Status                ( CGuiCommandLine*    _poGuiCommandLine ) 
{ 

    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] = "</REPLY>" ;
    
    unsigned long       ulRunNumber = 0 ;
    char                sRunState[16] = "?" ;
    char*               psRunState = sRunState ;

    unsigned long       ulEvtNumber = 0 ;
    char                sEvtState[16] = "?" ;
    char*               psEvtState = sEvtState ;


    //\\//

    CGuiCommandPrinter::Daq_Status   ( _poGuiCommandLine ) ;

    if ( CT962::mg_poT962->Status    ( &ulRunNumber,
                                        psRunState,
                                       &ulEvtNumber,
                                        psEvtState ) != Ok ) 
        eReturnStatus = GuiReply_Bad ;

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Run_Status
                                  + " " 
                                  + KsGuiXml_Run_Number 
                                  + "=\"" 
                                  + I_to_A ( ulRunNumber )
                                  + "\" "
                                  + KsGuiXml_State 
                                  + "=\"" 
                                  + psRunState
                                  + "\"/>" ) ;

    strcat ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Evt_Status
                                  + " " 
                                  + KsGuiXml_Evt_Number 
                                  + "=\"" 
                                  + I_to_A ( ulEvtNumber )
                                  + "\" "
                                  + KsGuiXml_State
                                  + "=\"" 
                                  + psEvtState
                                  + "\"/>" ) ;

    strcat ( sReplyText, (CString) "</" + KsGuiXml_Reply + ">" ) ;
    
    APPEND_STATUS_TO_REPLY_NO_INFOLINE() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/
