/*-------------------------------------------------------------------------------*/
  /*
     GuiCommandPrinter.cpp
     2-Nov-04
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"

#include "L1Cal_IIb_TCC/GlobalConstants.h"
#include "L1Cal_IIb_TCC/CustomDataTypes.h"

#include "L1Cal_IIb_TCC/GuiCommand.h"
#include                            "L1Cal_IIb_TCC/GuiCommandPrinter.h"

#include "L1Cal_IIb_TCC/HandleConsole.h"
#include "L1Cal_IIb_TCC/UtilsStrings.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Vio_ReadReg                    ( unsigned int        _uiVmeAddress,
                                                                        unsigned long       _ulRepeatCnt,
                                                                        char*               _psAddressSpace,
                                                                        char*               _psDataSize,
                                                                        char*               _psAccessPriv,
                                                                        char*               _psAccessType,
                                                                        char*               _psBit3Access,
                                                                        CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Vio_ReadReg 
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Vio_WriteReg                   ( unsigned int        _uiVmeAddress,
                                                                        unsigned int        _uiDataOut,
                                                                        unsigned long       _ulRepeatCnt,
                                                                        char*               _psAddressSpace,
                                                                        char*               _psDataSize,
                                                                        char*               _psAccessPriv,
                                                                        char*               _psAccessType,
                                                                        char*               _psBit3Access,
                                                                        CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Vio_WriteReg
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Rio_ReadReg                   ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiChipNum,
                                                                       unsigned int        _uiRegAddr,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Rio_ReadReg 
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Rio_WriteReg                  ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiChipNum,
                                                                       unsigned int        _uiRegAddr,
                                                                       unsigned int        _uiDataOut,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Rio_WriteReg
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Mio_MultiRead                 ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiChipNum,
                                                                       unsigned int        _uiRegAddr,
                                                                       unsigned int        _uiRegSamples, 
                                                                       unsigned int        _uiCondMask,
                                                                       unsigned int        _uiCondValue,
                                                                       unsigned int        _uiMax_Try,
                                                                       unsigned int        _uiRegDumpToFile,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Mio_MultiRead
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Hst_10BitHisto                ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiChipNum,
                                                                       unsigned int        _uiRegAddr,
                                                                       unsigned int        _uiRegSamples, 
                                                                       unsigned int        _uiRegAddrIncr,
                                                                       unsigned int        _uiRegDumpToFile,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Hst_10BitHisto
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Sio_ReadReg                   ( unsigned int        _uiTabGab_Module,
                                                                       unsigned int        _uiChip_Address,
                                                                       unsigned int        _uiGroup_Address,
                                                                       unsigned int        _uiSerial_Address,
                                                                       unsigned int        _uiSerial_Data,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Sio_ReadReg 
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Sio_WriteReg                  ( unsigned int        _uiTabGab_Module,
                                                                       unsigned int        _uiChip_Address,
                                                                       unsigned int        _uiGroup_Address,
                                                                       unsigned int        _uiSerial_Address,
                                                                       unsigned int        _uiSerial_Data,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Sio_WriteReg 
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Sio_VmeSclStatus              ( CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Sio_VmeSclStatus
                                  + "\">" ) ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Cfg_ConfigFPGA                ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiFpgaMask,
                                                                       char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Cfg_ConfigFpga 
                                  + "\">" ) ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Tcf_ConfigTabGab              ( unsigned int        _uiModuleNum,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Tcf_ConfigTabGab
                                  + "\">" ) ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    // display parameters
    CConsoleAccess::WriteLine ( (CString) " Configuring TAB/GAB module #"
                                          + I_to_A ( _uiModuleNum ) ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Rrt_ClearAll                  ( CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Rrt_ClearAll
                                  + "\">" ) ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Rrt_AddRange                  ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiChipNum,
                                                                       unsigned int        _uiRegAddrStart,
                                                                       unsigned int        _uiRegAddrCount,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Rrt_AddRange
                                  + "\">" ) ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Rrt_StartTest             ( unsigned int        _uiTestLoop,
                                                                   unsigned int        _uiExponent,
                                                                   bool                _lOnErrorStop,
                                                                   bool                _lOnErrorVerifyAll,
                                                                   CGuiCommandLine*    _poGuiCommandLine ) 

{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Rrt_StartTest
                                  + "\">" ) ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Adc_Capture                   ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       unsigned int        _uiTtRelEta,
                                                                       unsigned int        _uiTtRelPhi,
                                                                       unsigned int        _uiTtEtaSign,
                                                                       unsigned int        _uiTtEtaMagn,
                                                                       unsigned int        _uiTtPhi,
                                                                       ETT_Chan_Type       _eTtType,
                                                                       unsigned int        _uiThreshold,
                                                                       unsigned int        _uiMaxTry,
                                                                       unsigned int        _uiAdcDumpToFile,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Adc_Capture
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Dac_ProgOneDac            ( unsigned int        _uiMasterNum,
                                                                   unsigned int        _uiSlaveNum,
                                                                   unsigned int        _uiSlotNum,
                                                                   unsigned int        _uiTtRelEta,
                                                                   unsigned int        _uiTtRelPhi,
                                                                   unsigned int        _uiTtEtaSign,
                                                                   unsigned int        _uiTtEtaMagn,
                                                                   unsigned int        _uiTtPhi,
                                                                   ETT_Chan_Type       _eTtType,
                                                                   unsigned int        _uiDacValue,
                                                                   CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Dac_ProgOneDac
                                  + "\">" ) ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Dac_Find_DAC              ( unsigned int        _uiMasterNum,
                                                                   unsigned int        _uiSlaveNum,
                                                                   unsigned int        _uiSlotNum,
                                                                   unsigned int        _uiTtRelEta,
                                                                   unsigned int        _uiTtRelPhi,
                                                                   unsigned int        _uiTtEtaSign,
                                                                   unsigned int        _uiTtEtaMagn,
                                                                   unsigned int        _uiTtPhi,
                                                                   ETT_Chan_Type       _eTtType,
                                                                   unsigned int        _uiAdcValue,
                                                                   unsigned int        _uiAdcDumpToFile,
                                                                   CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Dac_Find_DAC
                                  + "\">" ) ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Adf_InitCard                  ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Adf_InitCard 
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Adf_SendPrn                   ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Adf_SendPrn 
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Adf_SendBls                   ( unsigned int        _uiMasterNum,
                                                                       unsigned int        _uiSlaveNum,
                                                                       unsigned int        _uiSlotNum,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Adf_SendBls 
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Roc_AnalyzeEvt                ( CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Roc_AnalyzeEvt 
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Roc_DumpEvt                   ( unsigned int        _ulTotLongDump,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Roc_DumpEvt 
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Cmd_Vio_File                  ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Com_ParseFile
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Cmd_Rio_File                  ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Com_ParseFile
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Cmd_Sio_File                  ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Com_ParseFile
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Cmd_Cfg_File                  ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Com_ParseFile
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Cmd_Tti_File                  ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Com_ParseFile
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Cmd_Msg_File                  ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Com_ParseFile
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Cmd_Mcf_File                  ( char*               _psFileName,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Com_ParseFile
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Daq_Start_Run                 ( unsigned int        _uiRunNumber,
                                                                       unsigned int        _uiEventMax,
                                                                       unsigned int        _uiCoolDown,
                                                                       unsigned int        _uiModeBinary,
                                                                       char*               _psDirectory,
                                                                       CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Daq_Run_Control
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Daq_Pause_Run            ( CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Daq_Run_Control
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Daq_Resume_Run            ( CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Daq_Run_Control
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Daq_Stop_Run            ( CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Daq_Run_Control
                                  + "\">") ;

    CConsoleAccess::WriteLine     ( sReplyText ) ;

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
EGuiCommandStatus  CGuiCommandPrinter::Daq_Status                ( CGuiCommandLine*    _poGuiCommandLine ) 
{ 
    EGuiCommandStatus   eReturnStatus = GuiReply_Ok ;
    char                sReplyText[KiMaxLengthReplyTextToGui] ;

    //\\//

    strcpy ( sReplyText, (CString) "<" 
                                  + KsGuiXml_Reply 
                                  + " " 
                                  + KsGuiXml_Name 
                                  + "=\"" 
                                  + KsGuiCmd_Daq_Run_Control
                                  + "\">") ;

//    CConsoleAccess::WriteLine     ( sReplyText ) ;    suppress this line

    if ( _poGuiCommandLine != NULL )
         _poGuiCommandLine->AppendReplyText ( sReplyText ) ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/
