/*-------------------------------------------------------------------------------*/
  /*
    HandleConsoleForNevis.cpp
    6-Dec-05
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"

#include "L1Cal_IIb_TCC/GlobalConstants.h"
#include "L1Cal_IIb_TCC/CustomDataTypes.h"

#include "L1Cal_IIb_TCC/HandleConsole.h"

#include "L1Cal_IIb_TCC/ResourceLocks.h"

#include "tabgab/util.h"
#include <stdarg.h>

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

char    sBufferString [1024] ; // generously sized string buffer as there is no overflow protection.
char*   psBufferString = sBufferString ;

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

/* tabgab uses this routine for outputting error messages */
void error ( char* psFmt, ...)
{
    va_list args;

    va_start(args, psFmt);

      CResourceLocks::Acquire_NevisScreenIO ( ) ; // use a separate lock as linux-ACE does not seem to allow acquiring twice
    
        vsprintf ( psBufferString, psFmt, args ) ;

        CConsoleAccess::ErrorLine  ( (CString) "$" + psBufferString ) ;
    
      CResourceLocks::Release_NevisScreenIO ( ) ;
    
    va_end(args);
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

/* tabgab uses this routine for outputting informational messages */
void info ( char* psFmt, ...)
{
    va_list args;

    va_start(args, psFmt);

      CResourceLocks::Acquire_NevisScreenIO ( ) ;
    
        vsprintf ( psBufferString, psFmt, args ) ;

        CConsoleAccess::WriteLine  ( (CString) "$" + psBufferString ) ;
    
      CResourceLocks::Release_NevisScreenIO ( ) ;
    
    va_end(args);
}

