/*-------------------------------------------------------------------------------*/
  /*
    HandleRemoteConsole.cpp
    Class CRemoteConsoleServer
     2-Jul-99
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"

#include "L1Cal_IIb_TCC/GlobalConstants.h"
#include "L1Cal_IIb_TCC/CustomDataTypes.h"

#include "L1Cal_IIb_TCC/HandleItcServer.h"

#include                            "L1Cal_IIb_TCC/HandleRemoteConsole.h"

#include "L1Cal_IIb_TCC/HandleConsole.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
// global variable to keep track of Remote Console server thread
ItcServer*  gpRemCons_ServerThread = NULL ;

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess  InitRemoteConsole ( unsigned short _iIP_port_num ) 
{
    ESuccess    eReturnStatus = Ok ;

    CConsoleAccess::WriteLine ( (CString) "Creating Remote Console Server" ) ;
    
    //
    // Create a server Thread, and accept connections
    //

    gpRemCons_ServerThread = new ItcServer ( _iIP_port_num );
    gpRemCons_ServerThread->start ( );

    return eReturnStatus ;
} ;

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess  CopyToRemoteConsole ( const char*       const _sString ) 
{
    ESuccess    eReturnStatus = Ok ;
    ESuccess    eStatus ;

    //\\//

    if ( gpRemCons_ServerThread != NULL )
    {
        eStatus = gpRemCons_ServerThread->SendMessage ( _sString ) ;

        if ( eStatus != Ok )
        {
            eReturnStatus = eStatus ;
        }
    }

    return eReturnStatus ;
} ;

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess  ShutdownRemoteConsole ( )
{
    ESuccess    eReturnStatus = Ok ;

    CConsoleAccess::WriteLine ( (CString) "Shutting down Remote Console  Server" ) ;    

    //
    // Delete the server Threads
    //

    if ( gpRemCons_ServerThread != NULL )
        delete gpRemCons_ServerThread ;

    return eReturnStatus ;
} ;

