/*-------------------------------------------------------------------------------*/
  /*
    HsroL1Cal.cpp
    Class CHsroL1Cal
    4-Jul-01  L1Cal VRB Crate
  */
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/StdAfx.h"

#include "L1Cal_IIb_TCC/GlobalConstants.h"
#include "L1Cal_IIb_TCC/CustomDataTypes.h"

#include                            "L1Cal_IIb_TCC/HsroL1Cal.h"

#include "L1Cal_IIb_TCC/HandleConsole.h"
#include "L1Cal_IIb_TCC/UtilsStrings.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
// Static data members must be initialized at file scope
CHsroL1Cal*       CHsroL1Cal::mg_poHsroL1Cal = NULL ; 

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CHsroL1Cal::CHsroL1Cal       ( )  
          : CHsroCrate       ( )  
{

    //\\//

    CConsoleAccess::WriteLine ( (CString) "" ) ;
    CConsoleAccess::WriteLine ( (CString) "Creating L1Cal Readout Crate Objects" ) ;


    //Create All VRBs in L1Cal Readout Crate
    CConsoleAccess::WriteLine ( (CString) " Creating L1Cal VRB Card Objects" ) ;

    m_paoVrb[Ki_Ordinal_Vrb_L1Cal_0] = new CHsroVrbCard  ( Ki_Id_Vrb_L1Cal_0, &m_poLastVrbCard ) ;
    m_paoVrb[Ki_Ordinal_Vrb_L1Cal_1] = new CHsroVrbCard  ( Ki_Id_Vrb_L1Cal_1, &m_poLastVrbCard ) ;
    m_paoVrb[Ki_Ordinal_Vrb_L1Cal_2] = new CHsroVrbCard  ( Ki_Id_Vrb_L1Cal_2, &m_poLastVrbCard ) ;


    //Create the VRB Controller in L1Cal Readout Crate
    CConsoleAccess::WriteLine ( (CString) " Creating L1Cal VRB Controller Card Object" ) ;

    m_poVrbContr =          new CHsroVrbContrCard  ( Ki_Id_Vrb_L1Cal_Controller ) ;

    
    //Create the VBD in L1Cal Readout Crate
    CConsoleAccess::WriteLine ( (CString) " Creating L1Cal VBD Card Object" ) ;
    
    m_poVbd =               new CHsroVbdCard  ( Ki_Id_Vbd_L1Cal ) ;


    // We DO NOT set the Static data member here, 
    // but let the main program in L1Cal_IIb_TCC decide which object is "The" global one
    // i.e. not mg_poHsroL1Cal = this ; 

    return ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CHsroL1Cal::~CHsroL1Cal       ()
{
    //Objects are deleted in the base class destructor


    //Reset the global pointer
    CHsroL1Cal::mg_poHsroL1Cal   = NULL ;

}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CHsroL1Cal::Initialize        ( ) 
{
    ESuccess        eReturnStatus = Ok ;

    //\\//

    CConsoleAccess::WriteLine ( "" ) ;
    CConsoleAccess::WriteLine ( (CString) "Initializing L1Cal Readout Crate" ) ;

    //Initialization is done via the base class
    if ( CHsroCrate::Initialize () != Ok ) eReturnStatus = Error ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess CHsroL1Cal::VmeSysReset ( ) 
{
    CConsoleAccess::WriteLine ( "" ) ;
    CConsoleAccess::SystemLine ( (CString) "Causing VMESYSRESET in L1Cal Readout Crate" ) ;

    return CHsroCrate::VmeSysReset ( Ki_VME_Reset_Addr_Vbd_L1Cal ) ;
}

/*-------------------------------------------------------------------------------*/
