/*-------------------------------------------------------------------------------*/
  /*
     MessageConsumer.cpp
     7-Oct-99
     28-Oct-99 Coor Command Parsing split onto separate files
     22-Sep-2005 Restructred for L1Cal_IIb_TCC
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"

#include                            "L1Cal_IIb_TCC/MessageConsumer.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CMessageConsumer::CMessageConsumer ( ) 
                : CMessageCommandLine (),
                  CMessageTokenizer (),
                  CMessageCoorParser (),
                  CMessageCoorDispatcher (),
                  CMessageCoorExecuter (),
                  CMessageMgrParser (),
                  CMessageMgrDispatcher (),
                  CMessageMgrExecuter ()

{
    // allow the parser components to add their keywords
    CMessageCoorParser::AddKeywords ( this ) ;
    CMessageMgrParser::AddKeywords ( this ) ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CMessageConsumer::~CMessageConsumer ( ) 
{
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus CMessageConsumer::ConsumeMessage       ( const char*         _psMessageCoor,
                                                            char*               _psReplyText,
                                                            unsigned int        _uiMaxReplyLength ) 
{ 
    ECoorMessageStatus  eReturnStatus ;

    //\\//

    //Get a hold of the new command
    CMessageCommandLine::NewRawCommand ( _psMessageCoor, _psReplyText, _uiMaxReplyLength ) ;

    // first step is to break this line down into tokens
    ////////////////////////////////////////////////////
    eReturnStatus = CMessageTokenizer::ParseTokenize ( this ) ;

    if ( eReturnStatus != Reply_Ok )        goto Done ;

    // second step is to interpret the tokens 
    // and turn them into one or more commands
    //////////////////////////////////////////////
    if ( m_lTokenList.FirstEntry()->GetValue() <= Ki_CoorCmd_MaxID_L1Cal )
        eReturnStatus = CMessageCoorParser::ParseMessage        ( this ) ;
    else 
        eReturnStatus = CMessageMgrParser::ParseMessage         ( this ) ;

    if ( eReturnStatus != Reply_Ok )        goto Done ;

    // third step is to dispatch+execute the command
    //////////////////////////////////////////////
    if ( m_lTokenList.FirstEntry()->GetValue() <= Ki_CoorCmd_MaxID_L1Cal )
        eReturnStatus = CMessageCoorDispatcher::MessageDispatch ( this, this ) ;
    else 
        eReturnStatus =  CMessageMgrDispatcher::MessageDispatch ( this, this ) ;

Done :

    return eReturnStatus ;
}


