/*-------------------------------------------------------------------------------*/
  /*
     MessageCoorConsumer.cpp
     7-Oct-99
     28-Oct-99 Coor Command Parsing split onto separate files
     22-Sep-2005 Restructred for L1Cal_IIb_TCC
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"

#include                            "L1Cal_IIb_TCC/MessageCoorConsumer.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

CMessageCoorConsumer::CMessageCoorConsumer ( ) 
                    : CMessageCommandLine (),
                      CMessageTokenizer (),
                      CMessageCoorParser (),
                      CMessageCoorDispatcher (),
                      CMessageCoorExecuter ()

{
    // allow the parser components to add their keywords
    CMessageCoorParser::AddKeywords ( this ) ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CMessageCoorConsumer::~CMessageCoorConsumer ( ) 
{
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus CMessageCoorConsumer::ConsumeCoorMessage   ( const char*         _psMessageCoor,
                                                                char*               _psReplyText,
                                                                unsigned int        _uiMaxReplyLength ) 
{ 
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    //\\//

    //Get a hold of the new command
    CMessageCommandLine::NewRawCommand ( _psMessageCoor, _psReplyText, _uiMaxReplyLength ) ;

    // first step is to break this line down into tokens
    ////////////////////////////////////////////////////
    eReturnStatus = CMessageTokenizer::ParseTokenize ( this ) ;
    if ( eReturnStatus != Reply_Ok )        goto Done ;

    // second step is to interpret the tokens 
    // and turn them into one or more commands
    //////////////////////////////////////////////
    eReturnStatus = CMessageCoorParser::ParseMessage        ( this ) ;
    if ( eReturnStatus != Reply_Ok )        goto Done ;

    // third step is to dispatch+execute the command
    //////////////////////////////////////////////
    eReturnStatus = CMessageCoorDispatcher::MessageDispatch ( this, this ) ;

Done :

    return eReturnStatus ;
}


