/*-------------------------------------------------------------------------------*/
  /*
     MessageMgrExecuter.cpp
     8-Jun-2000
     22-Sep-2005 Restructred for L1Cal_IIb_TCC
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"
#include <math.h>

#include "L1Cal_IIb_TCC/GlobalConstants.h"
#include "L1Cal_IIb_TCC/CustomDataTypes.h"

#include "L1Cal_IIb_TCC/MessageCommand.h"
#include                            "L1Cal_IIb_TCC/MessageMgrExecuter.h"

//#include "L1Cal_IIb_TCC/HandleCommandFiles.h"
//#include "L1Cal_IIb_TCC/CommandFileMaster.h"

#include "L1Cal_IIb_TCC/L1Cal.h"

#include "L1Cal_IIb_TCC/MonitControl.h"

#include "L1Cal_IIb_TCC/HandleConsole.h"
#include "L1Cal_IIb_TCC/HandleLogFile.h"
#include "L1Cal_IIb_TCC/UtilsStrings.h"
//#include "L1Cal_IIb_TCC/UtilsBits.h"

#include <math.h>

/*-------------------------------------------------------------------------------*/
// macros used in many of the commands
/////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////
#define APPEND_STATUS_TO_REPLY()                                                    \
    /* append success/error to reply text*/                                         \
    if ( _poCoorCommandLine != NULL )                                               \
        _poCoorCommandLine->AppendReplyText ( sReplyText ) ;                        \
    if ( eReturnStatus == Reply_Ok )                                                \
        CConsoleAccess::WriteLine     ( sReplyText ) ;                              \
    else                                                                            \
        CConsoleAccess::ErrorLine     ( sReplyText ) ;                              \
/////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////
#define CHECK_FOR_IO_ERROR()                                                        \
    if ( eReturnStatus == Reply_Bad )                                               \
        strcpy ( sReplyText, "<IO Error During Command Execution>" ) ;              \
/////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////
#define IF_TT_RANGE_WITHIN_COVERAGE( TT_COVERAGE )                                  \
  /*if*/ ( CL1Cal::mg_poL1Cal->f_okRangeInCoverage (TT_COVERAGE) != Ok)             \
    {                                                                               \
        eReturnStatus = Reply_Bad ;                                                 \
        strcpy ( sReplyText, "<L1CAL Trig Tower Range Problem, get expert assistance>" ) ;\
    }                                                                               \
    else /* we can perform the requested action */                                  \
/////////////////////////////////////////////////////////////////////////////////////

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::BaseAlignmentDelay       ( const unsigned long     _ulBaseDelay,
                                                                    CMessageCommandLine*    _poCoorCommandLine )

{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::BaseAlignmentDelay    ( _ulBaseDelay,
                                                _poCoorCommandLine ) ;

    CL1Cal::mg_ubBaseAlignDelay = _ulBaseDelay ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::OffsetTick1RawAdcMonit   ( const unsigned long     _ulIndexNum,
                                                                    CMessageCommandLine*    _poCoorCommandLine )

{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::OffsetTick1RawAdcMonit( _ulIndexNum,
                                                _poCoorCommandLine ) ;

    CL1Cal::mg_uwOffsetTick1RawAdcMonit = _ulIndexNum ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::OffsetTick1RawAdcSimu    ( const unsigned long     _ulIndexNum,
                                                                    CMessageCommandLine*    _poCoorCommandLine )

{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::OffsetTick1RawAdcSimu ( _ulIndexNum,
                                                _poCoorCommandLine ) ;

    CL1Cal::mg_uwOffsetTick1RawAdcSimu  = _ulIndexNum ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::OffsetTick1OutputEtMonit ( const unsigned long     _ulIndexNum,
                                                                    CMessageCommandLine*    _poCoorCommandLine )

{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::OffsetTick1OutputEtMonit ( _ulIndexNum,
                                                   _poCoorCommandLine ) ;

    CL1Cal::mg_uwOffsetTick1OutputEtMonit = _ulIndexNum ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::OffsetTick1OutputEtSimu  ( const unsigned long     _ulIndexNum,
                                                                    CMessageCommandLine*    _poCoorCommandLine )

{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::OffsetTick1OutputEtSimu ( _ulIndexNum,
                                                  _poCoorCommandLine ) ;

    CL1Cal::mg_uwOffsetTick1OutputEtSimu  = _ulIndexNum ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::OffsetTriggeredToTickAtCapture
                                                                  ( const unsigned long     _ulIndexNum,
                                                                    CMessageCommandLine*    _poCoorCommandLine )

{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::OffsetTriggeredToTickAtCapture
                                                ( _ulIndexNum,
                                                  _poCoorCommandLine ) ;

    CL1Cal::mg_uwOffsetTriggeredToTickAtCapture  = _ulIndexNum ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::L1Cal_Operational         ( CMessageCommandLine*    _poCoorCommandLine )

{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::L1Cal_Operational         ( _poCoorCommandLine ) ;

    CL1Cal::mg_eynL1CalOperational = Yes ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::L1Cal_Not_Operational     ( CMessageCommandLine*    _poCoorCommandLine )

{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::L1Cal_Not_Operational     ( _poCoorCommandLine ) ;

    CL1Cal::mg_eynL1CalOperational = No ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::Monit_Control_Time       ( const unsigned long     _ulTime_ms,
                                                                    CMessageCommandLine*    _poCoorCommandLine )

{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::Monit_Control_Time    ( _ulTime_ms,
                                                _poCoorCommandLine ) ;

    if ( _ulTime_ms == 0 )
    {
        CMonitControl::Set_Monit_Server_Silenced ( Yes ) ;
    }
    else if ( _ulTime_ms >= KiMonitControlTimeMsMinimum )
    {
        CMonitControl::Set_Monit_Server_Time     ( _ulTime_ms ) ;
        CMonitControl::Set_Monit_Server_Silenced ( No ) ;
    }
    else // user probably didn't mean less than one second
    {
        strcpy ( sReplyText, "<Control Time less than one second not accepted>" ) ;
        eReturnStatus = Reply_Bad ;
    }

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::L1CalCoverage              ( TAllTriggerTowers*      _pxTT,
                                                                    CMessageCommandLine*    _poCoorCommandLine )
{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    unsigned long   ulTTEtaSign ;
    unsigned long   ulTTEtaSignMin ;
    unsigned long   ulTTEtaSignMax ;

    unsigned long   ulTTEtaMagn ;
    unsigned long   ulTTEtaMagnMin ;
    unsigned long   ulTTEtaMagnMax ;

    unsigned long   ulTTPhi ;
    unsigned long   ulTTPhiMin ;
    unsigned long   ulTTPhiMax ;
    //\\//

    CMessageMgrPrinter::L1CalCoverage ( _pxTT, _poCoorCommandLine ) ;

    ////////////////////////////
    //Probe for Coverage Min and Max values
    ulTTEtaSignMin = 0xffffffff ;
    ulTTEtaSignMax = 0xffffffff ;
    ulTTEtaMagnMin = 0xffffffff ;
    ulTTEtaMagnMax = 0xffffffff ;
    for ( ulTTEtaSign  = eTT_Eta_Pos ;
          ulTTEtaSign <= eTT_Eta_Neg ;
          ulTTEtaSign ++ )
    for ( ulTTEtaMagn  = KiMin_TT_Eta_Magn ;
          ulTTEtaMagn <= KiMax_TT_Eta_Magn ;
          ulTTEtaMagn ++ )
    if ( _pxTT->aalTT_Eta[ulTTEtaSign][ulTTEtaMagn] == TRUE )
    {
        //Check Eta Sign
        if ( ulTTEtaSignMin == 0xffffffff ) // Min not yet set
        {
            ulTTEtaSignMin = ulTTEtaSign ;
            ulTTEtaSignMax = ulTTEtaSign ;
        }
        else if ( ulTTEtaSign > ulTTEtaSignMax ) // found bigger Max
            ulTTEtaSignMax = ulTTEtaSign ;

        //Check Eta Magn
        if ( ulTTEtaMagnMin == 0xffffffff ) // Min not yet set
        {
            ulTTEtaMagnMin = ulTTEtaMagn ;
            ulTTEtaMagnMax = ulTTEtaMagn ;
        }
        else if ( ulTTEtaMagn > ulTTEtaMagnMax ) // found bigger Max
            ulTTEtaMagnMax = ulTTEtaMagn ;
    }

    ulTTPhiMin = 0xffffffff ;
    ulTTPhiMax = 0xffffffff ;
    for ( ulTTPhi  = KiMin_TT_Phi ;
          ulTTPhi <= KiMax_TT_Phi ;
          ulTTPhi ++ )
    if ( _pxTT->alTT_Phi[ulTTPhi] == TRUE )
    {
        //Check Eta Magn
        if ( ulTTPhiMin == 0xffffffff ) // Min not yet set
        {
            ulTTPhiMin = ulTTPhi ;
            ulTTPhiMax = ulTTPhi ;
        }
        else if ( ulTTPhi > ulTTPhiMax ) // found bigger Max
            ulTTPhiMax = ulTTPhi ;
    }

    ////////////////////////////
    //Set Sign Eta

    if ( CL1Cal::mg_poL1Cal->SetCoverageSignEta ( ulTTEtaSignMin,
                                                ulTTEtaSignMax ) != Ok )
        CConsoleAccess::ErrorLine ( (CString) " Illegal Sign Eta Coverage Request" ) ;

    ////////////////////////////
    //Set Magn Eta

    if ( CL1Cal::mg_poL1Cal->SetCoverageMagnEta ( ulTTEtaMagnMin,
                                                ulTTEtaMagnMax ) != Ok )
        CConsoleAccess::ErrorLine ( (CString) " Illegal Magn Eta Coverage Request" ) ;


    ////////////////////////////
    //Set Phi

    if ( CL1Cal::mg_poL1Cal->SetCoveragePhi     ( ulTTPhiMin,
                                                ulTTPhiMax ) != Ok )
        CConsoleAccess::ErrorLine ( (CString) " Illegal Phi Coverage Request" ) ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::NewLogFile              ( CMessageCommandLine*    _poCoorCommandLine )
{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    CString   osOriginalFileName ;
    CString   osOldFileName ;
    CString   osNewFileName ;

    //\\//

    CMessageMgrPrinter::NewLogFile  ( _poCoorCommandLine ) ;

    osOriginalFileName  = CLogFile::OriginalFileName    ( ) ;
    osOldFileName       = CLogFile::CurrentFileName     ( ) ;
    osNewFileName       = CLogFile::NextFileName        ( ) ;

    CConsoleAccess::SystemLine ( (CString) " " ) ;
    CConsoleAccess::SystemLine ( (CString) " *********************** Closing Current Log File **********************" ) ;
    CConsoleAccess::SystemLine ( (CString) " The Original LogFile was:    " 
                                    + osOriginalFileName ) ;
    CConsoleAccess::SystemLine ( (CString) " This LogFile continues in:   " 
                                    + osNewFileName ) ;
    CConsoleAccess::SystemLine ( (CString) " " ) ;

    CLogFile::NewLogFile ( ) ;

    CConsoleAccess::SystemLine ( (CString) " " ) ;
    CConsoleAccess::SystemLine ( (CString) " ********************** Continuing in New Log File *********************" ) ;
    CConsoleAccess::SystemLine ( (CString) " The Original LogFile was:    " 
                                    + osOriginalFileName ) ;
    CConsoleAccess::SystemLine ( (CString) " This LogFile continues from: " 
                                    + osOldFileName ) ;
    CConsoleAccess::SystemLine ( (CString) " " ) ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::Find_DAC         ( ETT_Chan_Type           _eTTType,
                                                            TAllTriggerTowers*      _pxTT,
                                                            CMessageCommandLine*    _poCoorCommandLine ) 

{ 
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::Find_DAC  ( _eTTType,
                                    _pxTT, 
                                    _poCoorCommandLine ) ;

    if ( CL1Cal::mg_eynL1CalOperational == Yes )
    {
        eReturnStatus = Reply_Bad ;
        strcpy ( sReplyText, "<L1FW is Initialized, Find_DAC not allowed>" ) ;
    }
    else /* we can perform the requested action */
    if IF_TT_RANGE_WITHIN_COVERAGE( _pxTT )
    {
        if ( CL1Cal::mg_poL1Cal->f_okFind_DAC ( _eTTType, _pxTT ) != Ok )
            eReturnStatus = Reply_Bad ;

        CHECK_FOR_IO_ERROR() ;
    }

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::Adjust_Ped       ( ETT_Chan_Type           _eTTType,
                                                            TAllTriggerTowers*      _pxTT,
                                                            CMessageCommandLine*    _poCoorCommandLine ) 

{ 
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::Adjust_Ped( _eTTType,
                                    _pxTT, 
                                    _poCoorCommandLine ) ;

/*    if ( CL1Cal::mg_eynL1CalOperational == Yes )
    {
        eReturnStatus = Reply_Bad ;
        strcpy ( sReplyText, "<L1FW is Initialized, Adjust_Ped not allowed>" ) ;
    }
    else /* we can perform the requested action */
    if IF_TT_RANGE_WITHIN_COVERAGE( _pxTT )
    {
        if ( CL1Cal::mg_poL1Cal->f_okAdjust_Ped ( _eTTType, _pxTT ) != Ok )
            eReturnStatus = Reply_Bad ;

        CHECK_FOR_IO_ERROR() ;
    }

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::Revert_Ped       ( ETT_Chan_Type           _eTTType,
                                                            TAllTriggerTowers*      _pxTT,
                                                            CMessageCommandLine*    _poCoorCommandLine ) 

{ 
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::Revert_Ped( _eTTType,
                                    _pxTT, 
                                    _poCoorCommandLine ) ;

/*    if ( CL1Cal::mg_eynL1CalOperational == Yes )
    {
        eReturnStatus = Reply_Bad ;
        strcpy ( sReplyText, "<L1FW is Initialized, Revert_Ped not allowed>" ) ;
    }
    else /* we can perform the requested action */
    if IF_TT_RANGE_WITHIN_COVERAGE( _pxTT )
    {
        if ( CL1Cal::mg_poL1Cal->f_okRevert_Ped ( _eTTType, _pxTT ) != Ok )
            eReturnStatus = Reply_Bad ;

        CHECK_FOR_IO_ERROR() ;
    }

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::Profile_BLS      ( ETT_Chan_Type           _eTTType,
                                                            TAllTriggerTowers*      _pxTT,
                                                            CMessageCommandLine*    _poCoorCommandLine ) 

{ 
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::Profile_BLS   ( _eTTType,
                                        _pxTT, 
                                        _poCoorCommandLine ) ;

    if IF_TT_RANGE_WITHIN_COVERAGE( _pxTT )
    {
        if ( CL1Cal::mg_poL1Cal->f_okProfile_BLS ( _eTTType, _pxTT ) != Ok )
            eReturnStatus = Reply_Bad ;

        CHECK_FOR_IO_ERROR() ;
    }

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::Profile_AdfEt    ( ETT_Chan_Type           _eTTType,
                                                            TAllTriggerTowers*      _pxTT,
                                                            CMessageCommandLine*    _poCoorCommandLine ) 

{ 
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::Profile_AdfEt     ( _eTTType,
                                            _pxTT, 
                                            _poCoorCommandLine ) ;

    if IF_TT_RANGE_WITHIN_COVERAGE( _pxTT )
    {
        if ( CL1Cal::mg_poL1Cal->f_okProfile_AdfEt    ( _eTTType, _pxTT ) != Ok )
            eReturnStatus = Reply_Bad ;

        CHECK_FOR_IO_ERROR() ;
    }

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::AdfOut_Constant  ( ETT_Chan_Type           _eTTType,
                                                            TAllTriggerTowers*      _pxTT,
                                                            const unsigned long     _ulConstantData,
                                                            CMessageCommandLine*    _poCoorCommandLine ) 

{ 
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::AdfOut_Constant   ( _eTTType,
                                            _pxTT, 
                                            _ulConstantData,
                                            _poCoorCommandLine ) ;

    if ( CL1Cal::mg_poL1Cal->f_okAdfOut_Constant ( _eTTType, _pxTT, _ulConstantData ) != Ok )
        eReturnStatus = Reply_Bad ;

    CHECK_FOR_IO_ERROR() ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::RawAdc_Thresh    ( ETT_Chan_Type           _eTTType,
                                                            TAllTriggerTowers*      _pxTT,
                                                            const unsigned long     _ulThreshold,
                                                            CMessageCommandLine*    _poCoorCommandLine ) 

{ 
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::RawAdc_Thresh     ( _eTTType,
                                            _pxTT, 
                                            _ulThreshold,
                                            _poCoorCommandLine ) ;

    if ( CL1Cal::mg_poL1Cal->f_okRawAdc_Thresh ( _eTTType, _pxTT, _ulThreshold ) != Ok )
        eReturnStatus = Reply_Bad ;

    CHECK_FOR_IO_ERROR() ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::RawAdc_MuxMode   ( ETT_Chan_Type           _eTTType,
                                                            TAllTriggerTowers*      _pxTT,
                                                            ERawAdc_MuxMode_Type    _eMuxMode,
                                                            CMessageCommandLine*    _poCoorCommandLine )
{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::RawAdc_MuxMode ( _eTTType, 
                                         _pxTT, 
                                         _eMuxMode,
                                         _poCoorCommandLine ) ;

    if ( CL1Cal::mg_poL1Cal->f_okRawAdc_MuxMode ( _eTTType, _pxTT, _eMuxMode ) != Ok )
        eReturnStatus = Reply_Bad ;

    CHECK_FOR_IO_ERROR() ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::RawAdc_MemMode   ( ETT_Chan_Type           _eTTType,
                                                            TAllTriggerTowers*      _pxTT,
                                                            ERawAdc_MemMode_Type    _eMemMode,
                                                            CMessageCommandLine*    _poCoorCommandLine )
{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::RawAdc_MemMode ( _eTTType, 
                                         _pxTT, 
                                         _eMemMode,
                                         _poCoorCommandLine ) ;

    if ( CL1Cal::mg_poL1Cal->f_okRawAdc_MemMode ( _eTTType, _pxTT, _eMemMode ) != Ok )
        eReturnStatus = Reply_Bad ;

    CHECK_FOR_IO_ERROR() ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::AdfOut_MuxMode   ( ETT_Chan_Type           _eTTType,
                                                            TAllTriggerTowers*      _pxTT,
                                                            EAdfOut_MuxMode_Type    _eMuxMode,
                                                            CMessageCommandLine*    _poCoorCommandLine )
{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::AdfOut_MuxMode ( _eTTType, 
                                         _pxTT, 
                                         _eMuxMode,
                                         _poCoorCommandLine ) ;

    if ( CL1Cal::mg_poL1Cal->f_okAdfOut_MuxMode ( _eTTType, _pxTT, _eMuxMode ) != Ok )
        eReturnStatus = Reply_Bad ;

    CHECK_FOR_IO_ERROR() ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ECoorMessageStatus  CMessageMgrExecuter::AdfOut_MemMode   ( ETT_Chan_Type           _eTTType,
                                                            TAllTriggerTowers*      _pxTT,
                                                            EAdfOut_MemMode_Type    _eMemMode,
                                                            CMessageCommandLine*    _poCoorCommandLine )
{
    ECoorMessageStatus  eReturnStatus = Reply_Ok ;

    char                sReplyText[KiMaxLengthReplyTextToCoor] = "<Done>" ;

    //\\//

    CMessageMgrPrinter::AdfOut_MemMode ( _eTTType, 
                                         _pxTT, 
                                         _eMemMode,
                                         _poCoorCommandLine ) ;

    if ( CL1Cal::mg_poL1Cal->f_okAdfOut_MemMode ( _eTTType, _pxTT, _eMemMode ) != Ok )
        eReturnStatus = Reply_Bad ;

    CHECK_FOR_IO_ERROR() ;

    APPEND_STATUS_TO_REPLY() ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

