/*-------------------------------------------------------------------------------*/
  /*
    MonitPoolData.cpp
    11-Oct-2005
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"

#include                        "L1Cal_IIb_TCC/MonitPoolData.h"

#include "L1Cal_IIb_TCC/ResourceLocks.h"

#include "L1Cal_IIb_TCC/MonitControl.h"
#include "L1Cal_IIb_TCC/MonitPoolHelper.h"

#include "L1Cal_IIb_TCC/HandleConsole.h"
#include "L1Cal_IIb_TCC/UtilsStrings.h"
#include "L1Cal_IIb_TCC/UtilsBits.h"

#include "L1Cal_IIb_TCC/L1Cal.h"

#include "L1Cal_IIb_TCC/HandleConsole.h"

// Ace Synchronization tools: Mutex, etc.
#include "ace/Synch.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
// Static data members must be initialized at file scope
// Monitoring Data

L1CalTcc_Block_Header             CMonitPoolData::mg_xHeader ;

L1CalTcc_BeamX_Number             CMonitPoolData::mg_xBeamX ;

L1CalTcc_Block_Adf_OutputEt       CMonitPoolData::mg_xBlock_Adf_Et ;

L1CalTcc_Block_TabGab_Status      CMonitPoolData::mg_xBlock_TabGab_Status ;

const unsigned long               CMonitPoolData::mg_aIndexToTick[]={ kL1CalTcc_Tick_For_LiveBX_Index_0 ,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_1 ,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_2 ,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_3 ,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_4 ,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_5 ,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_6 ,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_7 ,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_8 ,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_9 ,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_10,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_11,

                                                                      kL1CalTcc_Tick_For_LiveBX_Index_12,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_13,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_14,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_15,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_16,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_17,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_18,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_19,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_20,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_21,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_22,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_23,

                                                                      kL1CalTcc_Tick_For_LiveBX_Index_24,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_25,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_26,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_27,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_28,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_29,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_30,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_31,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_32,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_33,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_34,
                                                                      kL1CalTcc_Tick_For_LiveBX_Index_35 } ;


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CMonitPoolData::CMonitPoolData ( )
{
    const EYesNo keynNotTriggeredCrossing = No ;
    const EYesNo keynInitDataIsBlank = Yes ;

    unsigned long ulTabNum ;
    unsigned long ulChipNum ;
    unsigned long ulScalerNum ;

    //\\//

    // initialize the TAB and GAB error counters
    for ( ulTabNum      = 0 ; ulTabNum      <= kL1CalTcc_Tot_Tab_Card           ; ulTabNum  ++ )
    for ( ulChipNum     = 0 ; ulChipNum     <= kL1CalTcc_Tot_Tab_Algo_Fpga      ; ulChipNum ++ )
    for ( ulScalerNum   = 0 ; ulScalerNum   < kL1CalTcc_Tot_Tab_Algo_ErrCounter ; ulScalerNum ++ )
        mg_xBlock_TabGab_Status.a3uwTabAlgo_ErrCnt  [ulTabNum]
                                                    [ulChipNum]
                                                    [ulScalerNum] = 0 ;

    for ( ulTabNum      = 0 ; ulTabNum      <= kL1CalTcc_Tot_Tab_Card           ; ulTabNum  ++ )
    for ( ulScalerNum   = 0 ; ulScalerNum   < kL1CalTcc_Tot_Tab_Glob_ErrCounter ; ulScalerNum ++ )
        mg_xBlock_TabGab_Status.a2uwTabGlob_ErrCnt  [ulTabNum]
                                                    [ulScalerNum] = 0 ;

    for ( ulChipNum     = 0 ; ulChipNum     <= kL1CalTcc_Tot_Gab_Rec_Fpga       ; ulChipNum ++ )
    for ( ulScalerNum   = 0 ; ulScalerNum   <  kL1CalTcc_Tot_Gab_Rec_ErrCounter ; ulScalerNum ++ )
        mg_xBlock_TabGab_Status.a2uwGabRec_ErrCnt  [ulChipNum]
                                                   [ulScalerNum] = 0 ;

    for ( ulScalerNum   = 0 ; ulScalerNum   < kL1CalTcc_Tot_Gab_Glob_ErrCounter ; ulScalerNum ++ )
        mg_xBlock_TabGab_Status.auwGabGlob_ErrCnt  [ulScalerNum] = 0 ;

    // Paint the monitoring data with zeroes
    UpdateMonitData         ( keynNotTriggeredCrossing, keynInitDataIsBlank ) ;

#if ( defined ( VME_IO_NONE ) || defined ( VME_IO_FAKE ) ) 

    CConsoleAccess::WriteLine    ( (CString) " Size of <L1CalTcc_Block_Header>          ="
                                             + I_to_A ( sizeof(L1CalTcc_Block_Header), 5 ) 
                                             + " bytes" ) ;

    CConsoleAccess::WriteLine    ( (CString) " Size of <L1CalTcc_BeamX_Number>          ="
                                             + I_to_A ( sizeof(L1CalTcc_BeamX_Number), 5 ) 
                                             + " bytes" ) ;

    CConsoleAccess::WriteLine    ( (CString) " Size of <L1CalTcc_Block_Adf_OutputEt>    ="
                                             + I_to_A ( sizeof(L1CalTcc_Block_Adf_OutputEt), 5 ) 
                                             + " bytes" ) ;

    CConsoleAccess::WriteLine    ( (CString) " Size of <L1CalTcc_Block_TabGab_Status>   ="
                                             + I_to_A ( sizeof(L1CalTcc_Block_TabGab_Status), 5 ) 
                                             + " bytes" ) ;
/*/
    CConsoleAccess::WriteLine    ( (CString) " Size of <> ="
                                             + I_to_A ( sizeof(), 5 ) 
                                             + " bytes" ) ;
/*/
#endif

}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CMonitPoolData::~CMonitPoolData ()
{
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess  CMonitPoolData::UpdateMonitData             ( EYesNo              _eynTriggered,
                                                        EYesNo              _eynFillBlankData )
{
    ESuccess    eReturnStatus = Ok ;

    // Prevent the Monit Data from being read while it is updated
    ACE_Guard<ACE_Thread_Mutex> oGuardMonitData (CResourceLocks::mg_oMutexMonitDataPool) ;

    //\\//

    //////////////////////////////////////////////////////////////////////////////////////
    // prepare common components used in several blocks below
    //////////////////////////////////////////////////////////////////////////////////////

    // collect common Info for Extended Header (will still need block type and version)
    GetMonitHeader ( &mg_xHeader, _eynTriggered, _eynFillBlankData ) ;

    // Set version
    mg_xHeader.ulFormatVersion = kL1CalTcc_Version_Phase_1 ;


    // collect Tick and Turn scalers
    GetMonitInfoTickTurn ( &mg_xBeamX, _eynFillBlankData ) ;


    //////////////////////////////////////////////////////////////////////////////////////
    // Prepare Block for request of type eL1CalTcc_BlockType_Adf_OutputEt :
    //////////////////////////////////////////////////////////////////////////////////////

    mg_xBlock_Adf_Et.xHeader = mg_xHeader ; // use the info already collected, then touch up
    mg_xBlock_Adf_Et.xHeader.ulBlockType = eL1CalTcc_BlockType_Adf_OutputEt ;

    // collect Tick and Turn scalers (use the set already collected)
    mg_xBlock_Adf_Et.xBeamX = mg_xBeamX ;

    // collect ADF Output Et
    GetMonitInfoAdfEt         ( &mg_xBlock_Adf_Et,          _eynFillBlankData ) ;


    //////////////////////////////////////////////////////////////////////////////////////
    // Prepare Block for request of type eL1CalTcc_BlockType_TabGab_Status :
    //////////////////////////////////////////////////////////////////////////////////////

    mg_xBlock_TabGab_Status.xHeader = mg_xHeader ; // use the info already collected, then touch up
    mg_xBlock_TabGab_Status.xHeader.ulBlockType = eL1CalTcc_BlockType_TabGab_Status ;

    // collect Tick and Turn scalers (use the set already collected)
    mg_xBlock_TabGab_Status.xBeamX = mg_xBeamX ;

    // collect TAB and GAB Status 
    GetMonitInfoTabGabStatus  ( &mg_xBlock_TabGab_Status,   _eynFillBlankData ) ;


    //////////////////////////////////////////////////////////////////////////////////////

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess  CMonitPoolData::RetrieveAdfOutputEt           ( L1CalTcc_Block_Adf_OutputEt*       _pxBlock_Adf_Et ) 
{
    ESuccess    eReturnStatus = Ok ;

    // Prevent the Monit Data from being updated while it is read 
    ACE_Guard<ACE_Thread_Mutex> oGuardMonitData (CResourceLocks::mg_oMutexMonitDataPool) ;

    //\\//

    // Retrieve Block for request of type eL1CalTcc_BlockType_Adf_OutputEt:
    //////////////////////////////////////////////////////////////////////////////////////
    *_pxBlock_Adf_Et = mg_xBlock_Adf_Et ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess  CMonitPoolData::RetrieveTabGabStatus        ( L1CalTcc_Block_TabGab_Status*       _pxBlock_TabGab_Status  ) 
{
    ESuccess    eReturnStatus = Ok ;

    // Prevent the Monit Data from being updated while it is read 
    ACE_Guard<ACE_Thread_Mutex> oGuardMonitData (CResourceLocks::mg_oMutexMonitDataPool) ;

    //\\//

    // Retrieve Block for request of type eL1CalTcc_BlockType_Adf_OutputEt:
    //////////////////////////////////////////////////////////////////////////////////////
    *_pxBlock_TabGab_Status = mg_xBlock_TabGab_Status ;

    return eReturnStatus ;
}
/*-------------------------------------------------------------------------------*/

