/*-------------------------------------------------------------------------------*/
  /*
    NevisCard.cpp
    06-Apr-2006
  */
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/StdAfx.h"

#include                            "L1Cal_IIb_TCC/NevisCard.h"

#include "L1Cal_IIb_TCC/L1CalCardAddresses.h"

#include "L1Cal_IIb_TCC/HandleConsole.h"
#include "L1Cal_IIb_TCC/UtilsStrings.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CNevisCard::CNevisCard    ( unsigned char   _ubModuleNum,
                            CString*        _posCardDescription )
          : CHsroChannel  ( ) 
{

    //\\//

    m_ubModuleNum  = _ubModuleNum ;

    if ( _posCardDescription == NULL )
        m_osCardDescription   = "Generic TabGab Card" ;
    else
        m_osCardDescription   = *_posCardDescription ;

    // Initialize Readout flag
    // Will be set by the CHsroChannel::FurtherConstruct if it applies
    m_ynThisCardReadout = No ; 

    // Retrieve the VRB Channel Coordinates, 
    // and locate the proper VRB Card and channel
    CHsroChannel::FurtherConstruct ( (CNevisCard*) this ) ; 

}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CNevisCard::~CNevisCard()
{
}
/*-------------------------------------------------------------------------------*/

ESuccess CNevisCard::Initialize ( ) 
{
    ESuccess        eReturnStatus = Ok ;

    //\\//
    
    CConsoleAccess::WriteLine ( (CString) " "
                                + " Initializing " 
                                 + m_osCardDescription 
                                 + " " 
                                 + f_osModuleNum ( ) ) ;

    return eReturnStatus ;
}


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
TCString CNevisCard::f_osModuleNum     ( ) // e.g. return "@Module#0"
{

    TCString  oMsg ;

    //\\//

    oMsg = "@Module#" + I_to_A( m_ubModuleNum ) ;

    return oMsg ;
}


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ESuccess ReportTabGabStatus ( EStatus   _eStatus, 
                              CString   _osTabGabRoutineName, 
                              CString   _osCallingRoutineName ) 

{
    ESuccess        eReturnStatus = Ok ;

    //\\//

    if ( _eStatus != eOk ) 
    {
        eReturnStatus = Error ;

        CString        oMsg ;
        oMsg = (CString) " TabGab's <"
                       + _osTabGabRoutineName
                       + "> returned " ;

        if      ( _eStatus == eBadParam ) /* Didn't like one of the parameters*/
            oMsg += "<BadParam>" ;

        else if ( _eStatus == eBadEnv   ) /* Problem with TAB/GAB Environment (not defined, non-existent directory, etc).*/
            oMsg += "<BadEnv>" ;

        else if ( _eStatus == eIoError  ) /* Tried to do as requested, but couldn't program hardware*/
            oMsg += "<IoError>" ;

        oMsg += (CString) " in <"
                       + _osCallingRoutineName
                       + "> " ;

        CConsoleAccess::ErrorLine ( oMsg ) ;
    }

    return eReturnStatus ;
}

