/*-------------------------------------------------------------------------------*/
  /*
    T962_Wire.cpp
    Class CT962_Wire
  */
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/StdAfx.h"

#include "L1Cal_IIb_TCC/GlobalConstants.h"
#include "L1Cal_IIb_TCC/CustomDataTypes.h"

#include                            "L1Cal_IIb_TCC/T962_Wire.h"

#include "L1Cal_IIb_TCC/HandleHardwareAccess.h"

#include "L1Cal_IIb_TCC/UtilsStrings.h"

// access to the console
// static means created only once throughout life of program (to avoid wasting time)
// *AND* internal linkage (to avoid clash between modules)
#include "L1Cal_IIb_TCC/HandleConsole.h"
static CConsoleAccess oConsole ;

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/

CT962_Wire::CT962_Wire           ( unsigned long    _ulWireNum,
                                   unsigned char    _ubCrateNum,
                                   unsigned char    _ubCardSlot,
                                   unsigned char    _ubChipAddress,
                                   unsigned short   _uwRegAddress,
                                   unsigned long    _ulRegCount,
                                   CAdfCardBase*    _pMotherAdf )
{
    m_ulWireNum     = _ulWireNum ;
    m_ulRegCount    = _ulRegCount ;
    m_ulChipAddress = _ubChipAddress ;
    m_paReadBuffer  = new ( TuwRegWord[m_ulRegCount+2048] ) ;

    CHardwareAccess::mg_poBit3BusAdaptorArray[_ubCrateNum]
                        -> CheckBufferAligned ( m_paReadBuffer, &m_ulBufferAlignOff ) ;

    m_oMonitRegBase = new CAdfRegBase             ( 0,          // Master
                                                    _ubCrateNum, // Slave
                                                    _ubCardSlot,
                                                    _ubChipAddress,
                                                    _uwRegAddress ) ;

    m_pMotherAdf = _pMotherAdf ;

    oConsole.WriteLine ( (CString) " Added Wire #" 
                                  + I_to_A ( m_ulWireNum, 3 )
                                  + " Buf Size=" 
                                  + I_to_A ( m_ulRegCount, 4 ) 
                                  + " " 
                                  + m_oMonitRegBase->f_osRegAddress() 
                                  + " " 
                                  + m_oMonitRegBase->f_osVmeAddress() ) ;

}


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CT962_Wire::~CT962_Wire ()
{

    delete ( m_oMonitRegBase ) ;

    delete ( m_paReadBuffer ) ;

}


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/


