/*-------------------------------------------------------------------------------*/
  /*
    UtilsBits.cpp
    18-May-98
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"

#include "L1Cal_IIb_TCC/DataManip.h"

#include                            "L1Cal_IIb_TCC/UtilsBits.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
// implement some of the MSVC bit manipulation utilities, not in ANSI C

#ifdef WIN32 
#else 

unsigned    long    _lrotl ( unsigned   long     _ulBitMask, int _iShiftTot ) 
{
    for ( int iShiftNum = 0 ; iShiftNum < _iShiftTot ; iShiftNum ++ )
    {
        if ( ( _ulBitMask & 0x80000000 ) == 0 ) 
            _ulBitMask = ( _ulBitMask * 2 ) ;
        else
            _ulBitMask = ( _ulBitMask * 2 ) + 0x00000001 ;
    }

    return _ulBitMask ;
}

unsigned    long    _lrotr ( unsigned   long     _ulBitMask, int _iShiftTot ) 
{
    for ( int iShiftNum = 0 ; iShiftNum < _iShiftTot ; iShiftNum ++ )
    {
        if ( ( _ulBitMask & 0x00000001 ) == 0 ) 
            _ulBitMask = ( _ulBitMask / 2 ) ;
        else
            _ulBitMask = ( _ulBitMask / 2 ) + 0x80000000 ;
    }

    return _ulBitMask ;
}
#endif

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned    long    fulRotrToLsb   ( unsigned   long     _ulBitMask ) 
{
    //\\//

    while ( ( _ulBitMask & 0x0001 ) == 0 ) 
    {
        _ulBitMask = _lrotr ( _ulBitMask, 1 ) ;
    }

    return      _ulBitMask ;

}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned    short   fuwRotrToLsb   ( unsigned    short    _uwBitMask ) 
{
    MultiAccessLong     xBitMask ;

    //\\//

    xBitMask.ulLong = _uwBitMask ;

    xBitMask.ulLong = fulRotrToLsb ( xBitMask.ulLong ) ;

    return      xBitMask.ByWord.uwWord_0 ;

}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned long   fulNumBitSet             ( unsigned    long     _ulBitMask ) 
{
    unsigned    long    ulNumBitSet ;
    unsigned    long    ulScanBit ;
    //\\//

    ulNumBitSet = 0 ;

    for ( ulScanBit = 0 ; ulScanBit < 32 ; ulScanBit++ )
    {
        ulNumBitSet = ulNumBitSet + ( _ulBitMask & 0x0001 ) ;
        _ulBitMask = _lrotr ( _ulBitMask, 1 ) ;
    }

    return      ulNumBitSet ;

}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned    long    fulTruncToLong    ( uint64            _uqBitMask ) 
{
    MultiAccessQuad     xBitMask ;

    //\\//

    xBitMask.uqQuad = _uqBitMask ;

    return      xBitMask.ByLong.ulLong_0 ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned    short   fuwTruncToWord    ( unsigned    long     _ulBitMask ) 
{
    MultiAccessLong     xBitMask ;

    //\\//

    xBitMask.ulLong = _ulBitMask ;

    return      xBitMask.ByWord.uwWord_0 ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned    short   fuwTruncTo9bit    ( unsigned    long     _ulBitMask ) 
{
    MultiAccessLong     xBitMask ;

    //\\//

    xBitMask.ulLong = _ulBitMask ;
    xBitMask.ByByte.ubByte_1 &= 0x01 ; // strip off the upper 7 bits of the second byte

    return      xBitMask.ByWord.uwWord_0 ; // return the lower 16 bits but only 9 bits come from argument
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned    char    fubTruncToByte    ( unsigned    long     _ulBitMask ) 
{
    MultiAccessLong     xBitMask ;

    //\\//

    xBitMask.ulLong = _ulBitMask ;

    return      xBitMask.ByByte.ubByte_0 ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned short    fuwRotrToAlign    ( unsigned long _ulCandidateMask,
                                      unsigned long _ulTargetMask ) 
{
    unsigned short     iShiftCount ;
    //\\//

    for ( iShiftCount = 0 ; iShiftCount < 32 ; iShiftCount++ ) 
      if ( _lrotr( _ulCandidateMask, iShiftCount ) == _ulTargetMask ) 
        break ;

    //if ( iShiftCount == 32 ) 
    // error, no shift could truely align the two masks, but just return this value
    return  iShiftCount ;

}
/*-------------------------------------------------------------------------------*/

                                    
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned    short   fuwRotr       ( unsigned    long    _ulBitMask, 
                                    unsigned    short   _uwShiftCount ) 
{
    return fuwTruncToWord ( _lrotr ( _ulBitMask, _uwShiftCount ) ) ;

}
/*-------------------------------------------------------------------------------*/
                                    

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned    short   fuwRotl       ( unsigned    short   _uwBitMask, 
                                    unsigned    short   _uwShiftCount ) 
{
	unsigned long ulTemp ;

	//\\//

	if ( ( _uwBitMask & 0x1000 ) == 0 ) 
		ulTemp = _uwBitMask ;
	else // extend the Most Significant Bit so that it can be rotated into the LSB
		ulTemp = _uwBitMask | 0xffff0000 ;

    return fuwTruncToWord ( _lrotl ( ulTemp, _uwShiftCount ) ) ;

}
/*-------------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned    short   fuwLowestBitOnly  ( unsigned    short    _uwBitMask ) 
{
    unsigned short  uwTemp ;

    //\\//

	if ( _uwBitMask != 0xffff ) 
	{
		// invert the input mask
		uwTemp = _uwBitMask ^ 0xffff ;

		// shift up the inverted mask and clip it back to the input mask
		uwTemp = fuwRotl ( uwTemp, 1 ) & _uwBitMask ;
	}
	else
		// 0xffff is a special case for the above method that would return 0
		uwTemp = 1 ;

    return uwTemp ;

}
/*-------------------------------------------------------------------------------*/

unsigned    short   fuwSetBits    ( unsigned    short   _uwValue, 
                                    unsigned    short   _uwMask ) 
{
    unsigned short  uwTemp ;

    //\\//

    uwTemp = _uwValue | _uwMask ;

    return uwTemp ;

}
/*-------------------------------------------------------------------------------*/
unsigned    short   fuwClearBits  ( unsigned    short   _uwValue, 
                                    unsigned    short   _uwMask ) 
{
    unsigned short  uwTemp ;

    //\\//

    uwTemp = _uwValue & ( 0xffff ^ _uwMask ) ;

    return uwTemp ;

}
/*-------------------------------------------------------------------------------*/
unsigned    short   fuwFlipBits   ( unsigned    short   _uwValue, 
                                    unsigned    short   _uwMask ) 
{
    unsigned short  uwTemp ;

    //\\//

    uwTemp = _uwValue ^ _uwMask ;

    return uwTemp ;

}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void                fvSetBit      ( uint64*             _puqValue, 
                                    unsigned    long    _ulBitNum ) 
{
    MultiAccessQuad*     pxBitMask = (MultiAccessQuad*) _puqValue ;
    _ulBitNum = _ulBitNum % 64 ;//damage control on the Bit Number
    int iLongNum = _ulBitNum / 32 ;
    int iBitNum = _ulBitNum % 32 ;
    pxBitMask->ulLong[iLongNum] |= ( 0x00000001 << _ulBitNum ) ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void                fvClearBit    ( uint64*             _puqValue, 
                                    unsigned    long    _ulBitNum ) 
{
    MultiAccessQuad*     pxBitMask = (MultiAccessQuad*) _puqValue ;
    _ulBitNum = _ulBitNum % 64 ;//damage control on the Bit Number
    int iLongNum = _ulBitNum / 32 ;
    int iBitNum = _ulBitNum % 32 ;
    pxBitMask->ulLong[iLongNum] &=  ~ ( 0x0000000000000001 << _ulBitNum ) ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void                fvFlipBit     ( uint64*             _puqValue, 
                                    unsigned    long    _ulBitNum ) 
{
    MultiAccessQuad*     pxBitMask = (MultiAccessQuad*) _puqValue ;
    _ulBitNum = _ulBitNum % 64 ;//damage control on the Bit Number
    int iLongNum = _ulBitNum / 32 ;
    int iBitNum = _ulBitNum % 32 ;
    pxBitMask->ulLong[iLongNum] ^= ( 0x0000000000000001 << _ulBitNum ) ;
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void                fvSetBit      ( unsigned    long*   _pulValue, 
                                    unsigned    long    _ulBitNum ) 
{ 
    _ulBitNum %= 32 ; 
    fvSetBit ( (uint64*) _pulValue, _ulBitNum ) ; 
} 
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void                fvClearBit    ( unsigned    long*   _pulValue, 
                                    unsigned    long    _ulBitNum )
{ 
    _ulBitNum %= 32 ; 
    fvClearBit ( (uint64*) _pulValue, _ulBitNum ) ; 
}
/*-------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------*/
void                fvFlipBit     ( unsigned    long*   _pulValue, 
                                    unsigned    long    _ulBitNum )
{ 
    _ulBitNum %= 32 ; 
    fvFlipBit ( (uint64*) _pulValue, _ulBitNum ) ; 
} 
/*-------------------------------------------------------------------------------*/
