/*-------------------------------------------------------------------------------*/
  /*
    UtilsMisc.cpp
    30-Apr-02   pulled from MonitControl
  */
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/StdAfx.h"

#include                                "L1Cal_IIb_TCC/UtilsMisc.h"

#include "L1Cal_IIb_TCC/DataManip.h"

#include <time.h>

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
uint64 TimeMilliSeconds ( ) 
/*  Return the number of milliseconds since midnight (00:00:00), January 1, 1970 
   (coordinated universal time)

    time() is the number of seconds elapsed since 
    midnight (00:00:00), January 1, 1970 (coordinated universal time)
    There are   60 s/mn = 3600 s/h = 86.4 ks/day = 31.5 Ms/year
                or 136 years worth of seconds per 32bit longword 
                only 0.136 years worth of milliseconds per 32bit longword 
                but some 500 Myears worth of milliseconds per 64bit longword 
*/
{
    time_t  iTimeSec ;
    clock_t iClockTicks ;

    //\\//

    time ( &iTimeSec ) ;
    iClockTicks = clock();

    return 1000 * (uint64) iTimeSec                                             // how many thousands of seconds til now
         + (uint64) ( (double) ( (long) iClockTicks % (long) CLOCKS_PER_SEC )   // how many ticks into the current second 
                    * ( 1000.0 / (double) CLOCKS_PER_SEC ) ) ;                  // how many milliseconds per tick
}
/*-------------------------------------------------------------------------------*/
