/*-------------------------------------------------------------------------------*/
  /*
     UtilsParsing.cpp
     7-Oct-99
  */
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/StdAfx.h"

#include <stdio.h>

#include                            "L1Cal_IIb_TCC/UtilsParsing.h"

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
char*       FirstTokenBegin         ( const char* _acString ) 
{
    char*           pcReturn ;
    int             iCharNum ;
    const   char    cCR = '\n' ;

    //\\//

    // First, check the existence of a string to parse
    if ( _acString == NULL ) 
    {
        pcReturn = NULL ;
        goto Done ;
    }

    // look for first character that is not a space or tab
    for ( iCharNum = 0 ; ; iCharNum++ )
    {

        if ( _acString[iCharNum] == 0 ) // is it the end of the string
        {
            pcReturn = NULL  ;
            goto Done ;
        }

        if ( ( _acString[iCharNum] != ' '  )     // is it a space character
          && ( _acString[iCharNum] != '\t' )     // is it a tab character
          && ( _acString[iCharNum] !=  cCR ) )   // is it a line feed character
        {
            pcReturn = (char*) _acString + iCharNum ;
            goto Done ;
        }

    }

Done:

    return pcReturn ;

}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned int         FirstTokenLength        ( const char* _acString ) 
{
    unsigned int    uiReturn ;
    int             iCharNum ;

    //\\//

    // First, check the existence of a string to parse
    if ( _acString == NULL ) 
    {
        uiReturn = 0 ;
        goto Done ;
    }

    // Check if the first character already implies the end of the word
    if ( ( *_acString == ' '  )     // is it a space character
      || ( *_acString == '\t' )     // is it a tab character
      || ( *_acString == 0    ) )   // is it the end of the string
    {
        uiReturn = 0 ;
        goto Done ;
    }

    // If the first character is a special syntax character, 
    // the token is this single character
    if ( ( *_acString ==   '('  )
      || ( *_acString ==   ')'  )
      || ( *_acString ==   '+'  )
      || ( *_acString ==   '-'  )
      || ( *_acString ==   '.'  )
      || ( *_acString ==   ':'  ) )
    {
        uiReturn = 1 ;
        goto Done ;
    }

    // Look for first character that is 
    //      a space or tab
    //   or a special syntax character,
    //   or the end of the string NULL character
    for ( iCharNum = 0 ; iCharNum < KiMaxTokenLength ; iCharNum++ )
    {
        if ( ( _acString[iCharNum] == ' '     )  // is it a space character
          || ( _acString[iCharNum] == '\t'    )  // is it a tab character
          || ( _acString[iCharNum] == '('     )
          || ( _acString[iCharNum] == ')'     )
          || ( _acString[iCharNum] == '+'     )
          || ( _acString[iCharNum] == '-'     )
          || ( _acString[iCharNum] == '.'     )
          || ( _acString[iCharNum] == ':'     )
          || ( _acString[iCharNum] == 0       ) ) // is it the end of the string
        {
            uiReturn = iCharNum ;
            goto Done ;
        }
    }

    // We have been looking further than the maximum keyword length
    // this is considered an error and here we limit the damages 
    // in case the pointer passed as argument is out of control.
    uiReturn = KiMaxTokenLength  ;

Done:

    return uiReturn ;

}

