/*-------------------------------------------------------------------------------*/
  /*
    UtilsRandom.cpp
    09-July-98
    updated 17-july-03
  */
/*-------------------------------------------------------------------------------*/

#include "L1Cal_IIb_TCC/StdAfx.h"

#include                            "L1Cal_IIb_TCC/UtilsRandom.h"

#include <stdlib.h> // for rand
#include <time.h>

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned long ulRandom      ( unsigned long     _ulMinValue, 
                              unsigned long     _ulMaxValue ) 
{
    unsigned long       ulRange ;
    unsigned long       ulRand ;

    //\\//

    //damage control on incoherent parameters
    if ( _ulMaxValue <= _ulMinValue ) return _ulMinValue ;

    //determine the spread of values needed
    ulRange = _ulMaxValue - _ulMinValue ;

    //start filling the lowest 15 bits
    ulRand = rand () ;

    //Maybe we don't have enough random bits, so ... get some more
    if ( ulRange > KiSingleNativeRandMax ) 
    {
        ulRand <<= KiNativeRandBits ;   // shift up by 15 bits
        ulRand |= rand () ;             // fill lower 15 bits again
        if ( ulRange > KiDoubleNativeRandMax ) 
        {
            ulRand <<= KiNativeRandBits ;   // shift up by 15 bits
            ulRand |= rand () ;             // fill lower 15 bits again
        }
    }

    //Trim range down to requested value
    if ( ulRand > ulRange ) ulRand %= ulRange + 1 ;

    //shift up to the desired lowest value
    ulRand += _ulMinValue ;

    return  ulRand ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void vRandomInit            ( ) 
{

   /* Seed the random-number generator with current time 
    * This helps having a different set of number generated every time
    */

    srand( (unsigned)time( 0 ) );

}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
void ulRandomSetSeed        ( unsigned long      _ulSeed ) 
{
   /* Seed the random-number generator with explicit value 
    * This helps having the same set of random numbers re-generated
    */

   srand( _ulSeed );

}

