/*-------------------------------------------------------------------------------*/
  /*
    UtilsStrings.cpp
    11-May-98
  */
/*-------------------------------------------------------------------------------*/
#include "L1Cal_IIb_TCC/StdAfx.h"

#include                            "L1Cal_IIb_TCC/UtilsStrings.h"

#include <time.h>
#include <sys/types.h>
#include <sys/timeb.h>

#include "ace/OS_String.h"

//forward declaration of internal utility function
CString I_to_A_formatting ( char*       _pBuf, 
                            const int   iMinDigits, 
			                const int   iRadix, 
                            const char  cPadChar,
            				const int   iSpace_Every ) ;

/*
#ifdef WIN32
#else

char* ulToHexOrBin ( int iValue, char * pString, int iRadix )
{
    if      ( iRadix == 16 ) 

        sprintf ( pString, "%x", iValue ) ;

    else if ( iRadix == 2 ) 
    {
        char sHex [8+1] ; // hold temporary hex dump
        sprintf ( sHex, "%8x", iValue ) ;

        pString[0] = 0 ; // initialize to zero length (null-terminated)

        for ( int iNibNum = 7 ; iNibNum >= 0 ; iNibNum -- )
        {
            if      ( sHex[iNibNum] == '0' ) 
                strcat ( pString, "0000" ) ;
            else if ( sHex[iNibNum] == '1' ) 
                strcat ( pString, "0001" ) ;
            else if ( sHex[iNibNum] == '2' ) 
                strcat ( pString, "0010" ) ;
            else if ( sHex[iNibNum] == '3' ) 
                strcat ( pString, "0011" ) ;
            else if ( sHex[iNibNum] == '4' ) 
                strcat ( pString, "0100" ) ;
            else if ( sHex[iNibNum] == '5' ) 
                strcat ( pString, "0101" ) ;
            else if ( sHex[iNibNum] == '6' ) 
                strcat ( pString, "0110" ) ;
            else if ( sHex[iNibNum] == '7' ) 
                strcat ( pString, "0111" ) ;
            else if ( sHex[iNibNum] == '8' ) 
                strcat ( pString, "1000" ) ;
            else if ( sHex[iNibNum] == '9' ) 
                strcat ( pString, "1001" ) ;
            else if ( sHex[iNibNum] == 'a' ) 
                strcat ( pString, "1010" ) ;
            else if ( sHex[iNibNum] == 'b' ) 
                strcat ( pString, "1011" ) ;
            else if ( sHex[iNibNum] == 'c' ) 
                strcat ( pString, "1100" ) ;
            else if ( sHex[iNibNum] == 'd' ) 
                strcat ( pString, "1101" ) ;
            else if ( sHex[iNibNum] == 'e' ) 
                strcat ( pString, "1110" ) ;
            else if ( sHex[iNibNum] == 'f' ) 
                strcat ( pString, "1111" ) ;
        }
        
        // trim the leading zeroes
        while ( pString[0] != '1' )  
        {
            for ( int iCharNum = 0 ; iCharNum < 32 ; iCharNum ++ )
            {
                if ( pString[iCharNum] == 0 ) break ;
                pString[iCharNum] = pString[iCharNum+1] ;
            }
        }
    }
    else 
        strcpy ( pString, "*Err*" ) ;

    return pString ;
}

char* _ltoa ( long iValue, char * pString, int iRadix )
{
    if ( ( iRadix == 10 ) 
      || ( iValue == 0 ) ) // get this special case out of the way 
        sprintf ( pString, "%d", iValue ) ;
    else 
        ulToHexOrBin ( iValue, pString, iRadix ) ;

    return pString ;
}

char* _ultoa ( unsigned long ulValue, char * pString, int iRadix )
{
    if ( ( iRadix  == 10 ) 
      || ( ulValue == 0 ) ) // get this special case out of the way 
        sprintf ( pString, "%u", ulValue ) ;
    else 
        ulToHexOrBin ( ulValue, pString, iRadix ) ;

    return pString ;
}

#endif
*/

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
// converts integer iNumber to a string representing its decimal value
// (or another optional Base iRadix)
// and pad the left of the resutling string with leading spaces 
// (or other optional padding character cPadChar) 
// to produce a CString with a minimum length of MinDigits+2 characters.
// The two leading characters are '0x' for Hexadecimal, 
// '0d' for decimal and '0b' for binary

CString I_to_A( const int iNumber, 
                const int iMinDigits, 
			    const int iRadix, 
                const char cPadChar,
				const int iSpace_Every )
{
	char Buf[80],  *pBuf = Buf;

    if ( ( iNumber & 0x80000000 ) == 0 ) 
        ACE_OS_String::itoa( iNumber, pBuf, iRadix) ;
    else 
    { // negative numbers seems not to be converted properly on linux.
      // If the MSbit is set, we explicitely print the negative sign,
      // and call itoa with a positive number
        *pBuf = '-' ;
        ACE_OS_String::itoa( -iNumber, pBuf+1, iRadix) ;
    }

	return ( I_to_A_formatting( pBuf, 
                                iMinDigits, 
			                    iRadix, 
                                cPadChar,
            				    iSpace_Every ) ) ;
}

CString I_to_A( const unsigned int iNumber, 
                const int iMinDigits, 
			    const int iRadix, 
                const char cPadChar,
				const int iSpace_Every )
{
	char Buf[80],  *pBuf = Buf;

    if ( ( iNumber & 0x80000000 ) == 0 ) 
        ACE_OS_String::itoa( (int) iNumber, pBuf, iRadix) ;
    else 
    { // if the MSbit is set, we work around and prevent printing a negative number
        ACE_OS_String::itoa( (int) (iNumber/10), pBuf, iRadix) ;
        ACE_OS_String::itoa( (int) (iNumber%10), &pBuf[strlen(pBuf)], iRadix) ;
    }

	return ( I_to_A_formatting( pBuf, 
                                iMinDigits, 
			                    iRadix, 
                                cPadChar,
            				    iSpace_Every ) ) ;
}

CString I_to_A( const long iNumber, 
                const int iMinDigits, 
			    const int iRadix, 
                const char cPadChar,
				const int iSpace_Every )
{
	char Buf[80],  *pBuf = Buf;

    ACE_OS_String::itoa( (int) iNumber, pBuf, iRadix) ;

	return ( I_to_A_formatting( pBuf, 
                                iMinDigits, 
			                    iRadix, 
                                cPadChar,
            				    iSpace_Every ) ) ;
}

CString I_to_A( const unsigned long iNumber, 
                const int iMinDigits, 
			    const int iRadix, 
                const char cPadChar,
				const int iSpace_Every )
{
	char Buf[80],  *pBuf = Buf;

    if ( ( iNumber & 0x80000000 ) == 0 ) 
        ACE_OS_String::itoa( (int) iNumber, pBuf, iRadix) ;
    else 
    { // if the MSbit is set, we work around and prevent printing a negative number
        ACE_OS_String::itoa( (int) (iNumber/iRadix), pBuf, iRadix) ;
        ACE_OS_String::itoa( (int) (iNumber%iRadix), &pBuf[strlen(pBuf)], iRadix) ;
    }

	return ( I_to_A_formatting( pBuf, 
                                iMinDigits, 
			                    iRadix, 
                                cPadChar,
            				    iSpace_Every ) ) ;
}


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CString I_to_A_formatting ( char*       _pBuf, 
                            const int   iMinDigits, 
			                const int   iRadix, 
                            const char  cPadChar,
            				const int   iSpace_Every )
{
// converts integer iNumber to a string representing its decimal value
// (or another optional Base iRadix)
// and pad the left of the resutling string with leading spaces 
// (or other optional padding character cPadChar) 
// to produce a CString with a minimum length of MinDigits+2 characters.
// The two leading characters are '0x' for Hexadecimal, 
// '0d' for decimal and '0b' for binary

	int  iStrLen, iPadCnt ;
    int  iCharIndex, iPadChar, iShiftChar ;

	iStrLen = strlen(_pBuf) ;
    iPadCnt = iMinDigits - iStrLen ;
	if ( iPadCnt > 0 )
	{ 
		// move existing characters up, including (null-termination)
		// start at the end to not overwrite characters not yet moved
		for ( iShiftChar = iStrLen ; iShiftChar >=0  ; iShiftChar-- ) 
			_pBuf[iShiftChar+iPadCnt] = _pBuf[iShiftChar] ;

		// add requested padding at the beginning of the string
		for ( iPadChar = 0 ; iPadChar < iPadCnt ; iPadChar++ ) 
			_pBuf[iPadChar] = cPadChar ;

	   // don't need that _pBuf[iMinDigits] = (char) 0 ;
	}

	// recomputer string length
	iStrLen = strlen(_pBuf) ;
	
	// now add spacing
	if ( iSpace_Every > 0 ) // negative or null values mean no spacing 
	{
		int iBlankCnt = 0 ;
		for ( iCharIndex = 1 ; iCharIndex <= iStrLen ; iCharIndex++ ) // scan each char index
		{
			if ( ( ( iCharIndex % iSpace_Every ) == 0 ) // see if it is divisible by the spacing length
		      || ( iCharIndex == iStrLen ) ) // always add blank at beginning
			{
				for ( iShiftChar  = iStrLen + iBlankCnt ; // start at end of string, including null-terminator
				      iShiftChar >= iStrLen - iCharIndex ; // down to the place where a space is needed
					  iShiftChar-- ) // this is running backwards becasue the LSDigit is at the end of the string
					_pBuf[iShiftChar+1] = _pBuf[iShiftChar] ; // shift character
				_pBuf[iStrLen-iCharIndex] = ' ' ; // add space
				iBlankCnt++ ; // remember that the string is now longer
			}
		}
	}

	// recomputer string length
	iStrLen = strlen(_pBuf) ;
	
	// add prefix to flag data type
	if ( ( iRadix == 2 ) || (iRadix == 16 ) ) 
	{
		for ( iShiftChar = iStrLen; iShiftChar >= 0; iShiftChar-- )
			_pBuf[iShiftChar+2] = _pBuf[iShiftChar] ;
		_pBuf[0] = '0' ;
		if ( iRadix == 2 )
			_pBuf[1] = 'b' ;
		else 
			_pBuf[1] = 'x' ;
	} 

	return ( _pBuf ) ;
}


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
unsigned int  A_to_uI( CString osString )
{
// converts CString to unsigned integer repesented by the string 
// while accepting decimal, hexadecimal or binary input
// decimal inputs MAY be preficed with '0d'
// hexadecimal inputs MUST be prefaced with '0x'
// binary inputs MUST be prefaced with '0b'
	unsigned int uiConverted ;
    char *pcEndChar, **ppcEndChar = &pcEndChar ; 
	int iBlankPos ;
	char acSpaceOrComma[] = " ," ;
	
	//squeeze out blank characters
	iBlankPos = osString.FindOneOf( acSpaceOrComma ) ;
	while ( iBlankPos != -1 )
	{
		osString = osString.Left( iBlankPos ) + osString.Mid( iBlankPos+1 ) ;
		iBlankPos = osString.FindOneOf( acSpaceOrComma ) ;
	}

	// now convert the rest from ascii to value
	if ( osString.GetLength() <= 2 )
	{// there cannot be a '0*' flag, do direct decimal conversion
		uiConverted = strtoul ( (LPCTSTR)osString, ppcEndChar, 10 ) ;
	}
	else if ( osString.GetAt(0) == '0' )
	{
		switch ( osString.GetAt(1) ) // find format tag 
		{
			case 'b' : // binary
			case 'B' :
				uiConverted = strtoul ( (LPCTSTR)osString.Mid(2), ppcEndChar, 2 ) ;
				break ;

			case 'x' : // hexadecimal
			case 'X' :
				uiConverted = strtoul ( (LPCTSTR)osString.Mid(2), ppcEndChar, 16 ) ;
				break ;

			case 'd' : // decimal (explicit)
			case 'D' :
				uiConverted = strtoul ( (LPCTSTR)osString.Mid(2), ppcEndChar, 10 ) ;
				break ;

			case 'k' : // decimal (explicit)
			case 'K' :
				uiConverted = 1000 * strtoul ( (LPCTSTR)osString.Mid(2), ppcEndChar, 10 ) ;
				break ;

			case 'm' : // decimal (explicit)
			case 'M' :
				uiConverted = 1000000 * strtoul ( (LPCTSTR)osString.Mid(2), ppcEndChar, 10 ) ;
				break ;

			case 'g' : // decimal (explicit)
			case 'G' :
				uiConverted = 1000000000 * strtoul ( (LPCTSTR)osString.Mid(2), ppcEndChar, 10 ) ;
				break ;

			default: // no format tag means decimal
				uiConverted = strtoul ( (LPCTSTR)osString, ppcEndChar, 10 ) ;
		}
	}
	else // start with something else than '0', so it's decimal
		uiConverted = strtoul ( (LPCTSTR)osString, ppcEndChar, 10 ) ;

	return uiConverted ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
double A_to_fD( CString osString ) 
{
    double fdConverted ;

    //\\//

    fdConverted = atof ( (LPCSTR) osString ) ;

    return fdConverted ;
}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
bool A_to_L( CString osString ) 
{
    bool lConverted ;

    //\\//

    if ( A_to_uI ( osString ) == 0 ) 
        lConverted = false ;
    else
        lConverted = true ;

    return lConverted ;
}


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ETT_Chan_Type        A_to_TTChanType ( CString osString ) 
{
    ETT_Chan_Type        eConverted ;

    //\\//

    if ( osString == "TT_EM" ) 
        eConverted = eTT_EM ;

    else if ( osString == "TT_HD" ) 
        eConverted = eTT_HD ;

    else // illegal value 
        eConverted = (ETT_Chan_Type) -1 ; 

    return eConverted ;
}


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
ETT_Eta_Sign        A_to_TTEtaSign ( CString osString ) 
{
    ETT_Eta_Sign        eConverted ;

    //\\//

    if ( osString == "+" ) 
        eConverted = eTT_Eta_Pos ;

    else if ( osString == "-" ) 
        eConverted = eTT_Eta_Neg ;

    else // illegal value 
        eConverted = (ETT_Eta_Sign) -1 ; 

    return eConverted ;
}


/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
// converts Floating Point Number _flNumber to a string representing its decimal value
// with _iDecDigits digits after decimal point
// and pad the left of the resutling string with leading spaces 
// to produce a CString with a minimum length of _iMinChar characters.

CString F_to_A( double      _flNumber, 
                const int   _iDecDigits,
                const int   _iMinChar )
{
    char    sBuf[80],  *psBuf = sBuf;
    char    sFormat[10], *psFormat = sFormat ;

    // first prepare the format string with the requested precision and width
    sprintf ( psFormat, "%s%d%s%d%s", "%#", _iMinChar, ".", _iDecDigits, "f" ) ;

    // now do the formatting
    sprintf ( psBuf, psFormat, _flNumber ) ;

    // return the buffer that will be converted to a CString
	return sBuf ;
}



/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CString AsciiTime () 
{

    struct tm *newtime;
    time_t aclock;

    //\\//

    time( &aclock );                 /* Get time in seconds */

    newtime = localtime( &aclock );  /* Convert time to struct */
                                     /* tm form */
    return asctime( newtime ) ;

}

/*-------------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------------*/
CString TimeStamp ( time_t*     _piTime ) 
{
#ifdef WIN32
    time_t          iTime ;
    tm*             pxTime ;
    _timeb          xTimeB ;

    char    sTimeString[KiTimeStampLength+1] = "dd-mmm-yyyy hh:mm:ss.mmm" ;

    //\\//

    //grab current time (or use given time) ...
    if ( _piTime == NULL )
        time ( &iTime ) ;
    else
        iTime = *_piTime ;
 
    pxTime = localtime ( &iTime ) ;
    _ftime ( &xTimeB ) ;

    //overwrite thestring with the date and time in the following format
    //(this shows the array index number, i.e. the column number minus one)
    // 0         1         2   
    // 012345678901234567890123
    // dd-mmm-yyyy hh:mm:ss.mmm
    strftime ( &sTimeString[0], 21, "%d-%b-%Y %H:%M:%S.", pxTime );
    sprintf  ( &sTimeString[21], "%.3d", xTimeB.millitm ) ;
    sTimeString[KiTimeStampLength] = 0 ;

    //return a pointer to this static string
    return sTimeString ;

#else

    time_t          iTime ;
    tm*             pxTime ;

    char    sTimeString[KiTimeStampLength+1] = "dd-mmm-yyyy hh:mm:ss" ;

    //\\//

    //grab current time (or use given time) ...
    if ( _piTime == NULL )
        time ( &iTime ) ;
    else
        iTime = *_piTime ;
    //...and fill a time structure
    pxTime = localtime ( &iTime ) ;

    //overwrite thestring with the date and time in the following format
    //(this shows the array index number, i.e. the column number minus one)
    // 0         1            
    // 01234567890123456789
    // dd-mmm-yyyy hh:mm:ss
    strftime ( &sTimeString[0], 21, "%d-%b-%Y %H:%M:%S.", pxTime );
    sTimeString[KiTimeStampLength ] = 0 ;

    //return a pointer to this static string
    return std::string ( sTimeString ) ;

#endif

}

/*------------------------------------------------------------------*/
CString DateTag ( time_t*     _piTime )   
{

    time_t          iTime ;
    tm*             pxTime ;

    //\\//

    //grab current time (or use given time) ...
    if ( _piTime == NULL )
        time ( &iTime ) ;
    else
        iTime = *_piTime ;

    pxTime = localtime ( &iTime ) ;

    return  I_to_A ( pxTime->tm_year+1900,  4, 10, '0' ) 
          + I_to_A ( pxTime->tm_mon+1,      2, 10, '0' ) 
          + I_to_A ( pxTime->tm_mday,       2, 10, '0' ) ;
}
/*------------------------------------------------------------------*/

/*------------------------------------------------------------------*/
CString TimeTag ( time_t*     _piTime )  
{

#ifdef WIN32
    time_t          iTime ;
    tm*             pxTime ;

    char    sTimeString[KiTimeTagLength+1] = "hhmmss" ;

    //\\//

    //grab current time (or use given time) ...
    if ( _piTime == NULL )
        time ( &iTime ) ;
    else
        iTime = *_piTime ;
 
    pxTime = localtime ( &iTime ) ;

    //overwrite thestring with the date and time in the following format
    //(this shows the array index number, i.e. the column number minus one)
    // 0     
    // 012345
    // hhmmss
    strftime ( &sTimeString[0], 7, "%H%M%S", pxTime );
    sTimeString[KiTimeTagLength] = 0 ;

    //return a pointer to this static string
    return sTimeString ;

#else
    // not implemented
#endif
}
/*------------------------------------------------------------------*/


/*------------------------------------------------------------------*/
// Create an ASCII String with a poorman dump of an histogram:
// e.g. "Avr= 4.40 Dev= 2.01 ( 3@2 1@3 1@4 1@5 3@6 1@8 )"


CString     DumpHistogram     ( unsigned short* const   _kpauwHistogram,
                                const unsigned long     _kulHistoSize, 
                                double* const           _kpfAverage,
                                double* const           _kpfDeviation ) 
{
    CString         osHistogram ;
    unsigned long   ulBin ;
    
    //\\//

    osHistogram = "" ;

    if ( _kpfAverage != NULL )
    osHistogram += "Avr=" 
                + F_to_A ( *_kpfAverage, 2, 6 ) 
                + " " ;

    if ( _kpfDeviation != NULL )
    osHistogram += "Dev=" 
                + F_to_A ( *_kpfDeviation, 2, 5 )
                + " " ;

    osHistogram += "(" ;
    for ( ulBin = 0 ; ulBin < _kulHistoSize ; ulBin ++ ) 
    if ( _kpauwHistogram[ulBin] != 0 )
    osHistogram += " " + I_to_A( _kpauwHistogram[ulBin] )
                + "@"  + I_to_A( ulBin ) ;

    osHistogram += " )" ;

    return osHistogram ;
}
/*------------------------------------------------------------------*/


/*------------------------------------------------------------------*/
// Create an ASCII String with a poorman dump of peaks :
// e.g. " 56@45( 8 8 23 56 45 13 9 9 ) 76@456( 8 8 23 76 57 45 13 9 9 )"

CString     DumpPeaks         ( unsigned short* const   _kpauwArray,
                                const unsigned short    _kuwArraySize, 
                                const unsigned short    _kuwThreshold, 
                                unsigned short* const   _kpuwMaxValue ) 
{
    CString         osDump = "" ;

    const long      kiWingSize = 4 ;

    unsigned long   ulCurrentValue ;

    unsigned long   ulTotPeak = 0 ;
    unsigned long   ulMaxValue = 0 ;
    unsigned long   ulDumpNextSamples = 0 ;

    //\\//

    for ( int iSampleNum = 0 ; iSampleNum < _kuwArraySize ; iSampleNum  ++ )
    {
        ulCurrentValue = _kpauwArray[iSampleNum] ;

        // look for a new peak
        if ( ( iSampleNum > kiWingSize  )   // but do not start a new peak at the extremities
          && ( iSampleNum < _kuwArraySize - kiWingSize ) )
        {
            if ( ulCurrentValue >= _kuwThreshold )
            {
                // Start a new peak if we are not already in one
                if ( ulDumpNextSamples == 0 ) 
                {
                    ulTotPeak ++ ;
                    osDump = osDump + I_to_A( ulCurrentValue) + "@" + I_to_A( iSampleNum ) + "( " ;
                    // insert the pre-wing
                    for ( int iWingSample = 0 ; iWingSample < kiWingSize ; iWingSample ++ ) 
                        osDump = osDump + I_to_A ( _kpauwArray[iSampleNum-kiWingSize+iWingSample] ) + " " ;
                }

                // start (or extend) the wing
                ulDumpNextSamples = 1 + kiWingSize ; // this one plus the post-wing

                //keep track of observed maximum
                if ( ulCurrentValue > ulMaxValue ) ulMaxValue = ulCurrentValue ;
            }

        }

        // print peak and wing sample
        if ( ulDumpNextSamples > 0 ) 
        {
            osDump = osDump + I_to_A ( ulCurrentValue ) + " " ;
            ulDumpNextSamples -- ;
            // close current peak after last wing sample
            if ( ulDumpNextSamples == 0 ) osDump = osDump + ") " ;
        }
    }

    //maybe there was no peak above threshold
    if ( osDump == "" ) osDump = "No Value found above " + I_to_A ( _kuwThreshold ) ;

    // see if we need to return the maximum value
    if ( _kpuwMaxValue != NULL ) *_kpuwMaxValue = ulMaxValue ;
    
    return osDump ;
}
/*------------------------------------------------------------------*/


/*------------------------------------------------------------------*/
/*------------------------------------------------------------------*/
// implement some of the MSVC string utilities, not in ANSI C


    // Force characters to uppercase, same as _strupr in windows
    char* strupr( char* _string )
    {
       for( char* p = _string; p < _string + strlen ( _string ); p++ )
       if ( ( *p >= 'a' )  && ( *p <= 'z' ) )
           *p = *p - ( 'a' - 'A' ) ; 
       return _string ;
    }

    // Force characters to lowercase, same as _strlwr in windows
    char* strlwr( char* _string )
    {
       for( char* p = _string; p < _string + strlen ( _string ); p++ )
       if ( ( *p >= 'A' )  && ( *p <= 'Z' ) )
           *p = *p + ( 'a' - 'A' ) ; 
       return _string ;
    }

#if !defined WIN32 

    // case-independent strings compare 

    int stricmp( const char *string1, const char *string2 )
    {
        CString string1_lower = string1 ; string1_lower.MakeLower() ;
        CString string2_lower = string2 ; string2_lower.MakeLower() ;
        return string1_lower.compare( string2_lower ) ; 
    }

#endif

