//
// gab.h  driver for GAB card and shared TAB/GAB functionality
//

#ifndef GAB_H
#define GAB_H 1

#include "gab_defs.h"
#include "tab.h"

//
// GAB lvds chips:
//

//
// For now use the SWA set parameters functions:
//int swa_set_delay_par       (unsigned long module, unsigned long chip, 
//    			       unsigned long delay,  unsigned long value);
//int swa_set_pars_from_file  (unsigned long module, const char * filename);

// read lvds diagnostic algorithm memory:
int lvds_recv_mem_read        (unsigned long chip, int mem,
			       unsigned long event, unsigned long addr, unsigned long *value);

// write the lvds test input memory:
int lvds_test_mem_clear       ();

int lvds_test_mem_load        (unsigned long chip, int mem,
			       unsigned long event, unsigned long addr, unsigned long value);

//
// GAB S30 chip:
//
int s30_recv_mem_read  (unsigned long addr, unsigned long *value);
int s30_trig_mem_read  (unsigned long addr, unsigned long *value);
int s30_l2_mem_read    (unsigned long addr, unsigned long *value);

int s30_load_parameter         (unsigned long addr, unsigned long value);
//set only bits of parameter corresponding to thresh <num>:
int s30_load_parameter_thresh (unsigned long addr, int num, unsigned long value);
//this will be obsolete soon:
int s30_load_shared_parameter  (unsigned long addr, int num, unsigned long value);
int s30_read_parameter         (unsigned long addr, unsigned long * value);
int s30_print_alg_parameters   ();

int s30_setup_level2_header_firmware_version(int major, int minor);
int s30_setup_level2_header();

#endif
