#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include "tabgab/util.h"
#include "tabgab/vme.h"
#include "tabgab/vmescl.h"
#include "tabgab/tab.h"
#include "tabgab/gab.h"

int lvds_recv_mem_read        (unsigned long chip, int mem,
			       unsigned long event, unsigned long addr, unsigned long *value){
    unsigned long group;
    if (mem == 0){
	group = LVDS_GROUP_RECV_DATA_0;
    } else if (mem == 1) {
	group = LVDS_GROUP_RECV_DATA_1;
    } else {
	error("ERROR: lvds_recv_mem_read...\n");
	return -1;
    }    
    unsigned event_addr = (event << 6) | addr;    
    return vmescl_read_serial(MOD_GAB, chip, group, event_addr, 0, value);    
}

int lvds_test_mem_clear(){
    for(int chip=1; chip<=4; chip++){
	for (int mem=0; mem<2; mem++){
	    for (int event=0; event<32; event++){
		for (unsigned long addr=0; addr<LVDS_DATA_MAX_ADDR; addr++)
		{
		    TRY(lvds_test_mem_load(chip, mem, event, addr, 0));		
		}
	    }	
	}
    }
    return EXIT_SUCCESS;
}

int lvds_test_mem_load(unsigned long chip, int mem,
		       unsigned long event, unsigned long addr, unsigned long value){
    unsigned long group;
    if (mem == 0){
	group = LVDS_GROUP_TEST_DATA_0;
    } else if (mem == 1) {
	group = LVDS_GROUP_TEST_DATA_1;
    } else {
        error("ERROR: lvds_recv_mem_read...\n");
	return -1;
    }    
    unsigned event_addr = (event << 8) | addr;    
    return vmescl_write_serial(MOD_GAB, chip, group, event_addr, value);    
}
