//
// tab_defs.h:  defines for the TAB and GAB cards
// 

//how many of each type of chip are there?
#define TAB_NUM_SWA_CHIPS  10

#define GLOBAL_SUM_THRESHOLD 0

//
// TAB chips: 
//

#define TAB_CHIP_STRATIX0 0
#define TAB_CHIP_STRATIX1 1
#define TAB_CHIP_STRATIX2 2
#define TAB_CHIP_STRATIX3 3
#define TAB_CHIP_STRATIX4 4
#define TAB_CHIP_STRATIX5 5
#define TAB_CHIP_STRATIX6 6
#define TAB_CHIP_STRATIX7 7
#define TAB_CHIP_STRATIX8 8
#define TAB_CHIP_STRATIX9 9
#define TAB_CHIP_GLOBAL   10
#define TAB_CHIP_CYCLONE  15

//
// cyclone chip addresses:
//
//groups:
#define CYCLONE_GROUP_STATUS    0
#define CYCLONE_GROUP_CONF_DATA 1
//serial addresses for status register:
#define CYCLONE_GROUP_STATUS_SERADR_READ   0
#define CYCLONE_GROUP_STATUS_SERADR_WRITE  1
//serial addresses for conf data  
#define CYCLONE_GROUP_CONF_DATA_SERADR_CONF8_A   0
#define CYCLONE_GROUP_CONF_DATA_SERADR_CONF8_B   1
#define CYCLONE_GROUP_CONF_DATA_SERADR_CONF16_A  2
#define CYCLONE_GROUP_CONF_DATA_SERADR_CONF16_B  3
//cylcone status register bit mask
#define CYCLONE_STATUS_MASK_CONF_MUX_A  0x0001
#define CYCLONE_STATUS_MASK_NCONFIG_A   0x0002
#define CYCLONE_STATUS_MASK_NSTATUS_A   0x0004
#define CYCLONE_STATUS_MASK_CONF_DONE_A 0x0008
#define CYCLONE_STATUS_MASK_CONF_MUX_B  0x0010
#define CYCLONE_STATUS_MASK_NCONFIG_B   0x0020
#define CYCLONE_STATUS_MASK_NSTATUS_B   0x0040
#define CYCLONE_STATUS_MASK_CONF_DONE_B 0x0080
#define CYCLONE_STATUS_MASK_SEROUT_EN_A 0x0400
#define CYCLONE_STATUS_MASK_SEROUT_EN_B 0x0800
#define CYCLONE_STATUS_MASK_MRST_A      0x1000
#define CYCLONE_STATUS_MASK_MRST_B      0x2000
#define CYCLONE_STATUS_MASK_PWR_A       0x4000
#define CYCLONE_STATUS_MASK_PWR_B       0x8000


//
//sliding windows algorithm addresses
//

//groups:
#define SWA_GROUP_LOAD_TEST_MEM    0
#define SWA_GROUP_LOAD_EM_PAR      1
#define SWA_GROUP_LOAD_JET_PAR     2
#define SWA_GROUP_STATUS           3
#define SWA_GROUP_READ_ALG_MEM     4
#define SWA_GROUP_RESET_PLL        5
#define SWA_GROUP_DELAY            6
#define SWA_GROUP_READ_RAW_MEM     7
#define SWA_GROUP_PARITY_COUNT     8
#define SWA_GROUP_LOAD_LFSR_SEED1  9
#define SWA_GROUP_LOAD_LFSR_SEED2 10
#define SWA_GROUP_LOAD_LFSR_SEED3 11
#define SWA_GROUP_ENABLE_LFSR1    12
#define SWA_GROUP_ENABLE_LFSR2    13
#define SWA_GROUP_ENABLE_LFSR3    14
//serial addresses for status register:
#define SWA_GROUP_STATUS_SERADR_READ  0
#define SWA_GROUP_STATUS_SERADR_WRITE 1
//serial addresses for parity error count:
#define SWA_GROUP_PARITY_COUNT_SERADR_CBL0 0
#define SWA_GROUP_PARITY_COUNT_SERADR_CBL1 1
#define SWA_GROUP_PARITY_COUNT_SERADR_CBL2 2
//serial addresses for swa parameters:
#define SWA_GROUP_DELAY_SERADR_SCL 0
#define SWA_GROUP_DELAY_SERADR_RAW 1
//the delay parameters group has been extened to include:
// an enable bit mask:
#define SWA_GROUP_DELAY_SERADR_ENABLE 2
// a minimum energy for sum et:
#define SWA_GROUP_DELAY_SERADR_MIN_ET 3
// waiting for this to be explained to me:
#define SWA_GROUP_DELAY_SERADR_ETA_38 4
// thresholds for the "noise" trigger (TT count):
#define SWA_GROUP_DELAY_SERADR_NOISE1 5
#define SWA_GROUP_DELAY_SERADR_NOISE2 6
#define SWA_GROUP_DELAY_SERADR_NOISE3 7

#define SWA_GROUP_LOAD_EM_PAR_SERADR_EM_ISO  7
//bit mask for TAB swa status writes
#define SWA_STATUS_MODE_TEST_MEMORY    0x8000
#define SWA_STATUS_MODE_ADF            0x0000
//bit mask for TAB swa status reads
#define SWA_STATUS_PERR0           0x0001
#define SWA_STATUS_PERR1           0x0002
#define SWA_STATUS_PERR2           0x0004
#define SWA_STATUS_SYNCERR0        0x0008
#define SWA_STATUS_SYNCERR1        0x0010
#define SWA_STATUS_SYNCERR2        0x0020
#define SWA_STATUS_BCERR0          0x0040
#define SWA_STATUS_BCERR1          0x0080
#define SWA_STATUS_BCERR2          0x0100
#define SWA_STATUS_PLL_LOCK_ERR    0x0200
#define SWA_STATUS_MODE_FF         0x0400
#define SWA_STATUS_LFSR1           0x0800
#define SWA_STATUS_LFSR2           0x1000
#define SWA_STATUS_LFSR3           0x2000
#define SWA_STATUS_EXPERT1         0x4000
#define SWA_STATUS_EXPERT2         0x8000
//
//global chip addresses
//
#define GLOBAL_GROUP_RESET_PLL        0
#define GLOBAL_GROUP_READ_RAW_MEM     1
#define GLOBAL_GROUP_READ_TRACK_MEM   2
#define GLOBAL_GROUP_READ_ALG_MEM     3
#define GLOBAL_GROUP_WRITE_RAW_PAR    4
#define GLOBAL_GROUP_WRITE_E_PAR      5
#define GLOBAL_GROUP_WRITE_SCL_DELAY  6
#define GLOBAL_GROUP_WRITE_TEST       7
#define GLOBAL_GROUP_WRITE_TESTRAW    8
#define GLOBAL_GROUP_READ_STATUS      9
//serial addresses for global chip energy parameters:
#define GLOBAL_GROUP_E_PAR_SERADR_E_THR     0
#define GLOBAL_GROUP_E_PAR_SERADR_SIN2      1
#define GLOBAL_GROUP_E_PAR_SERADR_COS2      2
#define GLOBAL_GROUP_E_PAR_SERADR_SIN3      3
#define GLOBAL_GROUP_E_PAR_SERADR_COS3      4
#define GLOBAL_GROUP_E_PAR_SERADR_SIN4      5
#define GLOBAL_GROUP_E_PAR_SERADR_COS4      6
#define GLOBAL_GROUP_E_PAR_SERADR_SIN5      7
#define GLOBAL_GROUP_E_PAR_SERADR_COS5      8
//serial addresses for raw parameters:
//... seradr 0-6 don't have a clear define name
#define GLOBAL_GROUP_RAW_PAR_SERADR_RAW_DEL 7
//bit mask for global status register:
#define GLOBAL_STATUS_MODE         0x0001
#define GLOBAL_STATUS_CP90_LOCK    0x0002
#define GLOBAL_STATUS_CP53_LOCK    0x0004
#define GLOBAL_STATUS_RUN          0x0008

//
//Test memories:
//
#define TAB_TEST_MEM_MAX_EVENTS 32

//
//These could use some cleaning up eventually...
//
#define SWA_MAX_THRESHOLD_JET 6
#define SWA_MIN_THRESHOLD 0
#define SWA_MAX_THRESHOLD_EM_ISO 7
#define SWA_MIN_TOWER 0
#define SWA_MAX_TOWER 35
#define TAB_MAX_EVENT 31
#define TAB_MIN_EVENT 0
#define SWA_MASK_ENERGY 0x0000
#define SWA_MASK_CONTROL 0x8000
#define TAB_EVENT_NUM 32
#define NUM_GLOB_GAB_EVENTS  TAB_EVENT_NUM
#define NUM_GLOB_GAB_CHANNEL 48
#define NUM_GLOB_TRACK_EVENTS TAB_EVENT_NUM
#define NUM_GLOB_TRACK_LINES_PER_EVENT 7
/* the number of bits the channel is stored in */
#define NUM_GLOB_GAB_CHBITS   6
