//
// tabgab_util.h:  low-level utilities, e.g. the TAB/GAB environment, utility macros.
//

#ifndef __env_h__
#define __env_h__

#include "util.h"

//TAB/GAB environment variables:

extern char * tabgab_package_version;
extern char * tabgab_firmware_dir;
extern char * tabgab_config_dir;
extern char * tabgab_work_dir;

//Has the TAB/GAB environment been setup properly?
int tabgab_check_environment();

#define CHECK_TABGAB_ENV \
        do { if (tabgab_check_environment()) return eBadEnv;} while(0)

//
// C-style try macros, based on util.h error message parsing...
//

#define TRY_IO(call) \
do { int retval; retval=(call); if (retval) { SET_TRY_TYPE("IO"); errorf(TRY_MSG); return eIoError;}} while(0)

#define TRY_PAR(call) \
do { int retval; retval=(call); if (retval) { SET_TRY_TYPE("PAR"); errorf(TRY_MSG); return eBadParam;}} while(0)

#define TRY_ENV(call) \
do { int retval; retval=(call); if (retval) { SET_TRY_TYPE("ENV"); errorf(TRY_MSG); return eBadEnv;}} while(0)

#endif
