/*-------------------------------------------------------------------------------*/
  /*
    tcc_to_tabgab_monit.cpp

  */
/*-------------------------------------------------------------------------------*/

#include "tabgab/tcc_to_tabgab.h"
#include "tabgab/tcc_to_tabgab_monit.h"
#include "tabgab/tab.h"
#include "tabgab/tabgab_util.h"
#include "tabgab/util.h"

/* ------------------------------------------------------------------------ */
/* ------------------------------------------------------------------------ */

/* -----------------------------------------*/
/* I.   TAB Algorithm Chip Status           */
/* -----------------------------------------*/

EStatus Tab_Monit_AlgoStatus      ( unsigned long    Tab_Module,
				    unsigned long    Tab_Chip,
				    unsigned short*  pMonit_Status )
{
    SET_TRY_CONTEXT("Tab_Monit_AlgoStatus");    
    CHECK_TABGAB_ENV;
    SET_TRY_MSG(TRY_MSG, "failure reading TAB SWA status.");
    
    unsigned long status;
    TRY_IO ( stratix_status_read(Tab_Module, Tab_Chip, &status));
    *pMonit_Status = (unsigned short) (status & 0xFFFF);
    return eOk ;
} ;

/* -----------------------------------------*/
/* II.   TAB Global Chip Status             */
/* -----------------------------------------*/

EStatus Tab_Monit_GlobalStatus    ( unsigned long    Tab_Module,
				    unsigned short*  pMonit_Status ) 
{
    SET_TRY_CONTEXT("Tab_Monit_GlobalStatus");    
    CHECK_TABGAB_ENV;
    SET_TRY_MSG(TRY_MSG, "failure reading TAB global status.");
    
    unsigned long status;
    TRY_IO ( stratix_status_read(Tab_Module, 10, &status));
    *pMonit_Status = (unsigned short) (status & 0xFFFF);        
    return eOk ;
} ;

/* -----------------------------------------*/
/* III.   GAB Reveiver Chip Status          */
/* -----------------------------------------*/

EStatus Gab_Monit_ReceiverStatus  ( unsigned long    Gab_Chip,
				    unsigned short*  pMonit_Status ) 
{
    SET_TRY_CONTEXT("Gab_Monit_ReceiverStatus");    
    CHECK_TABGAB_ENV;
    SET_TRY_MSG(TRY_MSG, "failure reading GAB LVDS status.");
       
    unsigned long status;
    TRY_IO ( stratix_status_read(8, Gab_Chip, &status));
    *pMonit_Status = (unsigned short) (status & 0xFFFF);        
    return eOk ;
} ;

/* -----------------------------------------*/
/* IV.   GAB Global Chip Status             */
/* -----------------------------------------*/

EStatus Gab_Monit_GlobalStatus    ( unsigned short*  pMonit_Status ) 
{
    SET_TRY_CONTEXT("Gab_Monit_GlobalStatus");    
    CHECK_TABGAB_ENV;
    SET_TRY_MSG(TRY_MSG, "failure reading GAB S30 status.");
    
    unsigned long status;
    TRY_IO ( stratix_status_read(8, 4, &status));
    *pMonit_Status = (unsigned short) (status & 0xFFFF);        
    return eOk ;
} ;


